<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if (!$CpId) $nsProduct->Redir("default");
if ($nsProduct->LICENSE==4) $nsProduct->Redir("default", "", "admin"); 

/////////////////////////////////////////////
///////// require libraries here

require_once SYS."/system/lib/validate.func.php";
require_once SYS."/system/lib/sql.func.php";
require_once SYS."/system/lib/sort.func.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/lib/delete.func.php";
require_once SELF."/lib/reports/hidden_reports.func.php";

$nsLang->TplInc("inc/report_headers");
$nsLang->TplInc("inc/menu");
$nsLang->TplInc("inc/cache");

$ProgPath[0]['Name']=$Lang['MCampaign'];
$ProgPath[0]['Url']=getURL("campaign", "CpId=$CpId", "admin");

/////////////////////////////////////////////
///////// prepare any variables

$PageTitle=$Lang['Title'];
extract(VPack(array('EditId','EditArr','DeleteId','ParentId','ax','amode')));
UserColumns(); // ,     
    
/////////////////////////////////////////////
///////// ajax block

if ($ax && $amode=='grp') require SELF.'/lib/ajax/campaign/short_grp_stat.inc.php';
if ($ax && $amode=='camp') require SELF.'/lib/ajax/campaign/short_camp_stat.inc.php';

/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {
	if ($EditId && $EditArr) UpdateCampaign($EditId, $EditArr);
	if ($DeleteId) DeleteCampaign($CpId, $DeleteId);
}

/////////////////////////////////////////////
///////// display section here

if (!$EditId) {

    if (!$ParentId) {
	$SubMenu[0]['Name']=$Lang['AddGroup'];
	$SubMenu[0]['Link']=getURL("campaign", "EditId=new");
    } else {
    $SubMenu[0]['Name']=$Lang['BackToList'];
    $SubMenu[0]['Link']=getURL("campaign");
    }
	$SubMenu[1]['Name']=$Lang['AddCampNoGrp'];
	$SubMenu[1]['Link']=getURL("sub_camp", "EditId=new");

    $CampArr=array();
    if (!$ParentId) {
    $Query = "SELECT * FROM ?_campaign WHERE COMPANY_ID=? ORDER BY NAME ASC";
    $Sql = new Query($Query,false, $CpId);
    while ($Row = $Sql->Row()) $CampArr[]=$Row;
    }

	$InCampArr=array();
	$Query = "
		SELECT CP.* 
		FROM ?_camp_piece CP
			INNER JOIN ?_sub_campaign SC
			ON SC.SUB_ID=CP.ID
		WHERE CP.CAMPAIGN_ID=? AND CP.COMPANY_ID=?
        ORDER BY CP.NAME
	";
	$Sql= new Query($Query,false,$ParentId,$CompId);
	while($Row=$Sql->Row()) {
		$Row->_EDITLINK=getURL("sub_camp", "EditId=".$Row->ID);
		$Row->_CODELINK=getURL("campaign_link", "CampId=".$Row->ID);
        $Row->_SALELINK=getURL("sale", "CampId=".$Row->ID, "admin");
		$Row->_DELETELINK=getURL("sub_camp", "GrpId=0&DeleteId=".$Row->ID);
		$Row->SUB_CAMP=$Row->ID;
		$InCampArr[]=$Row;
	}

    include $nsTemplate->Inc("inc/header");
    include $nsTemplate->Inc("inc/submenu");
    include $nsTemplate->Inc("admin.campaign");
	if (empty($CampArr)&&empty($InCampArr)) include $nsTemplate->Inc("inc/no_records");
	include $nsTemplate->Inc("inc/footer");
    exit;
}

//// edit campaign
if ($EditId) {

    $SubMenu[0]['Name']=$Lang['BackToList'];
    $SubMenu[0]['Link']=getURL("campaign");    
    
    if ($EditId != 'new') {
        $Query = "
            SELECT C.*, W.ID AS WATCH
            FROM ?_campaign C
                LEFT JOIN ?_watch W
                    ON W.GRP_ID=C.ID AND W.USER_ID=? 
            WHERE C.ID = ? AND C.COMPANY_ID = ?";
        $EditCamp = $Db->Select($Query,false,$nsUser->UserId(),$EditId,$CpId);
        if (!$EditCamp) $nsProduct->Redir('campaign', "CpId=$CpId");
        $TableCaption= $Lang['CaptionEdit'].stripslashes($EditCamp->NAME);
        
        $SubMenu[1]['Name']=$Lang['Stat'];
        $SubMenu[1]['Link']=getURL("paid_constructor", "GrpId=".$EditCamp->ID, "report");
    }
    else 	$TableCaption = $Lang['CaptionNew'];

	$EditArr['Name']=V($EditArr['Name'],V($EditCamp->NAME));
	$EditArr['Descr']=V($EditArr['Descr'],V($EditCamp->DESCRIPTION));
	$EditArr['Company']=V($EditArr['Company'],V($EditCamp->COMPANY_ID));
	$EditArr['Watch']=V($EditArr['Watch'],V($EditCamp->WATCH));

	include $nsTemplate->Inc("admin.campaign_edit");
}


/////////////////////////////////////////////
///////// process functions here

function UpdateCampaign($Id,$Arr)
{
	global $Db, $Lang, $nsProduct, $Logs, $CpId, $nsUser;

	extract($Arr);
	if (!V($Name)) $ErrArr['Name']=$Lang['MustFill'];
    $Descr = V($Descr);
    $Watch = V($Watch);

	if (isset($ErrArr)) {$Logs->Err($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}

    if ($Id == 'new') {
    	$Query = "INSERT INTO ?_campaign (NAME, DESCRIPTION, COMPANY_ID) VALUES (?,?,?)";
    	$Db->Query($Query, $Name, $Descr, $CpId);
        $Id=$Db->LastInsertId;

        $Cache = new nsQueryCache($CpId);
        $Cache->Mode="PAID";
        $Cache->UpdateInterval=360;
        $Cache->QueryParams=CampQueryParams($Id);
        $Cache->CreateCacheRecord(1);
        $Cache->SetCacheType(2);

        $nsProduct->Redir("campaign", "RCrt=1");
    }
    else {
        $Query = "
            SELECT C.*, W.ID AS WATCH
            FROM ?_campaign C
                LEFT JOIN ?_watch W
                    ON W.GRP_ID=C.ID AND W.USER_ID=? 
            WHERE C.ID = ? AND C.COMPANY_ID = ?";
        $EditCamp = $Db->Select($Query,false,$nsUser->UserId(),$Id,$CpId);        
        $Query = "UPDATE ?_campaign SET NAME = ?, DESCRIPTION = ? WHERE ID = ?";
    	$Db->Query($Query, $Name, $Descr, $Id);
    	if ($Watch && !$EditCamp->WATCH) SetGrpWatch($Id, $nsUser->UserId());
    	if (!$Watch) RemoveGrpWatch($Id, $nsUser->UserId());

        $nsProduct->Redir("campaign", "RUpd=1");
    }
}


function SetGrpWatch($GrpId, $UserId)
{
	global $Db;
	$Query = "INSERT INTO ?_watch (GRP_ID, USER_ID) VALUES (?, ?)";
	$Db->Query($Query, $GrpId, $UserId);
}

function RemoveGrpWatch($GrpId, $UserId)
{
	global $Db;
	$Query = "DELETE FROM ?_watch WHERE GRP_ID=? AND USER_ID=?";
	$Db->Query($Query, $GrpId, $UserId);
}


?>