<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

$nsLang->IncFile("inc/cache.php");

require_once SYS."/system/lib/validate.func.php";
require_once SYS."/system/lib/sql.func.php";
require_once SELF."/class/report_data.class.php";
require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/lib/reports/static_report.func.php";
CheckReportsInstalled();

$nsLang->TplInc("inc/report_headers");
$nsLang->TplInc("constructor/periods");

if (!ValidId($CurrentCompany->ID)) $nsProduct->Redir("default", "", "admin");
$PageTitle=$Lang['Title'];
$ProgPath[0]['Name']=$Lang['Home'];
$ProgPath[0]['Url']=$nsProduct->SelfAction("CpId=$CpId");

$Ajax = V($_REQUEST['ax']);
$Mode = V($_REQUEST['Mode']);
$Print = V($_REQUEST['_print']);

$SiteList = array();
$Query = "SELECT * FROM ?_site TS WHERE TS.COMPANY_ID=? ORDER BY TS.HOST ASC";
$Sql = new Query($Query, false, $CpId);
$DefaultSiteId = false;
while ($Row = $Sql->Row()) {
    if (!$DefaultSiteId) $DefaultSiteId=$Row->ID;
    $SiteList[$Row->ID]=$Row;
}
$CommonSiteList = $SiteList;

if (!$Ajax) {
    UserColumns();
    
    require_once SELF.'/lib/reports/reports_list.inc.php';
    $Query = "SELECT  COUNT(*) FROM ?_site TS WHERE TS.COMPANY_ID=? ORDER BY TS.HOST ASC";
    $SiteCnt = $Db->ReturnValue($Query,$CpId);
    
    $ClientWatch = array();
    $Query = "
        SELECT
        SC_1.ID AS CAMP_ID, SS_1.ID AS SPLIT_ID,
        CP_1.NAME AS CAMP_NAME, W.SUB_ID,
        W.GRP_ID, 
        C_2.NAME AS CAMPAIGN_NAME

        FROM ?_watch W

        LEFT JOIN ?_camp_piece CP_1 ON CP_1.ID=W.SUB_ID AND CP_1.COMPANY_ID=?cp
        LEFT JOIN ?_sub_campaign SC_1 ON SC_1.SUB_ID=CP_1.ID
        LEFT JOIN ?_split_test SS_1 ON SS_1.SUB_ID=CP_1.ID
        LEFT JOIN ?_campaign C_2 ON C_2.ID=W.GRP_ID AND C_2.COMPANY_ID=?cp

        WHERE W.USER_ID = ?uid AND (C_2.COMPANY_ID > 0 OR CP_1.COMPANY_ID>0)
    ";
    $Sql = new Query($Query, false, array('uid'=>$nsUser->UserId(),'cp'=>$CpId));
    while ($Row=$Sql->Row()) {
        if (!$Row->CAMP_ID && !$Row->SPLIT_ID && !$Row->GRP_ID) continue;
        if ($Row->CAMP_ID) {
            $k='camp';
            $Row->ID=$Row->SUB_ID;
            $Row->ICON = 'big_icon_paid';
            $Row->NAME = $Row->CAMP_NAME;
            if (!$nsUser->Columns->CLICKS && !$nsUser->Columns->ROI && !$nsUser->Columns->CONVERSIONS &&
                !$nsUser->Columns->SALES && !$nsUser->Columns->ACTIONS) continue;
        }
        if ($Row->SPLIT_ID) {
            $k='split';
            $Row->ID=$Row->SUB_ID;
            $Row->ICON = 'big_icon_split';
            $Row->NAME = $Row->CAMP_NAME;
            if (!$nsUser->Columns->CLICKS && !$nsUser->Columns->ROI && !$nsUser->Columns->CONVERSIONS &&
                !$nsUser->Columns->SALES && !$nsUser->Columns->ACTIONS) continue;
        }
        if ($Row->GRP_ID) {
            $k='grp';
            $Row->ID=$Row->GRP_ID;
            $Row->ICON = 'big_icon_paid';
            $Row->NAME = $Row->CAMPAIGN_NAME;
            if (!$nsUser->Columns->CLICKS && !$nsUser->Columns->ROI && !$nsUser->Columns->CONVERSIONS) 
                continue;            
        }
        $Row->Type=$k;
        $ClientWatch[]=$Row;
    }

    include $nsTemplate->Inc();
    exit;
}


$Today=UserDate();
$CampList=array();
$SplitList=array();
$GrpList=array();
$SiteList=array();
$ShowStats=true;

if (!$Mode) exit;
if (!in_array($Mode,array('sttoday','lastclick','lastref','lastsale','lastaction','graph','cities','pages','grp','camp','split', 'activity','companies'))) exit;

require_once SELF."/lib/ajax/client_page/$Mode.inc.php";


function GetRDataObj($Columns=true,$Mode="NATURAL")
{
    global $nsUser, $Lang;

    $RData = new ReportData($Mode);
    $RData->EnableSorting=false;
    $RData->ShowNextStep=false;
    $RData->ShowSimpleName=true;
    $RData->EnableSubValues=false;

    return $RData;
}


?>