<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==3&&!$nsUser->ADMIN) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE!=3&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");

extract(VPack(array('ViewId', 'EditId', 'NewKey', 'DeleteId', 'NewTrialKey')));

$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$Lang['Title'];
$ProgPath[1]['Url']=getURL("license", "", "admin");
$MenuSection="admin";

$ClientsCntNow=$Db->ReturnValue("SELECT COUNT(*) FROM ?_client");
$SitesCntNow=$Db->ReturnValue("SELECT COUNT(*) FROM ?_site");

$KeyVars['ID']=$Lang['LicenseID'];
$KeyVars['CL']=$Lang['LicenseClient'];
$KeyVars['D']=$Lang['LicenseDate'];
$KeyVars['L']=$Lang['LicenseL2'];
$KeyVars['TL']=$Lang['LicenseTL'];



/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {
    if ($NewTrialKey && $nsProduct->KEYS_NUM == 1) AddNewTrialKey($NewTrialKey);
	if ($NewKey) AddNewKey(trim($NewKey));
	if (ValidId($DeleteId)) DeleteKey($DeleteId);
}

/////////////////////////////////////////////
///////// display section here


if (!$nsProduct->LICENSE&&!$NewKey) $Logs->Err($Lang['KeyNeeded']);
$ClientsCnt=0;
$SitesCnt=$nsProduct->MAX_SITES;


if (!$EditId&&!$ViewId) {
	$LicenseArr=array();
	$Query = "SELECT *, UNIX_TIMESTAMP(STAMP) AS STAMP FROM ?_license ORDER BY STAMP DESC";
	$Sql = new Query($Query);
	while ($Row=$Sql->Row()) {
		$Row->AGENT=false;
		$Row->CLIENT=false;
        $Row->PERSONAL=false;
		$Row->DISABLED=false;
		$Row->ADD=false;
		$Row->WL=false;
		$Row->KEY_DECODE=$BF->decrypt($Row->LICENSE_KEY);
		$Row->License=GetLicenseText($Row->KEY_DECODE);
		if (!$Row->License) continue;
		$Row->License['D']=_date($Row->STAMP);
		//$SitesCnt+=$Row->License['L'];
		if ($Row->License['L']==0) unset($Row->License['L']);

		if (isset($Row->License['P'])&&$Row->License['P']==2) $Row->CLIENT=true;
		if (isset($Row->License['P'])&&$Row->License['P']==3) $Row->AGENT=true;
        if (isset($Row->License['P'])&&$Row->License['P']==4) $Row->PERSONAL=true;
		if (!isset($Row->License['P'])) $Row->ADD=true;

        if (substr($Row->License['ID'], 0, 5) == 'TRIAL' || @$Row->License['TRIAL']) $Row->License['ID']=$Lang['TrialID'];

		$LicenseArr[]=$Row;
	}

	for ($i=0;$i<Count($LicenseArr);$i++) {
		if (@$LicenseArr[$i]->License['WL']) {
			$LicenseArr[$i]->ADD=false;
			$LicenseArr[$i]->DISABLED=false;
			$LicenseArr[$i]->WL=true;
			unset($LicenseArr[$i]->License['L']);
		}
	}

	$SubMenu[0]['Name']=$Lang['AddNewKey'];
	$SubMenu[0]['Link']=getURL("license", "EditId=new", "admin");

	include $nsTemplate->Inc();
}

if ($EditId=="new") {
	$SubMenu[0]['Name']=$Lang['BackToList'];
	$SubMenu[0]['Link']=getURL("license", "", "admin");
	include $nsTemplate->Inc("admin.new_license");
}



/////////////////////////////////////////////
///////// process functions here

function AddNewTrialKey($Key) {
    global $Db;
    $Query = "DELETE FROM ?_license";
    $Db->Query($Query);
    AddNewKey($Key);
}

function AddNewKey($Key) {
	global $Db, $nsProduct, $BF, $Logs, $Lang;
	$Key=str_replace("\n", "", $Key);

	$KEY_DECODE=$BF->decrypt($Key);
	$License=GetLicenseText($KEY_DECODE);
	if (!$License) return $Logs->Err($Lang['KeyHasNoInfo']);
	if ( !$nsProduct->LICENSE && !isset($License['P'])) return $Logs->Err($Lang['SecondaryKeyErr']);
	$KeyId=intval(@$License['ID']);
	if (!$KeyId) return $Logs->Err($Lang['KeyIsInvalid']);

	$Query = "SELECT ID FROM ?_license WHERE KEY_ID=? OR LICENSE_KEY=? AND KEY_ID != '1' ";
	if ($Db->ReturnValue($Query, $KeyId, $Key)) return $Logs->Err($Lang['KeyExists']);

	if (isset($License['REQ']) && !CheckRequirements($License['REQ'])) return $Logs->Err($Lang['RequiredNotFound']);

    if (@$License['P']) $Db->Query('DELETE FROM ?_license WHERE KEY_ID=1');

	$Query = "INSERT INTO ?_license (LICENSE_KEY, STAMP, KEY_ID) VALUES (?, NOW(), ?)";
	$Db->Query($Query, $Key, $KeyId);
	$nsProduct->Redir("license", "RCrt=1", "admin");
}

//     
//    , REQ=P/>&equal;/2
//   ,        ,  2
//   ,  
//          
//    - REQ=ID/102 (     102) 
function CheckRequirements($Req=false)
{
	if (!$Req) return false;
	
	$FullArr=GetFullLicenseArr();
	$ReqArr=explode(";", $Req); //      P/2;WL;L/10
	$Return = false;
	for ($i=0;$i<count($ReqArr);$i++) {
		if ($Return) return false;
		if (!$ReqArr[$i]) continue;
		$Func=false;
		$ReqValue=explode("/",$ReqArr[$i]); //  P/<=/2  P/2  
		if (!isset($FullArr[$ReqValue[0]])) return false;  //   P     ,   false
		if (count($ReqValue)==2) { //     ,   equal
			for ($j=0; $j<count($FullArr[$ReqValue[0]]); $j++) {
				if (trim($FullArr[$ReqValue[0]][$j])==$ReqValue[1]) {	$Return = false; break;}
				$Return = true;
			}
		}
		if (count($ReqValue)==3) { //    
			$ReqValue[1]=str_replace("&equal;", "=", $ReqValue[1]);
			if (substr($ReqValue[1], 0, 3)=="sum") $Func="sum";
			if (substr($ReqValue[1], 0, 3)=="max") $Func="max";
			if (substr($ReqValue[1], 0, 3)=="min") $Func="min";
			if ($Func=="sum") {
				$Value=0;
				for ($j=0; $j<count($FullArr[$ReqValue[0]]); $j++) $Value+=trim($FullArr[$ReqValue[0]][$j]);
				$ReqValue[1]=substr($ReqValue[1], 3);
			}
			if ($Func=="max") {
				$Value=0;
				for ($j=0; $j<count($FullArr[$ReqValue[0]]); $j++) if ($Value<trim($FullArr[$ReqValue[0]][$j])) $Value=trim($FullArr[$ReqValue[0]][$j]);
				$ReqValue[1]=substr($ReqValue[1], 3);
			}
			if ($Func=="min") {
				$Value=false;
				for ($j=0; $j<count($FullArr[$ReqValue[0]]); $j++) if ($Value!==false&&$Value>trim($FullArr[$ReqValue[0]][$j])) $Value=trim($FullArr[$ReqValue[0]][$j]);
				$ReqValue[1]=substr($ReqValue[1], 3);
			}	
			for ($j=0; $j<count($FullArr[$ReqValue[0]]); $j++) {
				if (!$Func) $Value=trim($FullArr[$ReqValue[0]][$j]);
				if ($ReqValue[1]=="<="&&$Value<=$ReqValue[2]) {$Return = false; break;}
				if ($ReqValue[1]==">="&&$Value>=$ReqValue[2]) {$Return = false; break;}
				if ($ReqValue[1]=="<"&&$Value<$ReqValue[2]) {$Return = false; break;}
				if ($ReqValue[1]==">"&&$Value>$ReqValue[2]) {$Return = false; break;}
				if ($ReqValue[1]=="="&&$Value==$ReqValue[2]) {$Return = false; break;}
				$Return = true;
			}
		}
	}
	if ($Return) return false;
	return true;
}

function DeleteKey($Id) {
	global $Db, $nsProduct, $ClientsCntNow, $SitesCntNow, $BF, $Logs, $Lang;
	$Query = "SELECT * FROM ?_license WHERE ID = ?";
	$Row=$Db->Select($Query, false, $Id);
	$Row->KEY_DECODE=$BF->decrypt($Row->LICENSE_KEY);
	$Row->License=GetLicenseText($Row->KEY_DECODE);
	if (!$Row->License) return $Logs->Err($Lang['CantDelete']);

	if ($ClientsCntNow>1 && @$Row->License['P']==3 && $nsProduct->AKEY==1) return $Logs->Err($Lang['DelClientsErr']);
	if ( (($nsProduct->MAX_SITES+$nsProduct->TRIAL_SITES)-$Row->License['L']) < $SitesCntNow ) return $Logs->Err($Lang['DelSitesErr']);

	$Db->Query("DELETE FROM ?_license WHERE ID = ?", $Id);
	$nsProduct->Redir("license", "RDlt=1", "admin");
}


?>