<?
if (!defined("NS_TRACKER_INDEX")) exit;
require_once SYS."/system/lib/validate.func.php";
require_once SELF."/class/pagenums2.class.php";
$nsLang->TplInc("inc/reports");

$RunId=V($_REQUEST['RunId']);
$ViewDate=V($_REQUEST['ViewDate']);
$ShowSleep=V($_REQUEST['ShowSleep']);
if (!$ViewDate || !ValidDate($ViewDate)) $ViewDate=UserDate();

$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$Lang['Title'];
$ProgPath[1]['Url']=getURL("removal_log", "", "admin");
$MenuSection="admin";

//$Settings=GetSettings();
$CpuAvail=GetCpuLoad(true);
if ($CpuAvail==-1) $CpuAvail=false;


if (!$RunId) {
    
    $LogArr=array();
    $Where=($ShowSleep)?"":" AND CDL.MESSAGE != 'x-sleep'";
    $Query = "
        SELECT CL.*, CL.ID AS RUN_ID,
        MAX(CDL.CPU_LOAD) AS MAX_CPU,
        SUM(CDL.RUN_TIME) AS SUM_TIME,
        SUM(CDL.DELETED_ROWS) AS DELETED_ROWS,
        SUM(CDL.DELETED_SPACE) AS DELETED_SPACE,
        UNIX_TIMESTAMP(CL.STAMP) AS USTAMP,
        DATE_FORMAT(DATE_ADD(CL.STAMP,INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE),'%Y-%m-%d %H:%i') AS RUN_STAMP
        FROM ?_cron_log CL 
            INNER JOIN ?_cron_delete_log CDL
                ON CDL.TASK_PROCESS_ID=CL.ID
        WHERE CL.TASK='DELETE'
            AND CL.STAMP BETWEEN DATE_ADD('$ViewDate 00:00:00', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE) 
                                AND DATE_ADD('$ViewDate 23:59:59', INTERVAL '$nsUser->_SQL_TZ' HOUR_MINUTE)
                                $Where 
        GROUP BY CL.ID
        ORDER BY STAMP DESC
    ";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) {
        $Row->SUM_TIME=number_format($Row->SUM_TIME,3,'.','');
        $Row->TIME_ARR=TimeArr($Row->SUM_TIME);        
        $LogArr[]=$Row;
    }

    $Pages = new PageNums(count($LogArr),20);
    $Pages->Args="&ViewDate=$ViewDate&CpId=$CpId&ShowSleep=$ShowSleep";
    $Pages->Calculate();
    if ($Pages->Pages>1) $LogArr=array_slice($LogArr,$Pages->PageStart,$Pages->Limit);    

    include_once $nsTemplate->Inc();
}

if ($RunId) {
    
    $LogArr=array();
    $Args['runid']=$RunId;
    $Query = "
        SELECT *
            FROM ?_cron_delete_log CDL
            WHERE TASK_PROCESS_ID=?
            ORDER BY STAMP DESC, ID DESC
    ";
    $Sql = new Query($Query,false,$Args);
    while ($Row=$Sql->Row()) {
        if (!$ShowSleep && $Row->MESSAGE=='x-sleep') continue;
        $Row->MESSAGE=$Lang[$Row->MESSAGE];
        $Row->RUN_TIME=number_format($Row->RUN_TIME,3,'.','');
        $Row->TIME_ARR=TimeArr($Row->RUN_TIME);    
        $LogArr[]=$Row;
    }
    
    include_once $nsTemplate->Inc("admin.removal_log_list");
}
?>