<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if (!$nsUser->ADMIN&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE==4) $nsProduct->Redir("default", "", "admin"); 

require_once SYS.'/system/lib/validate.func.php';

$nsLang->TplInc("inc/menu");
$MenuSection="logs";

extract(VPack(array('SiteId','EditArr','VisId','CampId','CampId','SplitId','SplitPageId',
                                'Product','AddNewTag','DeleteTag')));
$EditId=V($_REQUEST['EditId'], 'new');


if (!$nsUser->DEMO) {
    if ($AddNewTag) AddNewTag($EditId,$AddNewTag);
    if ($DeleteTag) RemoveTag($EditId,$DeleteTag);
    if ($EditId && $EditArr) UpdateSale($EditId, $EditArr);
}

$PageTitle=($EditId=='new')?$Lang['NewSale']:$Lang['EditSale'];

$ProgPath=array();
$ProgPath[0]['Name']=$Lang['MReports'];
$ProgPath[0]['Url']=getUrl("reports", "CpId=$CpId&SiteId=$SiteId", "admin");
$ProgPath[1]['Name']=$Lang['SaleLog'];
$ProgPath[1]['Url']=getUrl("logs", "Mode=Sales&CpId=$CpId&SiteId=$SiteId", "report");
$ProgPath[2]['Name']=$PageTitle;
$ProgPath[2]['Url']=getUrl("sale", "CpId=$CpId&SiteId=$SiteId&EditId=$EditId", "admin");


$ProdList=array();

if ($EditId!='new') {

    $EditSale=GetSale($EditId);
    if (!$EditSale) $nsProduct->Redir('sale', "EditId=new"); 
    $VisId=$EditSale->VISITOR_ID;
    $CampId=$EditSale->CAMP_ID;
    $SplitId=$EditSale->SPLIT_ID;
    $SplitPageId=$EditSale->SPLIT_PAGE_ID;

    $Query = "
        SELECT SS.*, SI.NAME
        FROM ?_sale_set SS 
            INNER JOIN ?_sale_item SI
                ON SI.ID=SS.ITEM_ID AND SI.COMPANY_ID=?
        WHERE SS.SALE_ID=? AND SS.COMPANY_ID=?
        ORDER BY SI.NAME
    ";
    $Sql = new Query($Query, false, $CpId, $EditSale->SALE_ID, $CpId);
    while ($Row=$Sql->Row()) $ProdList[]=$Row;
}
if (empty($ProdList)) $ProdList[0]="123";


$ProductsArr=array();
$Query = "SELECT * FROM ?_sale_item WHERE COMPANY_ID=? ORDER BY NAME";
$Sql = new Query($Query, false, $CpId);
while ($Row=$Sql->Row()) $ProductsArr[]=$Row;

$SiteArr=array();
$Query = "SELECT * FROM ?_site WHERE COMPANY_ID=?";
$Sql = new Query($Query, false, $CpId);
while ($Row=$Sql->Row()) $SiteArr[]=$Row;

$SplitPagesArr=array();
if ($SplitId) {
    if ($TmpId=$Db->ReturnValue("SELECT ID FROM ?_split_test WHERE SUB_ID=?", $SplitId)) {
        $Query = "SELECT ID, FULL_PATH FROM ?_split_page WHERE SPLIT_ID=?";
        $Sql = new Query($Query, false, $TmpId);
        while ($Row=$Sql->Row()) {
            $SplitPagesArr[]=$Row;
        }
    }
}

$CampaignArr=array();
$SplitTestArr=array();
$Query = "
    SELECT CP.*, SC.ID AS CAMP_ID, ST.ID AS SPLIT_ID
    FROM ?_camp_piece CP
        LEFT JOIN ?_sub_campaign SC
            ON SC.SUB_ID=CP.ID
        LEFT JOIN ?_split_test ST
            ON ST.SUB_ID=CP.ID 
    WHERE CP.COMPANY_ID=? ORDER BY CP.NAME
";
$Sql = new Query($Query, false, $CpId);
while ($Row=$Sql->Row()) {
    if ($Row->SPLIT_ID) $SplitTestArr[]=$Row;
    if ($Row->CAMP_ID) $CampaignArr[]=$Row;
}

$UserStamp=UserDate('stamp');
$EditArr['Cost']=V($EditArr['Cost'], V($EditSale->COST));
$EditArr['Keyword']=V($EditArr['Keyword'], V($EditSale->KEYWORD));
$EditArr['CustomId']=V($EditArr['CustomId'], V($EditSale->CUSTOM_ORDER_ID));
$EditArr['Add']=V($EditArr['Add'], V($EditSale->ADDITIONAL));
$EditArr['Path']=V($EditArr['Path'], ($EditId=='new')?'/':V($EditSale->FULL_PATH) );
$EditArr['SaleDate']=V($EditArr['SaleDate'], V($EditSale->SALE_DATE, date("Y-m-d",$UserStamp)) );
$EditArr['SaleHour']=V($EditArr['SaleHour'], V($EditSale->SaleHour, date("H",$UserStamp)) );
$EditArr['SaleMinute']=V($EditArr['SaleMinute'], V($EditSale->SaleMinute, date("m",$UserStamp)) );

$SaleTags=array();
$Tags=array();
$Query = "SELECT T.* 
        FROM ?_sale_tag_rel SR 
        INNER JOIN ?_tag T
            ON T.ID=SR.TAG_ID 
        WHERE SR.COMPANY_ID=?";
$Sql = new Query($Query,false,$CpId);
while ($Row=$Sql->Row()) $Tags[$Row->ID]=$Row;

$Query = "SELECT TAG_ID FROM ?_sale_tag_rel WHERE COMPANY_ID=? AND SALE_ID=?";
$Sql = new Query($Query,false,$CpId,$EditId);
while ($Row=$Sql->Row()) $SaleTags[]=$Row->TAG_ID;



include $nsTemplate->Inc();






///////////////////////////////////////////////






function UpdateSale($Id, $Arr)
{
    global $Db,$Logs,$nsProduct,$Lang, $Product, $nsUser;
    global $VisId, $SiteId, $CampId, $CpId, $SplitId, $SplitPageId;
    
    if (!$SplitPageId) $SplitId=false;
    extract($Arr);
    if (!V($Path)) return $Logs->Err($Lang['NoPage']);
    $PathArr=parse_url($Path);
    $PathArr['scheme']=V($PathArr['scheme'], 'http');
    $PathArr['host']=V($PathArr['host']);
    $PathArr['path']=V($PathArr['path'], '/');
    $PathArr['query']=V($PathArr['query']);
    $Scheme=($PathArr['scheme']=="https")?1:0;

    $Keyword = trim(V($Keyword));

    $SaleStamp=false;
    if (V($SaleDate)) {
        $SaleHour=sprintf("%02d",V($SaleHour,'00'));
        $SaleMinute=sprintf("%02d",V($SaleMinute,'00'));
        $SaleStamp="$SaleDate $SaleHour:$SaleMinute:00";
    } else {
        $SaleStamp=date("Y-m-d H:i", UserDate('stamp'));
        $SaleStamp.=":00";
    }

    $QueryId=GetQueryId($PathArr['query']);

    if ($CustomId) {
        $Query="SELECT ID FROM ?_{$CpId}_stat_sale WHERE CUSTOM_ORDER_ID=? AND ID!=?";
        $Check=$Db->Select($Query,false,$CustomId,$Id);
        if ($Check) return $Logs->Err($Lang['DuplicateCustom']);
    }

    if (!V($VisId)) $VisId=CreateNewUser();
    $Visitor=$Db->Select("SELECT * FROM ?_visitor WHERE ID = ?", false, $VisId);
    if (!$Visitor) {
        $VisId=CreateNewUser();
        $Visitor=$Db->Select("SELECT * FROM ?_visitor WHERE ID = ?", false, $VisId);
    }

    //  
    if ($Id=='new') {
        if (!$SiteId) return $Logs->Err($Lang['NoSite']);
        $PageId=GetPageId($PathArr['path'],$SiteId);
        if ($PathArr['host']) {
            $Query = "SELECT SH.* FROM ?_site_host SH WHERE SH.HOST=? AND SH.SITE_ID=?";
            $SiteCheck=$Db->Select($Query,false,$PathArr['host'], $SiteId);
            if (!$SiteCheck) return $Logs->Err($Lang['NoSite']);
            $SiteHostId=$SiteCheck->ID;
        }
        else {
            $Query = "SELECT ID FROM ?_site_host WHERE SITE_ID=?";
            $SiteHostId=$Db->ReturnValue($Query, $SiteId);
        }

        $CookieLog=false;
        $Stamp=gmdate("Y-m-d H:i:s", time());
        $Query = "
            INSERT INTO ?_{$CpId}_stat_log
            (STAMP, VISITOR_ID, SITE_ID, SITE_HOST_ID, PAGE_ID, QUERY_ID, IP_ID, AGENT_ID, SCHEME)
            VALUES (DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE),?,?,?,?,?,?,?,?)
        ";
        $Db->Query($Query,$SaleStamp,$Visitor->ID,$SiteId,$SiteHostId,$PageId,$QueryId,$Visitor->LAST_IP_ID,$Visitor->LAST_AGENT_ID,$Scheme);
        $LogId=$Db->LastInsertId;
        if ($CampId) $CookieLog = GetNewPathCampaign($LogId, $Visitor->ID, $CampId,$CookieLog,$SaleStamp, $Keyword);
        if ($SplitId) $CookieLog = GetNewPathSplit($LogId, $Visitor->ID, $SplitId, $SplitPageId,$CookieLog,$SaleStamp);
        if (!$CookieLog) $CampId=$SplitId=false;

        if (!$CampId && !$SplitId)  {
            $Query = "SELECT ID FROM ?_{$CpId}_stat_log WHERE ID=COOKIE_LOG AND VISITOR_ID=? ORDER BY STAMP DESC LIMIT 1";
            $CookieLog=$Db->ReturnValue($Query, $VisId);
        }
        if ($CookieLog) {
            $Query = "UPDATE ?_{$CpId}_stat_log SET COOKIE_LOG=? WHERE ID=?";
            $Db->Query($Query,$CookieLog,$LogId);
        }

        $Query = "
            INSERT INTO ?_{$CpId}_stat_sale
            (LOG_ID, COST, SITE_ID, CUSTOM_ORDER_ID, ADDITIONAL)
            VALUES (?,?,?,?,?)
        ";
        $Db->Query($Query, $LogId, $Cost, $SiteId, $CustomId, $Add);
        $Id=$Db->LastInsertId;

    }
    //  
    else { 
        $EditSale=GetSale($Id);
        if (!$PathArr['host']) return $Logs->Err($Lang['NoSite']);
        $Query = "
            SELECT SH.*
                FROM ?_site_host SH
                    INNER JOIN ?_site S
                        ON S.ID=SH.SITE_ID
            WHERE SH.HOST=?
        ";
        $SiteCheck=$Db->Select($Query,false,$PathArr['host']);
        if (!$SiteCheck) return $Logs->Err($Lang['NoSite']);
        $SiteHostId=$SiteCheck->ID;
        $SiteId=$SiteCheck->SITE_ID;
        $PageId=GetPageId($PathArr['path'],$SiteId);

        $CookieLog=$EditSale->COOKIE_LOG;
        if ($CampId && ($CampId != $EditSale->CAMP_ID || $Keyword != $EditSale->KEYWORD)) {
            $CookieLog = GetNewPathCampaign($EditSale->LOG_ID, $EditSale->VISITOR_ID, $CampId, $CookieLog, $SaleStamp, $Keyword);
        }
        //$Logs->Msg("$SplitId -- {$EditSale->SPLIT_ID} || $SplitPageId -- {$EditSale->SPLIT_PAGE_ID}");
        if ($SplitId && $SplitId != $EditSale->SPLIT_ID || ($EditSale->SPLIT_ID && $SplitPageId != $EditSale->SPLIT_PAGE_ID)) {
            $CookieLog = GetNewPathSplit($EditSale->LOG_ID, $EditSale->VISITOR_ID, $SplitId, $SplitPageId, $CookieLog, $SaleStamp);
        }

        if (!$CampId && !$SplitId) $CookieLog=0;
        $IpId=($EditSale->VISITOR_ID==$VisId)?$EditSale->IP_ID:$Visitor->LAST_IP_ID;
        $AgentId=($EditSale->VISITOR_ID==$VisId)?$EditSale->AGENT_ID:$Visitor->LAST_AGENT_ID;
        $Query = "
            UPDATE ?_{$CpId}_stat_log SET 
                STAMP = DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE), SITE_ID=?, SITE_HOST_ID=?, 
                COOKIE_LOG=?, PAGE_ID=?, QUERY_ID=?, IP_ID=?, AGENT_ID=?, VISITOR_ID=?, SCHEME=?
                WHERE ID = ?
        ";
        $Db->Query($Query, $SaleStamp, $SiteId, $SiteHostId, $CookieLog, $PageId, 
                            $QueryId, $IpId, $AgentId, $VisId, $Scheme, $EditSale->LOG_ID);
                            
        if ($CookieLog) {
            // ,     
            $Query = "SELECT IF(S_LOG.STAMP > DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE), 1, 0) 
                            FROM ?_{$CpId}_stat_log S_LOG WHERE ID=?";
            $Check=$Db->ReturnValue($Query,$SaleStamp,$CookieLog);
            if ($Check) {
                $Query = "UPDATE ?_{$CpId}_stat_log S_LOG SET 
                                STAMP = DATE_ADD(DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE), INTERVAL -1 MINUTE) 
                                WHERE ID=?";
                $Db->Query($Query,$SaleStamp,$CookieLog);
                if ($CampId) $Logs->Alert($Lang['ClickStampChanged']);
                if ($SplitId) $Logs->Alert($Lang['SplitStampChanged']);
            }
        }

        $Query = "
            UPDATE ?_{$CpId}_stat_sale SET
                COST=?, SITE_ID=?, CUSTOM_ORDER_ID=?, ADDITIONAL=?
                WHERE ID = ?
        ";
        $Db->Query($Query, $Cost, $SiteId, $CustomId, $Add, $EditSale->SALE_ID);
    }

    //  
    $Query = "DELETE FROM ?_sale_set WHERE SALE_ID=? AND COMPANY_ID=?";
    $Db->Query($Query,$Id,$CpId);
    $ProdValue=0;
    $DbItems=array();
    if (!empty($Product)) {
    foreach ($Product as $Row) {
        if (V($Row['ItemId']) && $Row['ItemId']!="new" && !V($Row['Name'])) $ItemId=$Row['ItemId'];
        else $ItemId=GetSaleItem(V($Row['Name']), $CpId);
        if (!$ItemId) continue;
        $Cnt=V($Row['Cnt'],0);
        if(!$Cnt) continue;
        $Value=V($Row['Value'],'0');
        $ProdValue+=doubleval($Value);
        if (!isset($DbItems[$ItemId.$Value])) {
            $Query = "INSERT INTO ?_sale_set (SALE_ID, COMPANY_ID, ITEM_ID, QUANT, COST) VALUES (?,?,?,?,?)";
            $Db->Query($Query, $Id, $CpId,$ItemId,$Cnt,$Value);
            $DbItems[$ItemId.$Value] = $Db->LastInsertId;
        }
        else {
            $EditItemId = $DbItems[$ItemId.$Value];
            $Query = "UPDATE ?_sale_set SET QUANT = QUANT + ? WHERE ID = ?";
            $Db->Query($Query,$Cnt,$EditItemId);
        }
    }}
    
    if (doubleval($Cost)==0 && $ProdValue>0) {
        $Query = "UPDATE ?_{$CpId}_stat_sale SET COST=? WHERE ID=?";
        $Db->Query($Query,$ProdValue,$Id);
    }
    
    $nsProduct->Redir("sale", "RUpd=1&EditId=$Id");
}

function GetDefaultHost()
{
    global $Db, $CpId;
    $Query = "
        SELECT SH.HOST
            FROM ?_site S
                INNER JOIN ?_site_host SH
                    ON SH.SITE_ID=S.ID
            WHERE S.COMPANY_ID=? AND SH.ENABLED='1'
            ORDER BY S.HOST
    ";
    return $Db->ReturnValue($Query, $CpId);
}


function GetNewPathSplit($BeforeLogId,$VisitorId, $NewSplit, $SplitPageId,$CookieLog=false,$SaleStamp) 
{
    global $Db, $CpId, $nsUser, $Lang;
    $Query = "SELECT * FROM ?_split_page WHERE ID=?";
    $Page=$Db->Select($Query,false,$SplitPageId);
    if (!$Page) return false;
    $Page->ID=$SplitPageId; // ??
    $And=($CookieLog)?" AND S_LOG.ID=$CookieLog ":"";
    $Query = "
        SELECT S_LOG.ID,
        IF (S_LOG.STAMP > DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE),1,0) AS STAMP_BEFORE
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_split S_SPLIT
            ON S_SPLIT.LOG_ID=S_LOG.ID
        WHERE S_LOG.VISITOR_ID=? AND S_SPLIT.SPLIT_ID=? AND S_LOG.ID=S_LOG.COOKIE_LOG
                    AND S_LOG.PAGE_ID=? AND S_LOG.QUERY_ID=?
                    $And
        ORDER BY S_LOG.STAMP DESC
        LIMIT 1
    ";
    $Log=$Db->Select($Query, false, $SaleStamp, $VisitorId, $NewSplit, $Page->PAGE_ID, $Page->QUERY_ID);    
    if (!$Log) $LogId=CreateNewSplitClick($NewSplit, $Page, $BeforeLogId,$CookieLog,$SaleStamp);
    else $LogId=$Log->ID;
    if ($Log && $Log->STAMP_BEFORE) {
        $Query = "UPDATE ?_{$CpId}_stat_log SET STAMP = DATE_ADD(DATE_ADD(?, INTERVAL -1 MINUTE), INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE)";
        $Db->Query($Query,$SaleStamp);
        $Logs->Alert($Lang['SplitStampChanged']);
    }    
    $Query = "UPDATE ?_{$CpId}_stat_log SET COOKIE_LOG=? WHERE ID=?";
    $Db->Query($Query, $LogId, $BeforeLogId);
    return $LogId;
}


function CreateNewSplitClick($SplitId, $Page, $BeforeLogId,$CookieLog=false, $SaleStamp) 
{
    global $Db, $CpId, $nsUser, $Logs;
    $Query = "SELECT *, UNIX_TIMESTAMP(STAMP) AS STAMP FROM ?_{$CpId}_stat_log WHERE ID = ?";
    $Log=$Db->Select($Query, false, $BeforeLogId);
    $Stamp=date("Y-m-d H:i:s", $Log->STAMP-1);

    if (!$CookieLog) {
    $Query = "
        INSERT INTO ?_{$CpId}_stat_log
            (STAMP, VISITOR_ID, SITE_ID, SITE_HOST_ID, PAGE_ID, QUERY_ID, IP_ID, AGENT_ID)
            VALUES (DATE_ADD(DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE), INTERVAL -1 MINUTE),?,?,?,?,?,?,?)
    ";
    $Db->Query($Query,$SaleStamp,$Log->VISITOR_ID,$Log->SITE_ID,
                                $Log->SITE_HOST_ID,$Page->PAGE_ID,$Page->QUERY_ID,
                                $Log->IP_ID,$Log->AGENT_ID);
    $LogId=$Db->LastInsertId;
    $Query = "UPDATE ?_{$CpId}_stat_log SET COOKIE_LOG=? WHERE ID=?";
    $Db->Query($Query,$LogId,$LogId);
    }
    else $LogId=$CookieLog;
    
    $Query = "UPDATE ?_{$CpId}_stat_log SET PAGE_ID=?, QUERY_ID=? WHERE ID=?";
    $Db->Query($Query,$Page->PAGE_ID,$Page->QUERY_ID,$LogId);
    
    $Query = "
        INSERT INTO ?_{$CpId}_stat_split
            (LOG_ID, SPLIT_ID) VALUES (?,?) 
    ";
    $Db->Query($Query,$LogId,$SplitId);
    return $LogId;
}



function GetNewPathCampaign($BeforeLogId,$VisitorId, $NewCampaign,$CookieLog=false,
                                                  $SaleStamp,$Keyword=false)
{
    global $Db, $CpId, $nsUser, $Logs, $Lang;
    $KeyId = GetKeywordId($Keyword);
    $And=($CookieLog)?" AND S_LOG.ID=$CookieLog ":"";
    if ($KeyId) $And .= " AND S_CLICK.KEYWORD_ID = $KeyId ";
    $Query = "
        SELECT S_LOG.ID, 
            IF (S_LOG.STAMP > DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE),1,0) AS STAMP_BEFORE
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_click S_CLICK
            ON S_CLICK.LOG_ID=S_LOG.ID
        WHERE S_LOG.VISITOR_ID=? AND S_CLICK.CAMP_ID=? AND S_LOG.ID=S_LOG.COOKIE_LOG
            $And
        ORDER BY S_LOG.STAMP DESC
        LIMIT 1
    ";
    $Log=$Db->Select($Query, false, $SaleStamp, $VisitorId, $NewCampaign);
    if (!$Log) $LogId=CreateNewClick($NewCampaign, $BeforeLogId,false,$SaleStamp, $KeyId);
    else $LogId=$Log->ID;
    if ($Log && $Log->STAMP_BEFORE) {
        $Query = "UPDATE ?_{$CpId}_stat_log SET STAMP = DATE_ADD(DATE_ADD(?, INTERVAL -1 MINUTE), INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE)";
        $Db->Query($Query,$SaleStamp);
        $Logs->Alert($Lang['ClickStampChanged']);
    }
    $Query = "UPDATE ?_{$CpId}_stat_log SET COOKIE_LOG=? WHERE ID=?";
    $Db->Query($Query, $LogId, $BeforeLogId);
    return $LogId;
}

function CreateNewClick($CampId, $BeforeLogId,$CookieLog=false, $SaleStamp, $KeyId=0) 
{
    global $Db, $CpId, $nsUser;
    $Query = "SELECT *, UNIX_TIMESTAMP(STAMP) AS STAMP FROM ?_{$CpId}_stat_log WHERE ID = ?";
    $Log=$Db->Select($Query, false,$BeforeLogId);
    $PageId=GetPageId("/",$Log->SITE_ID);
    $Stamp=date("Y-m-d H:i:s", $Log->STAMP-1);
    
    if (!$CookieLog) {
    $Query = "
        INSERT INTO ?_{$CpId}_stat_log
            (STAMP, VISITOR_ID, SITE_ID, SITE_HOST_ID, PAGE_ID, IP_ID, AGENT_ID)
            VALUES (DATE_ADD(DATE_ADD(?, INTERVAL '{$nsUser->_SQL_TZ}' HOUR_MINUTE), INTERVAL -1 MINUTE),?,?,?,?,?,?) 
    ";
    $Db->Query($Query,$SaleStamp,$Log->VISITOR_ID,$Log->SITE_ID,$Log->SITE_HOST_ID,$PageId,$Log->IP_ID,$Log->AGENT_ID);
    $LogId=$Db->LastInsertId;
    $Query = "UPDATE ?_{$CpId}_stat_log SET COOKIE_LOG=? WHERE ID=?";
    $Db->Query($Query,$LogId,$LogId);
    }
    else $LogId=$CookieLog;
    
    $Query = "INSERT INTO ?_{$CpId}_stat_click (LOG_ID, CAMP_ID, KEYWORD_ID) VALUES (?,?,?) ";
    $Db->Query($Query,$LogId,$CampId,$KeyId);
    return $LogId;
}


function CreateNewUser()
{
    global $Db;
    $Query = "
        INSERT INTO ?_visitor 
        (LAST_IP_ID, LAST_AGENT_ID, FIRST_STAMP, LAST_STAMP, LAST_COUNTRY_ID, LAST_RESOLUTION, FLASH_VERSION, PIXEL_DEPTH)
        SELECT 
        LAST_IP_ID, LAST_AGENT_ID, NOW(), NOW(), LAST_COUNTRY_ID, LAST_RESOLUTION, FLASH_VERSION, PIXEL_DEPTH
             FROM ?_visitor 
            ORDER BY RAND() LIMIT 1
    ";
    $Db->Query($Query);
    $VisId=$Db->LastInsertId;
    return $VisId;
}

function GetPageId($Path=false, $StId=false)
{
    if (!$Path||!$StId) return 0;
    global $Db;
    $Path=escape_string($Path);
    $Query = "SELECT ID FROM ?_site_page WHERE PATH = ? AND SITE_ID=?";
    $Check=$Db->Select($Query, false, $Path, $StId);
    if ($Check) return $Check->ID;
    $Query = "INSERT INTO ?_site_page (SITE_ID, PATH) VALUES (?, ?)";
    $Db->Query($Query, $StId, $Path);
    return $Db->LastInsertId;
}

function GetQueryId($Qr=false)
{
    if (!$Qr) return 0;
    global $Db;
    $Qr=escape_string($Qr);
    $Query = "SELECT ID FROM ?_query WHERE MD5_SEARCH=MD5(?)";
    $CheckId=$Db->ReturnValue($Query, $Qr);
    if ($CheckId) return $CheckId;
    $Query ="INSERT INTO ?_query (QUERY_STRING, MD5_SEARCH) VALUES (?, MD5(?))";
    $Db->Query($Query, $Qr, $Qr);
    return (ValidId($Db->LastInsertId))?$Db->LastInsertId:0;
}


function GetSaleItem($ItemName=false, $CompanyId=false)
{
    if (!$ItemName||!$CompanyId) return 0;
    global $Db;
    $Query = "SELECT ID FROM ?_sale_item WHERE NAME=? AND COMPANY_ID=?";
    $CheckId=$Db->ReturnValue($Query, $ItemName, $CompanyId);
    if ($CheckId) return $CheckId;
    $Query ="INSERT INTO ?_sale_item (COMPANY_ID, NAME) VALUES (?, ?)";
    $Db->Query($Query, $CompanyId, $ItemName);
    return $Db->LastInsertId;
}

function AddNewHost($Host,$SiteId)
{
    global $Db;
    $Query = "INSERT INTO ?_site_host (SITE_ID,HOST) VALUES (?,?)";
    $Db->Query($Query,$SiteId,$Host);
    return $Db->LastInsertId;
}

    
function GetSale($Id)
{
    global $Db, $CpId, $nsUser;
    $Query = "
        SELECT 
            S_SALE.*, S_LOG.*, 
            S_SALE.ID AS SALE_ID,
            SP.PATH, Q.QUERY_STRING,
            SH.HOST AS SITE_HOST,
            DATE_FORMAT(DATE_ADD(S_LOG.STAMP, INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE), '%Y-%m-%d') AS SALE_DATE,
            DATE_FORMAT(DATE_ADD(S_LOG.STAMP, INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE), '%H:%i') AS SALE_TIME
            FROM ?_{$CpId}_stat_sale S_SALE
                INNER JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.ID=S_SALE.LOG_ID
                INNER JOIN ?_site_page SP ON SP.ID=S_LOG.PAGE_ID
                INNER JOIN ?_site S ON S.ID=S_LOG.SITE_ID
                INNER JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
                LEFT JOIN ?_query Q ON Q.ID=S_LOG.QUERY_ID
        WHERE S_SALE.ID=?
    ";
    $EditSale=$Db->Select($Query, false, $Id);
    if (!$EditSale) return false;
    $Arr=explode(':',$EditSale->SALE_TIME);
    $EditSale->SaleHour=$Arr[0];
    $EditSale->SaleMinute=$Arr[1];
    $EditSale->CAMP_ID=false;
    $EditSale->SPLIT_ID=false;
    if ($EditSale->COOKIE_LOG) {
        $Query = "SELECT S_CLICK.CAMP_ID, S_CLICK.KEYWORD_ID, K.KEYWORD
            FROM ?_{$CpId}_stat_click S_CLICK
                LEFT JOIN ?_keyword K ON K.ID=S_CLICK.KEYWORD_ID
            WHERE S_CLICK.LOG_ID=?
        ";
        $Click = $Db->Select($Query,false,$EditSale->COOKIE_LOG);
        if ($Click) {
            $EditSale->CAMP_ID=$Click->CAMP_ID;
            $EditSale->KEYWORD_ID=$Click->KEYWORD_ID;
            $EditSale->KEYWORD=$Click->KEYWORD;
        }
        $Query = "SELECT SPLIT_ID FROM ?_{$CpId}_stat_split WHERE LOG_ID=?";
        $EditSale->SPLIT_ID=$Db->ReturnValue($Query, $EditSale->COOKIE_LOG);
    } 
    $EditSale->SPLIT_PAGE_ID=false;
    if ($EditSale->SPLIT_ID) {
        $Query = "SELECT ID FROM ?_split_test WHERE SUB_ID=?";
        $Id=$Db->ReturnValue($Query, $EditSale->SPLIT_ID);
        $Query = "SELECT PAGE_ID, QUERY_ID FROM ?_{$CpId}_stat_log WHERE ID=?";
        $Page=$Db->Select($Query, false, $EditSale->COOKIE_LOG);
        if ($Id) {
            $Query= "SELECT ID FROM ?_split_page WHERE SPLIT_ID=? AND PAGE_ID=? AND QUERY_ID=? LIMIT 1";
            $EditSale->SPLIT_PAGE_ID=$Db->ReturnValue($Query, $Id, $Page->PAGE_ID, $Page->QUERY_ID);
        }
    }
    if ($EditSale->QUERY_STRING) $EditSale->PATH.="?".$EditSale->QUERY_STRING;
    $EditSale->FULL_PATH=(($EditSale->SCHEME)?"https":"http")."://".$EditSale->SITE_HOST.$EditSale->PATH;
    return $EditSale;
}

function AddNewTag($SaleId,$Tag)
{
    global $Db,$CpId,$nsProduct;
    $TagId=GetTagId($Tag);
    $Query = "SELECT ID FROM ?_sale_tag_rel WHERE COMPANY_ID=? AND SALE_ID=? AND TAG_ID=?";
    $CheckId=$Db->ReturnValue($Query,$CpId,$SaleId,$TagId);
    if ($CheckId) return $CheckId;
    $Query = "INSERT INTO ?_sale_tag_rel (COMPANY_ID,SALE_ID,TAG_ID) VALUES (?,?,?)";
    $Db->Query($Query,$CpId,$SaleId,$TagId);

    $nsProduct->Redir('sale',"EditId=$SaleId");
}

function GetTagId($Tag)
{
    global $Db, $CpId;
    $Query = "SELECT ID FROM ?_tag WHERE MD5_HASH = MD5(?)";
    $CheckId=$Db->ReturnValue($Query,$Tag);
    if ($CheckId) return $CheckId;
    $Query = "INSERT INTO ?_tag (MD5_HASH,TAG) VALUES (MD5(?),?)";
    $Db->Query($Query,$Tag,$Tag);
    return $Db->LastInsertId;
}

function RemoveTag($SaleId,$TagId)
{
    global $Db,$CpId,$nsProduct;
    $Query = "DELETE FROM ?_sale_tag_rel WHERE COMPANY_ID=? AND SALE_ID=? AND TAG_ID=?";
    $Db->Query($Query,$CpId,$SaleId,$TagId);
    $nsProduct->Redir("sale","EditId=$SaleId");
}

function GetKeywordId($Key=false)
{
    if (!$Key) return 0;
    global $Db, $LangConfig;

    $LowerKey=ToLower($Key,@$LangConfig['charset']);
    $LowerKey=md5($LowerKey);

    $Query = "SELECT ID FROM ?_keyword WHERE MD5_SEARCH=?";
    $CheckId=$Db->ReturnValue($Query,$LowerKey);
    if ($CheckId) return $CheckId;
    $Query ="INSERT INTO ?_keyword (KEYWORD, MD5_SEARCH) VALUES (?, ?)";
    $Db->Query($Query, $Key, $LowerKey);
    return $Db->LastInsertId;
}


?>