<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

if ($nsProduct->LICENSE==3&&!$nsUser->ADMIN) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE!=3&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE==1) {
    $Logs->Err($Lang['TrialUpdate']);
    $nsProduct->Redir("license", "EditId=new", "admin");
}

$CustomUpdate=V($_GP['CustomUpdate']);
$RunCustom=str_replace("/", "", V($_GP['RunCustom']));

define('UPDATE_MODE', true);


/////////////////////////////////////////////
///////// require libraries here

// run custom scripts from updates
if ($CustomUpdate && $RunCustom && file_exists(SELF."/update/$CustomUpdate/$RunCustom.php")) {
    include_once SELF."/update/$CustomUpdate/$RunCustom.php";
}


/////////////////////////////////////////////
///////// prepare any variables
$PageTitle=$Lang['Title'];
$AdditionalOnload="";
$UpdatesArr=array();
$UpdateDescr=array();
$FirstUpdate="";
$UpdatesAvail=0;
$RunSql=false;
$UpdateVersion=true;
$AdditionalInclude=false;
$UseRedir=true;
$DisableSubmit=false;
$UpdateForms=array();
$SkipErrors=false;
$WrongReqVersion=false;


$Done=(V($_REQUEST['Done']))?$_REQUEST['Done']:false;
$Run=(V($_REQUEST['Run']))?$_REQUEST['Run']:false;
$NoHands=(V($_REQUEST['NoHands']))?$_REQUEST['NoHands']:false;
$Silent=(V($_REQUEST['Silent']))?true:false;
$CheckShell=V($_REQUEST['CheckShell']);

/////////////////////////////////////////////
///////// call any process functions


$D=@opendir(SELF."/update");
while (($Row=@readdir($D))!==false) {
	if ($Row==".."||$Row=="."||$Row=="CVS") continue;
	if (CompareVersions($Row, $nsProduct->VERSION)<1) continue;
    if (CompareVersions($Row, $TrackerVersion)==1) continue;
	if (CompareVersions($Row, $nsProduct->VERSION, 1)==1&&$nsProduct->LICENSE!=1) {
		//$Logs->Alert($Lang['NextVersionKey']);
	}
	$UpdateDescr[$Row]="";
	$DescrFile="$Row.".$nsLang->CurrentLang.".html";
	if (@file_exists(SELF."/update/$Row/$DescrFile")) $UpdateDescr[$Row]=ReadFileData(SELF."/update/$Row/$DescrFile");
	elseif (@file_exists(SELF."/update/$Row/$Row.html")) $UpdateDescr[$Row]=ReadFileData(SELF."/update/$Row/$Row.html");
	
	$UpdatesArr[]=$Row;
}
@closedir($D);

if (count($UpdatesArr)>0) {
	sort($UpdatesArr);
	$UpdatesAvail=count($UpdatesArr);
	$FirstUpdate=$UpdatesArr[0];
}

$SubTitle=$Lang['UpdatesAvail'].$UpdatesAvail;


//  
if ($Run&&$FirstUpdate&&!$nsUser->DEMO) {
	if (@file_exists(SELF."/update/$FirstUpdate/$FirstUpdate.php")) {
		include_once SELF."/update/$FirstUpdate/$FirstUpdate.php";
	}
	else $RunSql=true;

	if ($RunSql&&@file_exists(SELF."/update/$FirstUpdate/$FirstUpdate.sql")) {
		$Logs->ClearError();
		RunSqlArr(PrepareQueries(ReadFileData(SELF."/update/$FirstUpdate/$FirstUpdate.sql")));
		if($Logs->HaveErr()&&!$Silent&&!$SkipErrors) {
			$UseRedir=false;
			$UpdateVersion=false;
		}
	}

	if ($UpdateVersion&&!$WrongReqVersion) {
		$CurVersion=$FirstUpdate;
		$CurVersionArr=explode(".", $CurVersion);
		if (count($CurVersionArr)==2) $CurVersion=$FirstUpdate.".0";
		else $CurVersion=$FirstUpdate;
		$Query = "UPDATE ?{PFX}_system_product SET VERSION=? WHERE ID=?";
		$Db->Query($Query, $CurVersion, $nsProduct->ID);
	}
	if ($UseRedir&&!$WrongReqVersion) {
		if ($NoHands&&$UpdatesAvail>1) $nsProduct->Redir("update", "Run=1&NoHands=$NoHands", "admin");
		$nsProduct->Redir("update", "Done=1", "admin");
	}
    //if ($WrongReqVersion) $nsProduct->Redir(); 
}


if($UpdatesAvail==0&&!$Done&&!$CheckShell) $Logs->Msg($Lang['NoUpdateNeeded']);
if($Done || ($CheckShell && !in_array($CheckShell, $UpdatesArr))) $Logs->Msg($Lang['UpdateComplete']);

if ($UpdatesAvail>0) $Logs->Alert($Lang['BackUp']);

/////////////////////////////////////////////
///////// display section here

if (!defined("COMMAND_LINE")) {
include $nsTemplate->Inc("inc/header");
if (!$AdditionalInclude) include $nsTemplate->Inc();
else include $AdditionalInclude;
include $nsTemplate->Inc("inc/footer");
}

/////////////////////////////////////////////
///////// process functions here


/////////////////////////////////////////////
///////// library section


function CheckPrevVersion($ReqVersion=false,$CurVersion=false)
{
    if (!$ReqVersion) return true;
    global $nsProduct, $Logs, $Lang,$WrongReqVersion;
    if (is_array($ReqVersion)) {
        foreach ($ReqVersion as $V) {
            if (CompareVersions($V,$nsProduct->VERSION)==0) return true;
        }
    }
    else {
        if (CompareVersions($ReqVersion,$nsProduct->VERSION)==0) return true;
    }
    $WrongReqVersion=true;
    $Logs->Err(sprintf($Lang['WrongReqVersion'],$CurVersion,$ReqVersion,$nsProduct->VERSION));
    return false;
}


function PrepareQueries($SQL=false)
{
	if (!$SQL) return false;
	$SqlArr=array();
	$SQL = str_replace("{PREF}", PFX, $SQL);
	$SqlArr=explode(";", $SQL);
	for($i=0;$i<count($SqlArr);$i++) {
		$SqlArr[$i]=trim($SqlArr[$i]);
		if ($SqlArr[$i]=="") unset($SqlArr[$i]);
	}
	return $SqlArr;
}

function ReadFileData($File=false)
{
	if (!$File) return false;
	$f=@fopen($File, "r");
	$SQL = @fread($f, @filesize($File));
	@fclose($f);
	return $SQL;
}

function RunSqlArr($Arr=false)
{
	if (empty($Arr)) return false;
	global $Db;
	foreach ($Arr as $Query) 	$Db->Query(trim($Query));
}

?>