<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (function_exists("ini_set")) @set_time_limit(0);
if ($nsProduct->VERSION!=$TrackerVersion) exit;
define('NS_TRACKER_DELAYED',true);

require_once SELF. '/lib/cron/cron.func.php';

if (!isset($Settings)) $Settings=GetSettings();
if (!defined("NO_CRON_COMMENTS")) define("NO_CRON_COMMENTS",true);
$GLOBALS['_NS_TRACK_VARS']=array();
$_GP=array();
$ClientArr=array();
$Query = " SELECT C.ID, CO.DELAYED_TRACKING
    FROM ?_client C
        LEFT JOIN ?_config CO ON CO.COMPANY_ID=C.ID AND CO.SITE_ID=0
        ORDER BY C.ID
";
$Sql = new Query($Query);
$EnableDelayed = false;
if ($nsProduct->LICENSE != 4) while ($Row=$Sql->Row()) {
    if ($Settings['All']->DELAYED_TRACKING || $Row->DELAYED_TRACKING)  {
        $ClientArr[]=$Row->ID;
        $EnableDelayed = true;
    }
}

$SetSleepMessageFunc="DelayedSleepMessage";

if (!NO_CRON_COMMENTS) echo "Delayed tracking... \n";
$EnableDelayed = RunAllDelayed();

function RunAllDelayed()
{
    global $ClientArr, $Db;
    $Processed=0;
    foreach ($ClientArr as $CpId) {
        $Steps=array();
        $Query = "SELECT * FROM ?_{$CpId}_delayed ORDER BY STAMP ASC LIMIT 100";
        $Sql = new Query($Query);
        while ($Row=$Sql->Row()) $Steps[]=$Row;
        foreach ($Steps as $Step) {
            CheckCpuLoad($CpId,NO_CRON_COMMENTS);
            if (IsCronTaskFinished()) return false;
            RunDelayedStep($Step);
            $Query = "DELETE FROM ?_{$CpId}_delayed WHERE ID=?";
            $Db->Query($Query,$Step->ID);
            $Processed++;
        }
    }

    if (!NO_CRON_COMMENTS&&$Processed) echo "\n\nDelayed steps processed: $Processed\n\n";
}


function DelayedSleepMessage()
{
    return false;
}



function RunDelayedStep($Step)
{
    global $Db, $nsProduct, $_GP, $_NS_TRACK_VARS, $Logs, $_COOKIE, $TrackerVersion;
    global $nsUser;
    $nsSelf=SELF;
    $nsSys=SYS;
    $_GP=array();
    $_NS_TRACK_VARS['Product']=&$nsProduct;
    $_NS_TRACK_VARS['PresetStamp']=$Step->STAMP;

    $Vars=unserialize($Step->VARS);
    $_GP=$Vars['_GP'];
    $_SERVER['HTTP_USER_AGENT']=@$Vars['HTTP_USER_AGENT'];
    $_SERVER['QUERY_STRING']=@$Vars['QUERY_STRING'];
    $_SERVER['REMOTE_ADDR']=$Step->IP;
    $CookieVars=unserialize($Step->COOKIE_VARS);
    if (!empty($CookieVars)) foreach ($CookieVars as $k=>$v) $_COOKIE[$k]=$v;
    $_COOKIE[COOKIE_PFX.'visitor']=$Step->VISITOR_COOKIE;

    $LangConfFile=SELF.'/lang/'.$nsProduct->DEFAULT_LANG.'/_system/'.$nsProduct->DEFAULT_LANG.'.config.php';
    if (file_exists($LangConfFile)) require $LangConfFile;   

    if (!NO_CRON_COMMENTS) echo $Step->REQUEST_TYPE.": $Step->STAMP\n"; 

    if ($Step->REQUEST_TYPE=='1') include SELF."/actions/track.default.php";
    if ($Step->REQUEST_TYPE=='2') include SELF."/actions/track.event.php";
    if ($Step->REQUEST_TYPE=='3') include SELF."/actions/track.sale.php";
    if ($Step->REQUEST_TYPE=='4') include SELF."/actions/track.campaign.php";
    if ($Step->REQUEST_TYPE=='5') include SELF."/actions/track.split.php";
}

?>