<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!defined("NS_PHP_TRACKING")) {
	$nsSelf=SELF;
	$nsSys=SYS;
	if (!defined("NS_DB_PFX")) define("NS_DB_PFX", PFX);
	if (!defined("NS_COOKIE_PFX")) define("NS_COOKIE_PFX", COOKIE_PFX);
    if (!defined("NS_TRACKING")) define("NS_TRACKING", true);
	$_NS_TRACK_VARS['QueryClass']="Query";
	$_NS_TRACK_VARS['Version']=$nsProduct->VERSION;
}
if (!defined("NS_TRACKER_DELAYED")) define("NS_TRACKER_DELAYED",false);

require_once $nsSelf."/lib/track/misc.func.php";
require_once $nsSelf."/lib/track/delayed.func.php";
require_once $nsSelf."/lib/track/general.func.php";
require_once $nsSelf."/lib/track/campaign.func.php";
require_once $nsSelf."/lib/track/visitor.func.php";
require_once $nsSelf."/lib/track/page.func.php";
require_once $nsSelf."/lib/track/referer.func.php";
require_once $nsSelf."/lib/track/action.func.php";
require_once $nsSelf."/lib/track/query.func.php";
require $nsSelf."/lib/track/define.vars.php";
require_once $nsSys."/system/class/convertcharset/convert_charset.class.php";

if ($Version!=$TrackerVersion) return NS_TRACK_GENERAL::FinishTracking('Wrong tracker version');

if (defined("DEBUG") && DEBUG) $Db->LoggerFunc="nsTrackingSqlStat";    
if (defined("TRACK_ERRORS")&&TRACK_ERRORS &&  !defined("NS_PHP_TRACKING")) $Db->ErrorFunc="nsTrackingSqlError";
$_NS_TRACK_VARS['Db']=&$Db;
$RequestType=1;

//    
$GetVars=&$_NS_TRACK_VARS['GetVars'];
$TimeDblPageLoad=&$_NS_TRACK_VARS['TimeDblPageLoad'];
$TimeDblAdvClick=&$_NS_TRACK_VARS['TimeDblAdvClick'];
$TimeDblSale=&$_NS_TRACK_VARS['TimeDblSale'];
$TimeDblEvent=&$_NS_TRACK_VARS['TimeDblEvent'];


$Ref= NS_TRACK_MISC::V($_GP['ref']);
$ScrRes= NS_TRACK_MISC::V($_GP['wr']);
$FlVer= NS_TRACK_MISC::V($_GP['fl']);
$PxD= NS_TRACK_MISC::V($_GP['px']);
$Frame= NS_TRACK_MISC::V($_GP['frame']);
$PageTitle= NS_TRACK_MISC::V($_GP['title']);
$PageCharset= NS_TRACK_MISC::V($_GP['charset']);
$CurrentCharset=$LangConfig;

$StId=(NS_TRACK_MISC::ValidId($_GP['st']))?$_GP['st']:false; //   
$StTextId=NS_TRACK_MISC::V($_GP['stext']); //   
$Cur=NS_TRACK_MISC::V($_GP['cur']); //    ( )
$CheckCookieId=NS_TRACK_MISC::V($_GP['CheckCookieId']); 
if (NS_TRACK_MISC::V($_COOKIE[NS_COOKIE_PFX.'skip'])) $Skip=true;

//     , 
if ((!$StId&&!$StTextId)||$Skip) return NS_TRACK_GENERAL::FinishTracking('No site id');

//     
$Site=NS_TRACK_GENERAL::GetCurrentSite($StId,$StTextId);

//   ,      ,  
if (!NS_TRACK_MISC::V($Site)) $Skip=true;
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Site not found');
$CompanyId=$Site->COMPANY_ID; 
if (NS_TRACK_GENERAL::CheckStopTracking()) return NS_TRACK_GENERAL::FinishTracking('Tracking stopped');

//  
$Settings=NS_TRACK_MISC::GetSettings($CompanyId, $StId);

//     ,    
$Current=false;
if (isset($_SERVER['HTTP_REFERER'])) $Current=$_SERVER['HTTP_REFERER'];
if ($Cur) $Current=$Cur;
//       ,  
if (!$Current) return NS_TRACK_GENERAL::FinishTracking('No current page');

if (NS_TRACK_DELAYED::DelayedNeeded()) return NS_TRACK_DELAYED::WriteTempLog();

$Item=&$_NS_TRACK_VARS['Item']; //  
$KeepVisPath=NS_TRACK_MISC::SetsByPrior($Settings, "KEEP_VISITOR_PATH"); 
$KeepNoRef=NS_TRACK_MISC::SetsByPrior($Settings, "KEEP_NO_REF"); 
$NoDblPageLoad=NS_TRACK_MISC::SetsByPrior($Settings, "STOP_DBL_PAGE_LOAD"); //   
$TimeDblPageLoad=NS_TRACK_MISC::TimeDblSettings($Settings, "STOP_DBL_PAGE_LOAD", "TIME_DBL_PAGE_LOAD"); 
$NoDblAdvClick=NS_TRACK_MISC::SetsByPrior($Settings, "STOP_DBL_ADV_CLICK"); //   
$TimeDblAdvClick=NS_TRACK_MISC::TimeDblSettings($Settings, "STOP_DBL_ADV_CLICK", "TIME_DBL_ADV_CLICK");
$NoDblEvent=NS_TRACK_MISC::SetsByPrior($Settings, "STOP_DBL_EVENT"); 
$TimeDblEvent=NS_TRACK_MISC::TimeDblSettings($Settings, "STOP_DBL_EVENT", "TIME_DBL_EVENT");  
$Actions=&$_NS_TRACK_VARS['Actions']; //    id  
$UpdateVisPath=&$_NS_TRACK_VARS['UpdateVisPath']; //    ,   , 
//        
$Fraud=&$_NS_TRACK_VARS['Fraud'];

$VarCamp=NS_TRACK_MISC::V($Settings['All']->VAR_CAMPAIGN, "c");
$VarCampSource=NS_TRACK_MISC::V($Settings['All']->VAR_CAMPAIGN_SOURCE, false);
$VarKw=NS_TRACK_MISC::V($Settings['All']->VAR_KW, "kw");
$VarKeyword=NS_TRACK_MISC::V($Settings['All']->VAR_KEYWORD, "k");

if ($Skip)  return NS_TRACK_GENERAL::FinishTracking('no comment 1');

//      
$CurrentPageArr=NS_TRACK_GENERAL::PreparePathAddr($Current);
$RefPageArr=NS_TRACK_GENERAL::PreparePathAddr($Ref,'ref');
if (!$CurrentPageArr)  return NS_TRACK_GENERAL::FinishTracking('Invalid current page');




//       
$HostsArr=NS_TRACK_GENERAL::GetSiteHosts($StId, $Site);
$SiteHostId=NS_TRACK_GENERAL::CurrentSiteHost($HostsArr, $CurrentPageArr, $Site);
if (!$SiteHostId) $Skip=true;
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Unknown host?');

//  id  
$PageId=NS_TRACK_PAGE::GetPageId($CurrentPageArr, $StId);
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('no comment 2 / page id');


//       
$GetVars=NS_TRACK_QUERY::ParseTemplate(NS_TRACK_MISC::V($CurrentPageArr['query']));
$Skip=(NS_TRACK_MISC::ValidId($GetVars[NS_COOKIE_PFX.'skip']))?true:false; //  true,    
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Cookie ns_skip');

//    
$ClickSubId=(NS_TRACK_MISC::ValidId($GetVars[$VarCamp]))?$GetVars[$VarCamp]:0;
if (!$ClickSubId) $ClickSubId=NS_TRACK_CAMPAIGN::GetCampaignBySrc(NS_TRACK_MISC::V($GetVars[$VarCampSource]));
$KeyId=(NS_TRACK_MISC::ValidId($GetVars[$VarKeyword]))?$GetVars[$VarKeyword]:0;
$Keyword=NS_TRACK_REFERER::FindReqKeyword($GetVars,$VarKw);
if ($Keyword) $KeyId=NS_TRACK_REFERER::GetKeywordId($Keyword);

//     referer set    
$RefSet=NS_TRACK_REFERER::GetRefererSet($RefPageArr, $Ref);
//      ?
$QueryId=NS_TRACK_QUERY::GetQueryId($CurrentPageArr['query']);
$PqId=NS_TRACK_PAGE::SetPage2QueryRelation();
// ,    - 
$Actions=NS_TRACK_ACTION::GetActionIds($PageId, $CurrentPageArr);

if (!$KeepNoRef&&$RefSet==0&&!@$_COOKIE[NS_COOKIE_PFX.'log']
    &&$ClickSubId==0&&empty($Actions)) $Skip=true;
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Do not keep visitors without referers');

//  id   !
$VisId=NS_TRACK_VISITOR::GetVisitorId();
if ( (!$VisId&&!$UseBotLog) || $Skip) return NS_TRACK_GENERAL::FinishTracking('No visitor or ignored visitor');

if ($NoDblPageLoad) NS_TRACK_GENERAL::CheckPathDblClick();
if ($NoDblAdvClick) NS_TRACK_GENERAL::CheckAdvDblClick();
if ($NoDblEvent&&!empty($Actions)) NS_TRACK_GENERAL::CheckPathDblClick($TimeDblEvent);
if ($Skip) return NS_TRACK_GENERAL::FinishTracking('Double click protection');

if ($UseBotLog) {
    NS_TRACK_GENERAL::BotLogRecord();
    NS_TRACK_GENERAL::FinishTracking('Found search bot');
}

$Fraud=NS_TRACK_GENERAL::CheckClickFraud($Settings, $VisId, $ClickSubId);

//   
NS_TRACK_GENERAL::UpdateVisitorAction();
//  
if (NS_TRACK_MISC::ValidId($ClickSubId)&&$ClickSubId>0) NS_TRACK_GENERAL::UpdateVisitorClick();
//  ,    
if ($UpdateVisPath||$KeepVisPath) NS_TRACK_GENERAL::UpdateVisitorPath();



if ($CookieLogSet && NS_TRACK_GENERAL::CheckTrackingMode()) $CookieLogSet=false;
if ($CookieLogSet) NS_TRACK_GENERAL::SetCookieLog();
if ($FindLastNode) NS_TRACK_VISITOR::FindLastNode($VisId);

//   
//     
// NS_TRACK_VISITOR::UpdateByRegs();


if (defined("TRACK_ERRORS")&&TRACK_ERRORS &&  !defined("NS_PHP_TRACKING") 
    && !empty($_SESSION['__Errors']) && !NS_TRACKER_DELAYED) {
    foreach ($_SESSION['__Errors'] as $Error) {
        $Db->Query("INSERT INTO track_error (ERROR) VALUES (?)",$Error);
    }
}

return NS_TRACK_GENERAL::FinishTracking('We are watching you :)');
?>