

function initTabs(tabId, tableId, options) {
    if (!options) options = {};
    $(document).ready(function() {
        var tbl = $('#'+tableId);
        var def = false;
        var selected = false;
        $('li', '#'+tabId).each(function() {
            if (!this.id) return true;
            if (!def) def = this.id;
            var t = $(this);
            if ( t.hasClass('InnerTabSelected') ) selected = this.id;
            if (!t.hasClass('InnerTabDisabled')) t.click(function() { switchTab( this.id, tableId, options ); });
        });
        switchTab( (selected ? selected : def) , tableId, options);
        if (options.initCallback) options.initCallback();
    });
}

function switchTab(tabId, tableId, options) {
    if (!tabId) return false;
    if (!options) options = {};
    var t = $('#'+tabId);
    if (t.hasClass('InnerTabDisabled') || t.hasClass('InnerTabSpacer')) return false;
    $('li', t.parent()).each(function() {
        if (!this.id) return true;
        var ct = $(this);
        ct.removeClass('InnerTabSelected');
        $('#b'+this.id, '#'+tableId).hide();
    });
    $('#'+tabId).addClass('InnerTabSelected');
    $('#b'+tabId, '#'+tableId).show();
    if (options.switchCallback) options.switchCallback(tabId); 
}