<?
if (!defined('NS_TRACKER_INDEX')) exit;
extract(VPack(array('SiteId', 'ActData')));

require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/lib/reports/misc.func.php";

$Range['Today']=GetDateFromPeriod('0-d-0', true);
$Range['Yesterday']=GetDateFromPeriod('1-d-0', true);
$Range['ThisWeek']=GetDateFromPeriod('0-w-0', true);
$Range['LastWeek']=GetDateFromPeriod('1-w-0', true);
$Range['ThisMonth']=GetDateFromPeriod('0-m-0', true);
$Range['LastMonth']=GetDateFromPeriod('1-m-0', true);

$TodayEnd = UserDate().' 23:59:59';
$Range['Today']['EndDate'] = $TodayEnd;
$Range['ThisWeek']['EndDate'] = $TodayEnd;
$Range['ThisMonth']['EndDate'] = $TodayEnd;


$ReportName = $SiteId ? @$CommonSiteList[$SiteId]->HOST.': ' : '';
//$ReportName = '';
$Data = array();
$Query = '';

$Tmp = explode(',', @$nsUser->ACTIVITY_ORDER);
$Pinned = in_array($ActData.$SiteId, $Tmp) ? 1 : 0;

if ($ActData == 'pv') {
    $ReportName .= $Lang['RHeaderPV'];
    $Query = "SELECT COUNT(S_LOG.ID) AS CNT FROM ?_{$CpId}_stat_log S_LOG WHERE STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'uni') {
    $ReportName .= $Lang['RHeaderVisitor'];
    $Query = "SELECT COUNT(DISTINCT VISITOR_ID) AS CNT FROM ?_{$CpId}_stat_log S_LOG WHERE STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'vis') {
    $ReportName .= $Lang['RHeaderVisits'];
    $Query = "SELECT  COUNT(DISTINCT SESS_LOG.SESSION_ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_LOG.ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'clk') {
    $ReportName .= $Lang['RHeaderClick'];
    $Query = "SELECT COUNT(S_LOG.ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_click S_CLICK ON S_CLICK.LOG_ID = S_LOG.ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'sale') {
    $ReportName .= $Lang['RHeaderSale'];
    $Query = "SELECT COUNT(S_LOG.ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_sale S_SALE ON S_SALE.LOG_ID = S_LOG.ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'act') {
    $ReportName .= $Lang['RHeaderAction'];
    $Query = "SELECT COUNT(S_LOG.ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_action S_ACTION ON S_ACTION.LOG_ID = S_LOG.ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'new') {
    $ReportName .= $Lang['RHeaderNew'];
    $Query = "SELECT COUNT(DISTINCT S_LOG.VISITOR_ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_LOG.ID
        INNER JOIN ?_{$CpId}_stat_session SESS ON SESS.ID=SESS_LOG.SESSION_ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end AND SESS.FIRST_SESSION = '1' ";
}

if ($ActData == 'ret') {
    $ReportName .= $Lang['RHeaderReturn'];
    $Query = "SELECT COUNT(DISTINCT S_LOG.VISITOR_ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_LOG.ID
        INNER JOIN ?_{$CpId}_stat_session SESS ON SESS.ID=SESS_LOG.SESSION_ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end AND SESS.FIRST_SESSION = '0' ";
}

if ($ActData == 'saleconv') {
    $ReportName .= $Lang['RHeaderSaleConv'];
    $Query = "SELECT (100/COUNT(DISTINCT S_LOG.VISITOR_ID)) * COUNT(DISTINCT SESS.VISITOR_ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        LEFT JOIN ?_{$CpId}_stat_sale S_SALE ON S_SALE.LOG_ID = S_LOG.ID
        LEFT JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_SALE.LOG_ID
        LEFT JOIN ?_{$CpId}_stat_session SESS ON SESS.ID=SESS_LOG.SESSION_ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'actconv') {
    $ReportName .= $Lang['RHeaderActConv'];
    $Query = "SELECT (100/COUNT(DISTINCT S_LOG.VISITOR_ID)) * COUNT(DISTINCT SESS.VISITOR_ID) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        LEFT JOIN ?_{$CpId}_stat_action S_ACTION ON S_ACTION.LOG_ID = S_LOG.ID
        LEFT JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_ACTION.LOG_ID
        LEFT JOIN ?_{$CpId}_stat_session SESS ON SESS.ID=SESS_LOG.SESSION_ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'avgvis') { //     
    $ReportName .= $Lang['RHeaderAvgVis'];
    $Query = "SELECT  
        (COUNT(DISTINCT SESS_LOG.SESSION_ID) / COUNT(DISTINCT S_LOG.VISITOR_ID)) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_LOG.ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'avgpv') { //      
    $ReportName .= $Lang['RHeaderAvgPv'];
    $Query = "SELECT  
        (COUNT( S_LOG.ID ) / COUNT(DISTINCT S_LOG.VISITOR_ID)) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_LOG.ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}

if ($ActData == 'avgpvvis') { //      
    $ReportName .= $Lang['RHeaderAvgPvVis'];
    $Query = "SELECT  
        (COUNT( S_LOG.ID ) / COUNT( DISTINCT SESS_LOG.SESSION_ID)) AS CNT
        FROM ?_{$CpId}_stat_log S_LOG
        INNER JOIN ?_{$CpId}_stat_session_log SESS_LOG ON SESS_LOG.LOG_ID=S_LOG.ID
        WHERE S_LOG.STAMP BETWEEN ?start AND ?end";
}



if ($SiteId) $Query .= " AND S_LOG.SITE_ID = ?site ";
foreach ($Range as $k=>$r) {
    $Data[$k]=$Db->Select($Query, false, array(
        'start'=>$Db->ReturnValue("SELECT DATE_FORMAT(DATE_ADD(?, INTERVAL ? HOUR_MINUTE), '%Y-%m-%d %H:%i:%s')", 
                                                         $r['StartDate'], $nsUser->_SQL_TZ), 
        'end'=>$Db->ReturnValue("SELECT DATE_FORMAT(DATE_ADD(?, INTERVAL ? HOUR_MINUTE), '%Y-%m-%d %H:%i:%s')", 
                                                         $r['EndDate'], $nsUser->_SQL_TZ), 
        'site'=>$SiteId
        ));
    if (  in_array($ActData, array('actconv', 'saleconv')) ) $Data[$k]->CNT = round($Data[$k]->CNT, 2).'%';
    elseif ( in_array($ActData, array('avgvis','avgpv','avgpvvis')))  $Data[$k]->CNT = round($Data[$k]->CNT, 2);
    else $Data[$k]->CNT = number_format($Data[$k]->CNT, ',');
}



include $nsTemplate->Inc('client_page/activity.inc');
exit;
?>