<?

$RData = new ReportData();
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->ShowNoRecords = true;
$RData->Id = 'lact';

$RData->ColumnOrder = array('Stamp','Path','Visitor','Action','ActionItem');
$RData->AddColumn('Stamp', $Lang['Time'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Path', $Lang['Page'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Visitor', $Lang['Visitor'], false, false, array('NoFormat'=>true));;
$RData->AddColumn('Action', $Lang['Action'], false, false, array('NoFormat'=>true));
$RData->AddColumn('ActionItem', $Lang['ActionItem'], false, false, array('NoFormat'=>true));

$RData->TopCaption = $Lang['LastActions'];
$RData->RefreshLink = 'javascript:;';
$RData->RefreshJs = "loadDashReport('LastActions', '".getURL('client_page','Mode=lastaction&ax=1')."', '{$RData->Id}')";
$RData->CloseLink = 'javascript:;';
$RData->CloseJs = "$('#Report_{$RData->Id}').hide(); $('#SpacerLarge', '#Caption_{$RData->Id}').hide(); $('#close{$RData->Id}, #goto{$RData->Id}').hide(); ";
$RData->GotoLink = getURL('logs','Mode=Action&CpId='.$CpId,'report');


$Now = gmdate("Y-m-d H:i:s", time());
$Query = "SELECT DATE_FORMAT(DATE_ADD('$Now', INTERVAL -7 DAY), '%Y-%m-%d %H:%i:%s')";
$FromStamp = $Db->ReturnValue($Query);

$Query = "
    SELECT
    S_LOG.ID,
    UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS STAMP,
    (TO_DAYS(DATE_ADD(?now, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) - 
        TO_DAYS(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE))) AS NOT_TODAY,
    
    S_LOG.VISITOR_ID, I.IP, CV.NAME AS VISITOR_NAME,
    VA.NAME AS ACTION_NAME,
    AI.NAME AS ACTION_ITEM,
    SP.PATH, Q.QUERY_STRING, SH.HOST

    FROM ?_{$CpId}_stat_action S_ACTION
    INNER JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.ID=S_ACTION.LOG_ID

    INNER JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
    INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
    INNER JOIN ?_ip I ON I.ID=S_LOG.IP_ID
    INNER JOIN ?_visitor_action VA ON VA.ID=S_ACTION.ACTION_ID

    INNER JOIN ?_site_page SP ON SP.ID=S_LOG.PAGE_ID
    LEFT JOIN ?_query Q ON Q.ID=S_LOG.QUERY_ID

    LEFT JOIN ?_action_set ASET ON ASET.STAT_ACTION_ID=S_ACTION.ID AND ASET.COMPANY_ID=?cp
    LEFT JOIN ?_action_item AI ON AI.ID=ASET.ACTION_ITEM_ID AND AI.COMPANY_ID=?cp

    LEFT JOIN ?_client_visitor CV ON CV.VISITOR_ID=S_LOG.VISITOR_ID AND CV.COMPANY_ID=?cp
    
    WHERE S_LOG.STAMP > ?stamp
    ORDER BY S_LOG.STAMP DESC
    LIMIT 10
";
$Sql = new Query($Query,false,array('cp'=>$CpId,'now'=>$Now,'stamp'=>$FromStamp));
while ($Row=$Sql->Row()) {
    $Row->VISITOR_NAME=htmlspecialchars(stripslashes($Row->VISITOR_NAME));
    if ($Row->NOT_TODAY == 0) $Arr['Stamp'] = _date($Row->STAMP,'time');
    if ($Row->NOT_TODAY == 1) $Arr['Stamp'] = $Lang['Yesterday'].', '._date($Row->STAMP,'time');
    if ($Row->NOT_TODAY > 1) $Arr['Stamp'] = _date($Row->STAMP,'datetime');
    $Arr['Visitor']= $Row->VISITOR_NAME? $Row->VISITOR_NAME : $Row->IP;
    $Arr['Action'] = $Row->ACTION_NAME;
    $Arr['ActionItem'] = $Row->ACTION_ITEM;
    $Arr['Path'] = 'http://'.$Row->HOST.$Row->PATH;
    if ($Row->QUERY_STRING) $Arr['Path'].='?'.$Row->QUERY_STRING;
    $Arr['Link_Path']=$Arr['Path'];
    $Arr['Path'] = RefCut($Arr['Path']);
    $Arr['Link_Visitor'] = getURL('visitor_path', "CpId=$CpId&VisId={$Row->VISITOR_ID}&ViewDate=".date("Y-m-d",$Row->STAMP), 'report');

    $RData->AddRow($Arr);
}

$RData->CheckExport();
$RData->HtmlDump();
exit;
?>