<?

function ExportParams( $Params ) {
    global $Lang, $CpId, $nsProduct, $Db, $nsLang;

    $ExportParams = array();

    if (empty($Params)) return $ExportParams;
    if (!$CpId) $CpId = @$Params['CpId'];
    if (!$CpId) return $ExportParams;

    if (!empty($Params['ReportValues'])) {
        $ExportParams['ReportPath']='';
        $i=0;
        foreach ($Params['ReportValues'] as $k=>$v) {
            if ($i>0) $ExportParams['ReportPath'] .= ' / ';
            $ExportParams['ReportPath'] .= $v;
            $i++;
        }
        if (@$Params['Name']) {
            $ExportParams['ReportPath'] .= ' / '.$Params['Name'];
        }
    }

    $URL = false;
    if (@$Params['URL']) $URL = $Params['URL'];
    else switch (@$Params['Mode']) {
        case 'PAID':
            if (@$Params['CacheId']) {
                $URL = getURL('paid_constructor', "CpId=$CpId&CacheId={$Params['CacheId']}", 'report');
            }
            break;
        case 'NATURAL':
            if (@$Params['CacheId']) {
                $URL = getURL('natural_constructor', "CpId=$CpId&CacheId={$Params['CacheId']}", 'report');
            }
            break;
        case 'Clicks':
        case 'Sales':
        case 'Split':
        case 'Fraud':
        case 'Hits':
        case 'Actions':
        case 'Ref':
        case 'Key':
            $URL = getURL('logs', "CpId=$CpId&Mode={$Params['Mode']}", 'report');
            break;
        case 'SPLIT' AND @$Params['SplitId']:
            $URL = getURL('split_test', "CpId=$CpId&SplitId={$Params['SplitId']}", 'report');
            break;
    }
    if ($URL) $ExportParams['URL'] = $URL;

    if (@$Params['StartDate'] || @$Params['EndDate']) {
        $ExportParams['Period'] = '';
        if (@$Params['StartDate']) $ExportParams['Period'] .= $Lang['from'].' '._date($Params['StartDate']);
        if (@$Params['EndDate']) $ExportParams['Period'] .= $Lang['till'].' '._date($Params['EndDate']);
    }

    if ( (@$Params['SiteId'] && intval($Params['SiteId']) > 0) || @$Params['Site']) {
        $ExportParams['Site'] = '';
        if (@$Params['Site']) $ExportParams['Site'] .= $Params['Site'];
        else $ExportParams['Site'] .= $Db->ReturnValue('SELECT HOST FROM ?_site WHERE ID=?', $Params['SiteId']);
    }

    if (@$Params['Filter']) {
        $ExportParams['Filter'] = ''.$Params['Filter'];
    }

    if (isset($Params['TrafficMode'])) {
        $ExportParams['TrafficType'] = $Lang['TrafficMode'.@$Params['TrafficMode']];
    }

    return $ExportParams;
}

?>