<?$PageTitle=$Lang['Title']?>
<?include $nsTemplate->Inc("inc/header");?>
<?include $nsTemplate->Inc("inc/submenu");?>
<link rel="stylesheet" href="<?=FileLink("css/dashboard.css")?>" />
<link rel="stylesheet" href="<?=FileLink("css/report.css")?>" />


<table class='DashTable'><tr>
<td valign=top class='DashLeftColumn DashLeftEmpty' style="background: url('<?=FileLink('images/bg_settings.gif')?>') no-repeat;">

</td>
<td valign=top class='DashMainColumn'>

<?if ($nsUser->ADMIN||($nsUser->MERCHANT&&$nsUser->SUPER_USER)) {?>

    <div class=ReportTopCaption><span><?=$Lang['AdmAcc']?></span></div>
    <div class=ReportListBlock>
    
    <?if ($nsUser->ADMIN&&$nsProduct->LICENSE==3) {?>
    <div class='DashReportRow'>
    <a href="<?=getURL("company", "", "admin")?>"><?=$Lang['AdmClnt']?></a>
    </div>
    <?}?>
    
    <?if ($nsUser->MERCHANT||$nsProduct->LICENSE!=3) {?>
    <div class='DashReportRow'>
    <a href="<?=getURL("company", "EditId=".$nsUser->COMPANY_ID, "admin")?>"><?=$Lang['ClientEdit']?></a>
    </div>
    <?}?>
    
    <?if ($nsUser->ADMIN||$nsUser->SUPER_USER) {?>
    <div class='DashReportRow'>
    <a href="<?=getURL("users", "Mode=users", "admin")?>"><?=$Lang['AdmUsers']?></a>
    </div>
    <?}?>
    
    <?if ($nsUser->ADMIN) {?>
    <div class='DashReportRow'>
    <a href="<?=getURL("users", "Mode=admins", "admin")?>"><?=$Lang['AdmAgents']?></a>
    </div>
    <?}?>
    
    </div>
    <div id=SpacerLarge></div>
<?}?>

<?if ($nsUser->ADMIN||($nsUser->SUPER_USER&&$nsProduct->LICENSE!=3)) {?>
    
    <div class=ReportTopCaption><span><?=$Lang['ProgramSets']?></span></div>
    <div class=ReportListBlock>
    <div class='DashReportRow'>
    <a href="<?=getURL("misc_config","","admin")?>"><?=$Lang['GeneralSets']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("cron","","admin")?>"><?=$Lang['CronSettings']?></a>
    </div>           
    <div class='DashReportRow'>
    <a href="<?=getURL("cache","","admin")?>"><?=$Lang['CacheSettings']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("removal","","admin")?>"><?=$Lang['DeleteSettings']?></a>
    </div>                   
    <div class='DashReportRow'>
    <a href="<?=getURL("archiving","","admin")?>"><?=$Lang['ArchiveSettings']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("license","","admin")?>"><?=$Lang['LicenseKeys']?></a>
    </div>           
    <?if ($UpdatesAvailable>0) {?>
    <div class='DashReportRow'>
    <a href="<?=getURL("update","","admin")?>"><?=$Lang['Updates']?></a>
    </div>
    <?}?>
    <?if ($nsProduct->LICENSE!=1) {?>
    <div class='DashReportRow'>
    <a href="<?=getURL("versioncheck","","admin")?>"><?=$Lang['CheckUpdates']?></a>
    </div>                
    <?}?>
    </div>
    <div id=SpacerLarge></div>            
<?}?>


<?if (($nsProduct->LICENSE!=3&&$nsUser->SUPER_USER)||$nsUser->ADMIN) {?>
    
    <div class=ReportTopCaption><span><?=$Lang['BaseStruct']?></span></div>
    <div class=ReportListBlock>    

    <div class='DashReportRow'>
    <a href="<?=getURL("natural_host", "", "admin")?>"><?=$Lang['NaturalHosts']?></a>
    </div>    
    <div class='DashReportRow'>
    <a href="<?=getURL("user_agent", "", "admin")?>"><?=$Lang['UserAgents']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("base_stat", "", "admin")?>"><?=$Lang['Database']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("ip_ignore", "", "admin")?>"><?=$Lang['IpIgnore']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("xml", "", "admin")?>"><?=$Lang['ImportXml']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("visit_length", "", "admin")?>"><?=$Lang['VisitLength']?></a>
    </div>
    
    </div>
    <div id=SpacerLarge></div>    
<?}?>

<?if ($nsUser->ADMIN&&$nsProduct->LICENSE==3) {?>
    
    <div class=ReportTopCaption><span><?=$Lang['TrackSets']?></span></div>
    <div class=ReportListBlock>
    <div class='DashReportRow'>
    <a href="<?=getURL("stat_config","","admin")?>"><?=$Lang['CatchSets']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("stat_dbl_click","","admin")?>"><?=$Lang['DblClickSets']?></a>
    </div>            
    </div>
    <div id=SpacerLarge></div>        
<?}?>


<?if ($nsUser->ADMIN||($nsUser->SUPER_USER&&$nsProduct->LICENSE!=3)) {?>
    
    <div class=ReportTopCaption><span><?=$Lang['AdminLogs']?></span></div>
    <div class=ReportListBlock>
    <div class='DashReportRow'>
    <a href="<?=getURL("cron_log","","admin")?>"><?=$Lang['CronLog']?></a>
    </div>                   
    <div class='DashReportRow'>
    <a href="<?=getURL("removal_log","","admin")?>"><?=$Lang['DeleteLog']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("archive_log","","admin")?>"><?=$Lang['ArchiveLog']?></a>
    </div>
    <div class='DashReportRow'>
    <a href="<?=getURL("email_log","","admin")?>"><?=$Lang['EmailLog']?></a>
    </div>               
    <div class='DashReportRow'>
    <a href="<?=getURL("cron_monitor","","admin")?>"><?=$Lang['CronProcesses']?></a>
    </div>           
    </div>
<?}?>

</td></tr></table>


<?include $nsTemplate->Inc("inc/footer");?>