
<?if (!$List) {?>
<script>
var intv = false
var stopUpdate =false

function updateList() {
    if (stopUpdate) return false
    loadURL('ProcessList', '<?=getURL('cron_monitor', 'List=1')?>')
}

function cancelTask(id) {
    stopUpdate = true
    requestURL('<?=getURL('cron_monitor', "CancelId=")?>'+id, showGlobalLoading, function() {
        hideGlobalLoading()
        stopUpdate = false
        updateList()
    })
}

function finishProcess(id) {
    stopUpdate = true
    if (!confirm('<?=$Lang['YouSure']?>')) { stopUpdate = false; return false; }
    requestURL('<?=getURL('cron_monitor', "StopId=")?>'+id, showGlobalLoading, function() {
        hideGlobalLoading()
        stopUpdate = false
        updateList()
    })
}

$(document).ready(function() {
        intv = window.setInterval(updateList, 10000)
        updateList()
})
</script>
<link rel="stylesheet" href="<?=FileLink("css/report.css")?>" />
<style>
.LogHeader { font-weight:bold; border-bottom:2px solid #444; border-left:1px solid #444; }
.LogHeaderFirst { border-left:0px; }
.LogRow { border-bottom:1px solid #444; border-left:1px solid #444; }
.LogRowFirst { border-left:0px; }
.LogRowUnfinished td { background:#fef8ba }
</style>

<table width=50% cellpadding=0 cellspacing=0 border=0 align=center>
<tr><td id='ProcessList'>


</td></tr>
</table>
<?} else {?>

<?if (!empty($Tasks)) {?>
    <table width=100% cellpadding=4 cellspacing=0 border=0>
    <tr>
    <td class='LogHeader LogHeaderFirst' width=33%><?=$Lang['CurrentTask'] ?></td>
    <td class=LogHeader width=34%><?=$Lang['Description']?></td>
    <td class=LogHeader width=33%>&nbsp;</td>
    </tr>
    <?foreach ($Tasks as $Row) {?>
    <tr>
    <td class='LogRow LogRowFirst'><?=$Lang[$Row->TASK_TYPE]?></td>
    <td class=LogRow><?=$Row->DESCRIPTION?></td>
    <td class=LogRow>
    <?if (!$Row->IN_PROGRESS) {?><input type=button onclick="cancelTask(<?=$Row->ID?>)" value="<?=$Lang['CancelTask']?>"><?}
    else {?><?=$Lang['InProgress']?><?}?>
    </td>
    </tr>
    <?}?>    
    </table>
    <br>
<?}?>

<table width=100% cellpadding=4 cellspacing=0 border=0>
<tr>
<td class='LogHeader LogHeaderFirst' width=25%><?=$Lang['Time']?></td>
<td class=LogHeader width=25%><?=$Lang['ProcessType']?></td>
<td class=LogHeader width=25%><?=$Lang['RunTime']?></td>
<td class=LogHeader width=25%><?=$Lang['Finished']?></td>
</tr>
<?foreach ($Proc as $Row) {?>
<tr <?=$Row->FINISHED?'':' class="LogRowUnfinished" '?>>
<td class='LogRow LogRowFirst'><?=_date($Row->STAMP, 'datetime')?></td>
<td class=LogRow><?=$Lang[$Row->TASK]?></td>
<td class=LogRow>
<?if ($Row->RUN_TIME>0) {
        if (V($Row->TimeArr['h'])) echo $Row->TimeArr['h'].'h ';
        if (V($Row->TimeArr['m'])) echo $Row->TimeArr['m'].'m ';
        if (V($Row->TimeArr['s'])) echo $Row->TimeArr['s'].'s ';
} else echo $Lang['Unknown'];
?>
</td>
<td class=LogRow>
<?if ($Row->FINISHED) {?><?=$Lang['Yes']?><?} 
    elseif ($Row->TO_STOP) {?><?=$Lang['Waiting']?><?}
    else {?><input type=button onclick="finishProcess(<?=$Row->ID ?>)" value="<?=$Lang['Finish']?>"><?}?>
</td>
</tr>
<?}?>
</table>
    
<?}?>