
function saveUserChoice(mode) {
    var reqUrl=cacheParams.cacheURL+"&SetUpdateCacheMode="+mode+
                "&UserId="+cacheParams.userId+
                "&FunnelId="+cacheParams.funnelId
    requestURL(reqUrl)
}

function getCheck(args) {
    if (typeof(args.realTime) != 'undefined' && args.rValue != 1) return showPrepareFailed()
    if (args.rValue == 1) location.reload()
    else {
        cacheParams.greenLight = true
        if (!cacheParams.runByAjax || cacheParams.cronOnly == 1) 
            intv = window.setTimeout(checkCache, 5000)
    }
}

function showPrepareFailed() {
    $('#WaitCron, #WaitAjax').hide()
    $('#PrepareFailed, #WhatToDoForm').show()
}

function checkCache() {
    if (!cacheParams.greenLight) return false
    reqUrl=cacheParams.cacheURL+"&CheckCacheId="+cacheParams.cacheId+
            "&Add="+cacheParams.addHash+
            "&FunnelId="+cacheParams.funnelId
    requestURL(reqUrl,false,function(data) {
        getCheck({rValue:data})
    })
    cacheParams.greenLight = false
    keepAttention()
}

function keepAttention() {
    return
    _('WaitCron').innerHTML += "."
    _('WaitAjax').innerHTML += "."
}

function runCache() {
    var reqUrl=cacheParams.cacheURL+"&DoCacheId="+cacheParams.cacheId+
                "&UserId="+cacheParams.userId+"&Add="+cacheParams.addStr+
                "&FunnelId="+cacheParams.funnelId
    requestURL(reqUrl,false,function(data) {
        getCheck({rValue:data,reaTime:true})
    })
}

function setOk(rValue) {
    if (rValue != 1) updateCache()
    else {
        if (cacheParams.runByAjax && cacheParams.cronOnly != 1) runCache()
        else checkCache()
    }
}

function preUpdateCache() {
    if (cacheParams.updateCacheMode == 0) {
        $('#WhatToDoForm').show()      
        $('#WaitAjax, #WaitCron, #PrepareFailed').hide()
        $('#CacheCheckDiv').toggle()   
        return
    }
    runPrepare(cacheParams.updateCacheMode)
}

function updateCache() {
    var reqUrl=cacheParams.cacheURL+"&SetToCache="+cacheParams.cacheId+
                       "&UserId="+cacheParams.userId+
                       "&CustomReportId="+cacheParams.customReportId+
                       "&ReportId="+cacheParams.reportId+
                       "&FunnelId="+cacheParams.funnelId+
                       "&Add="+cacheParams.addStr+"&AddHash="+cacheParams.addHash
    requestURL(reqUrl,false,setOk)
    $('#CacheCheckDiv').show()
}

function runPrepare(action) {
    if (!action) action = $("#WhatToDo").val()

    if (cacheParams.cronOnly == 1) action = 1
    else setUpdateCacheCookie(action)

    if (action == 1) { //    
        $('#CacheCheckDiv, #WaitCron').show()
        $('#WaitAjax, #WhatToDoForm, #PrepareFailed').hide()           
        updateCache()
    }
    if (action == 2) {
        if (typeof(customAjaxFunction) != 'undefined') customAjaxFunction()
        else { //   
            $('#CacheCheckDiv, #WaitAjax').show()
            $('#WaitCron, #WhatToDoForm, #PrepareFailed').hide()        
            runCache()
        }
    }
    //    
    if (_('DontAsk').checked) saveUserChoice(action)
}

function setUpdateCacheCookie(value) {
    expires = new Date()
    expires.setSeconds(expires.getSeconds()+31536000)
    setCookie(cacheParams.cacheUpdateCookieName,value,expires,'/')
}

