<?
# ============================================================================
#
#                        ___
#                    ,yQ$SSS$Q,      ,yQQQL
#                  j$$"`     `?$'  ,d$P"```$$,
#           i_L   I$;            `$`       `$$,
#                                 `          I$$
#           .yQ$$$$,            ;        _,d$$'
#        ,d$$P"^```?$b,       _,'  ;  ,d$$P"`
#     ,d$P"`        `"?$$Q#QP`    $d$$P"`
#   ,$$"         ;       ``       ;$?'
#   $$;        ,dI                I$;
#   `$$,    ,d$$$`               j$I
#     ?$S#S$P'j$'                $$;         Copyright (c) Stuffed Guys
#       `"`  j$'  __....,,,.__  j$I              www.stuffedguys.com
#           j$$"``           ',$$
#           I$;               ,$$'
#           `$$,         _.u$$`
#             "?$$Q##Q$$SP"^`
#                `````
#

class nsLang{
	var $CurrentLang;// current language for this page.
	var $_LangList;// the variable for list of languages
	var $htmlTagArguments = '';

	function nsLang()
    {
		global $DefLangFile;
		$this->CurrentLang($DefLangFile);	
    }

	function GetList(){
        global $nsProduct;
        if(!empty($this->_LangList)) return $this->_LangList;

        // unpacking the query get vars:
        $querystr=$nsProduct->SelfAction();
		foreach ($_GET as $GName=>$GValue){
			if(!in_array($GName,array('RequestPath','lsave','lang','action','sc','prd')))
					$querystr .=	$GName.'='.$GValue.'&';
		}

		$langd = dir($this->Path());
		while (false !== ($entry = $langd->read())) {
		    if(!strpos($entry, '.lang.php') || is_dir($this->Path().$entry)) continue;
		    $Row['name'] = str_replace('.lang.php', '', $entry);		
            $Row['path'] = $this->Path(). '/'. $Row['name'].'/';
			$Row['req'] = $Row['path'].'_system/'.$Row['name'].'.config.php';
            $CLangs[]=$Row;			
		}
        $langd->close();        

        foreach ($CLangs as $i=>$Row) {
            require $Row['req'];
            $Row['caption'] = $LangConfig['name'];
            $Row['charset'] = $LangConfig['charset'];
            $Row['url'] = $querystr.'lang='.$Row['name'];
            $CLangs[$i]=$Row;
        }

		if (empty($CLangs)){ // no languages found - but we have to return something:
            $CLangs[]=array('name'=>'','path'=>'','caption'=>'','charset'=>'','url'=>'');
		}
		return $this->_LangList=$CLangs;
	}

    function SystemInc() {
        global $nsProduct, $DefLangFile, $Lang;
        $retsys = SYS.'/system/lang/'.$this->CurrentLang.'.lang.php';
        // I am not sure that chosen language exists inside the
        // system - but only in this product            
        $retsys = file_exists($retsys) ? $retsys : SYS.'/system/lang/'.$DefLangFile.'.lang.php'; 
        require($retsys);       
    }
    
    function GeneralInc() {
        global $nsProduct, $DefLangFile, $Lang;
        $retprod = SELF.'/lang/'.$this->CurrentLang.'.lang.php';
        $retdefprod = SELF.'/lang/'.$DefLangFile.'.lang.php';
        $retval = file_exists($retprod) ? $retprod : (file_exists($retdefprod)? $retdefprod : false);
        if (@$retval) require($retval);
    }

	/**
	* @return void
	* @desc includes file that contains
	* additional cells for the array "$Lang". Exactly for the current
	* product. If nsProduct was not constructed yet - includes
	* the file for the inner system
	*/
	function Inc($def=false){		
		global $nsProduct, $DefLangFile, $Lang;
				
		if (isset($nsProduct->Action)){
			$retprod = SELF.'/lang/'.$this->CurrentLang.'/'.$nsProduct->Section.'.'.$nsProduct->Action.'.php';
			$retdefprod = SELF.'/lang/'.$DefLangFile.'/'.$nsProduct->Section.'.'.$nsProduct->Action.'.php';
			$retval = file_exists($retprod) ? $retprod : (file_exists($retdefprod)? $retdefprod : false);
        }

		if (@$retval) require($retval);
	}

	function IncConfig(){
		global $LangConfig;
		require(SELF.'/lang/'.$this->CurrentLang.'/_system/'.$this->CurrentLang.'.config.php');

		if (isset($LangConfig['dir']) && !empty($LangConfig['dir'])) {
			$this->htmlTagArguments = 'dir="'.$LangConfig['dir'].'"';
		}		
	}

	function ReturnConfig($Lang)
	{
		$LangConfig=array();
		require(SELF."/lang/$Lang/_system/$Lang.config.php");
		return $LangConfig;
	}

	/**
	* @return void
	* @param string $file
	* @desc Include for use within nsTemplate's "Inc()"
	*/
	function TplInc($file, $def=false){
		global $DefLangFile, $Lang, $nsProduct;
		if($def) { 	$tmpcur = $this->CurrentLang; $this->CurrentLang = $DefLangFile;	}	
		$incf = SELF.'/lang/'.$this->CurrentLang.'/'.$file.'.php';
		if(!$def) $this->TplInc($file, true);
		if (file_exists($incf)) require($incf);	
		if ($def) $this->CurrentLang = $tmpcur;
	}

	function TplReturn($file, $def=false)
	{
		global $DefLangFile,$nsProduct;
		$Lang=array();
		if($def) { 	$tmpcur = $this->CurrentLang; $this->CurrentLang = $DefLangFile;	}	
		$incf = SELF.'/lang/'.$this->CurrentLang.'/'.$file.'.php';
		if (file_exists($incf)) { require($incf); return $Lang;	}
        return array();	
	}

	function InitLang($L = ''){
		if(!empty($L))	$this->CurrentLang($L);
	}

	function CurrentLang($L){
		global $nsSession;
		$this->CurrentLang = $L;		
		if(!empty($nsSession)) $nsSession->set('ns_lang_current', $L);		
	}

	function Path() {
			return SELF.'/lang';
	}

	/**
	* @return void
	* @param filename $file
	* @desc Includes the specific file from the current language directory
	*/
	function IncFile($file){
		global $Lang;
		require($this->Path().'/'.$this->CurrentLang.'/'.$file);
	}
};
?>