<?

//////////////////////////
/*
     
$Table -   
$ByField -   .   POSITION
$Where -  
$Direction -  = 1,     0 -   
 $Direction != 1,    1,    .
*/

function ResortTable($Table, $ByField=false, $Where = false, $Direction = false)
{
	if (!$Table) return false;
	global $Db;
	if (!$ByField) $ByField="POSITION";
	if ($Where) $Where = "WHERE ".$Where;

	if ($Direction == 1) {
		$Query = "SELECT MAX($ByField) AS MAX_POS FROM $Table";
		$Check = $Db->Select($Query);
		$MaxPos = $Check->MAX_POS+1;
	}

	$Query = "SELECT ID, $ByField FROM $Table $Where ORDER BY $ByField ASC";
	$Sql = new Query($Query);
	while ($Row = $Sql->Row())
	{
		if ($Row->$ByField == 0 && $Direction == 1 && $MaxPos) {
			$Query = "UPDATE $Table SET $ByField = ? WHERE ID = ?";
			$Db->Query($Query,$MaxPos,$Row->ID);
		}
		if ($Row->$ByField != $Sql->Position+1) {
			if ($Direction == 1 && $Row->$ByField == 0) continue;
			$Query = "UPDATE $Table SET $ByField = ? WHERE ID = ?";
			$Db->Query($Query,$Sql->Position+1,$Row->ID);
		}
	}
}

//////////////////////////
/*
      
$Table -   
$ByField -   .   POSITION
$Id - ID   
$To -  - "Up"  "Down",       , 
     
$Where -  
*/

function SortTable($Table, $ByField=false, $Id, $To, $Where = false)
{
	if (!$Table || !$Id || !$To) return false;
	if ($To != "Up" && $To != "Down") return false;
	global $Db;
	if (!$ByField) $ByField="POSITION";
	if ($Where) $WhereStr = " AND ".$Where;
	else $WhereStr="";

	$Query = "SELECT ID, $ByField FROM $Table WHERE ID = ?";
	$El1 = $Db->Select($Query,false,$Id);
	if ($To=="Up") $Pos2 = $El1->POSITION - 1;
	if ($To=="Down") $Pos2 = $El1->POSITION + 1;
	$Query = "SELECT ID, $ByField FROM $Table WHERE POSITION = ? $WhereStr";
	$El2 = $Db->Select($Query,false,$Pos2);
	$Query = "UPDATE $Table SET $ByField = ? WHERE ID = ?";
	$Db->Query($Query,$Pos2,$El1->ID);
	$Query = "UPDATE $Table SET $ByField = ? WHERE ID =?";
	$Db->Query($Query,$El1->POSITION,$El2->ID);
	ResortTable($Table, $ByField, $Where);
}

?>