<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==3&&!$nsUser->ADMIN) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE!=3&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");

$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$Lang['Title'];
$ProgPath[1]['Url']=getURL("cron", "", "admin");
$MenuSection="admin";

require_once SELF."/lib/reports/create_cache.func.php";

$CronStr="php -q ".SELF."/index.php sc=cron action=default";

$EditArr=V($_REQUEST['EditArr']);

$Win=(strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')?true:false;

if (!$nsUser->DEMO) {
    if ($EditArr) UpdateSettings($EditArr);
}


//$Settings=GetSettings();
$CpuAvail=GetCpuLoad(true);

$EditArr['CronEnable']=V($EditArr['CronEnable'], V($Settings['All']->CRON_ENABLE,0));
$EditArr['CronCpu']=V($EditArr['CronCpu'], V($Settings['All']->CRON_MAX_CPU,0));
$EditArr['CpuWin']=V($EditArr['CpuWin'], V($Settings['All']->CPU_AVG_PATH));
$EditArr['SkipTime']=V($EditArr['SkipTime'], V($Settings['All']->CRON_SKIP_TIME));

if ($Win && !$EditArr['CpuWin']) $CpuAvail=false;
if ($Win && trim($EditArr['CpuWin'])) {
    //echo GetCpuLoad(true);
    if (GetCpuLoad(true)==-1) $Logs->Err($Lang['LoadAvgErr']);
    $CpuAvail=true;
}


$Query = "SELECT COUNT(*) FROM ?_cron_log";
$Cnt=$Db->ReturnValue($Query);
if ($Cnt>0) {
    $Query = "SELECT AVG(RUN_TIME) FROM ?_cron_log";
    $AvgTime=$Db->ReturnValue($Query);
    $AvgTime= (double) $AvgTime;
    $Query = "SELECT DATE_ADD(STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE) AS STAMP, UNIX_TIMESTAMP(DATE_ADD(STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS USTAMP FROM ?_cron_log ORDER BY STAMP DESC LIMIT 1";
    $LastRec=$Db->Select($Query);
    $LastStamp=$LastRec->USTAMP;
    $LastDate=_date($LastRec->USTAMP,'datetime');
    //$Stamp=time()-($nsUser->TZ*60*60);
    $Logs->Msg($Lang['LastRun'].$LastDate);    
}
elseif ($Settings['All']->CRON_ENABLE) $Logs->Alert($Lang['NeverRun']);

include $nsTemplate->Inc();



function UpdateSettings($Arr)
{
    global $Db, $nsProduct, $CpuAvail;
    global $TTRunTime, $TTReCache;
    extract($Arr);
    $CronEnable=V($CronEnable,0);
    $CronInterval=V($CronInterval,5);    
    $CronCpu=V($CronCpu,0);
    $CpuWin=V($CpuWin,"");
    $SkipTime=ParseSkipTime(V($SkipTime,""));

    $Query = "
        UPDATE ?_config SET  

            CRON_ENABLE=?,
            CRON_MAX_CPU=?,
            CPU_AVG_PATH=?,
            CRON_SKIP_TIME=?

        WHERE COMPANY_ID=0 AND SITE_ID=0
    ";
    $Db->Query($Query, $CronEnable, $CronCpu,$CpuWin,$SkipTime);
    $nsProduct->Redir("cron");
    
}


function ParseSkipTime($Str=false)
{
    if (!$Str) return false;
    $NewStr='';
    $Periods=explode(";",$Str);
    foreach ($Periods as $i=>$Period) {
        if (!trim($Period)) continue;
        $Stamps=explode("-",trim($Period));
        if (count($Stamps)<2) continue;
        if (!trim($Stamps[0])||!trim($Stamps[1])) continue;
        $Start=explode(":",trim($Stamps[0]));
        $End=explode(":",trim($Stamps[1]));
        if (count($Start)<2||count($End)<2) continue;
        if (!trim($Start[0])||!trim($Start[1])||!trim($End[0])||!trim($End[1])) continue;
        if ($Start[0]==$End[0]&&$Start[1]==$End[1]) continue;
        if (sprintf("%02d",intval($Start[0]))!=$Start[0]) continue;
        if (sprintf("%02d",intval($Start[1]))!=$Start[1]) continue;
        if (sprintf("%02d",intval($End[0]))!=$End[0]) continue;
        if (sprintf("%02d",intval($End[1]))!=$End[1]) continue;
        if (intval($Start[0])>intval($End[0])) continue;
        
        if ($i>0) $NewStr.=";";
        $NewStr.="{$Start[0]}:{$Start[1]}-{$End[0]}:{$End[1]}";
    }
    
    return $NewStr;
}

?>