<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

require_once SELF.'/lib/email.func.php';
require_once SELF.'/lib/reports/cache_path.func.php';
require_once SELF.'/class/cache_v2.class.php';
require_once SYS.'/system/class/convertcharset/convert_charset.class.php';
$nsLang->TplInc("inc/top_panel.inc");
$nsLang->TplInc("inc/menu");
$nsLang->TplInc("logs/logs_menu.inc");
$nsLang->TplInc("constructor/periods");
$nsLang->TplInc("inc/filter");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->TplInc("admin.email");

extract(VPack(array('EditId','EditArr','EmailMode', 'QuerySetId', 'CacheId', 'ax', 'Mode', 'Additional', 'Log', 'SplitId',
                                    'ToggleId', 'HlId', 'DeleteId')));
$ReportParams = array();
$NamesArr = array('Hits'=>'MenuHits', 'Clicks'=>'MenuClicks', 'Fraud'=>'MenuClickFraud', 'Actions'=>'MenuActions',
                                               'Sales'=>'MenuSales', 'Split'=>'MenuSplits', 'Ref'=>'MenuRefs', 'Key'=>'MenuKeys');

if (!@$nsUser->ALLOW_SCHEDULE_EMAILS && !$EditId)  $nsProduct->Redir("default", "", "admin");

if (!$nsUser->DEMO) {
    if ($EditId && $EditArr) ProcessEmailForm($EditId, $EditArr);
    if ($ToggleId) ToggleEmail($ToggleId);
    if ($DeleteId) DeleteEmail($DeleteId);
}

if ($EditId) {

    if (!$EmailMode) {
        $Params=unserialize($Db->ReturnValue("SELECT PARAMETERS FROM ?_email_schedule WHERE COMPANY_ID=? AND ID=?", $CpId, $EditId));
        if (!empty($Params)) extract($Params);
    }

    if ($QuerySetId && !$CacheId) {
        $CacheObj = new nsQueryCache($CpId, $QuerySetId);
        if ($Additional) $CacheObj->Additional=$CacheObj->TaskToArr(urldecode($Additional));
        $CacheObj->Mode=$EmailMode;
        $CacheId = $CacheObj->GetCacheId();
        if (!$CacheId) $CacheObj->CreateCacheRecord();
        $CacheId = $CacheObj->GetCacheId();
    }

    $EmailName = '';
    if (!$CacheId && !$Log) $nsProduct->Redir("default", "", "admin");
    $RParamsOriginal = array();

    $Receips=array();
    $Query = "
        SELECT SU.*
        FROM ?{PFX}_system_user SU
        LEFT JOIN ?_user U ON U.USER_ID=SU.ID
        LEFT JOIN ?_admin A ON A.USER_ID=SU.ID
        WHERE (A.ID IS NOT NULL) OR (U.COMPANY_ID=?cp)
    ";
    $Sql = new Query($Query, false, array('cp'=>$CpId));
    while ($Row=$Sql->Row()) $Receips[]=$Row;

    if ($CacheId) {
        $Query = "
            SELECT QS.*, C.MODE
            FROM ?_{$CpId}_cache C
            INNER JOIN ?_{$CpId}_cache_query_set QS ON QS.ID=C.QUERY_SET_ID
            WHERE C.ID=?
        ";
        $QuerySet = $Db->Select($Query, false, $CacheId);
        if (!$QuerySet) $nsProduct->Redir("default", "", "admin");
        $QuerySet->Params = @unserialize($QuerySet->PARAMS_SET);
        if (in_array($QuerySet->MODE, array('PAID', 'NATURAL'))) {
            $QuerySet->PATH = isset($QuerySet->Params['WhereArr']) ? CachePath($QuerySet->Params['WhereArr'], $CpId) :
                                                 getURL($QuerySet->MODE=='NATURAL' ? 'natural_constructor' : 'paid_constructor', "CpId=$CpId", 'report');
            $QuerySet->NAME = ($QuerySet->MODE=='NATURAL'? $Lang['MNatural'] : $Lang['MPaidAdv']).' / '.$QuerySet->PATH['Name'];
        }
        if ($QuerySet->MODE=='SPLIT') {
            $Query = "SELECT * FROM ?_camp_piece WHERE ID=?";
            $Split = $Db->Select($Query, false, $SplitId);
            $QuerySet->NAME = $Split->NAME;
        }
        if (!empty($QuerySet->Params)) {
            $ReportParams = GetReportParamsTable($QuerySet->Params);
            $RParamsOriginal = $QuerySet->Params;
        }
    }
    if ($Log && $Additional) {

        $Arr = array();
        parse_str(urldecode($Additional), $Arr);
        $ReportParams = GetReportParamsTable($Arr);
        $RParamsOriginal = $Arr;
    }

    $ReportDynamicPeriod=array();
    if (!empty($ReportParams) && @$RParamsOriginal['DynamicPeriod'] &&
        !in_array($RParamsOriginal['DynamicPeriod'], array('-1', '0-a-0'))) {
        $ReportDynamicPeriod = $RParamsOriginal['DynamicPeriod'];
    }

    if ($EditId != 'new') {

        $EditEmail = $Db->Select("SELECT *, UNIX_TIMESTAMP(SEND_AT) AS SEND_AT
            FROM ?_email_schedule WHERE COMPANY_ID=? AND ID=?", false, $CpId, $EditId);
        if (!$EditEmail) $nsProduct->Redir('email', '', 'admin');
        $EditEmail->Params = @unserialize($EditEmail->PARAMETERS);

        $EmailName = $EditEmail->SUBJECT;
        if ($EditEmail->COMMENT) $EmailName .= " ($EditEmail->COMMENT)";
        $PageTitle = $EmailName;
        $Mode = $EditEmail->SCHEDULE ? 'Schedule' : 'OneTime';
        if ($EditEmail->SCHEDULE) $EditEmail->SEND_AT = time();

        $tmp = explode("\n", trim($EditEmail->RECEPIENTS));
        if (count($tmp)<2) {
            $EditEmail->RECEPIENT = $EditEmail->RECEPIENTS;
            $EditEmail->RECEPIENTS = false;
        }

        $EditEmail->PeriodCnt = $EditEmail->Period='';
        if ($EditEmail->SCHEDULE) {
            $tmp = explode('-', $EditEmail->SCHEDULE);
            $EditEmail->PeriodCnt = @$tmp[0];
            $EditEmail->Period = @$tmp[1];
            $EditEmail->PeriodStart = @$tmp[2];
        }

    } else {
        if ($CacheId) {
            $EmailName = $QuerySet->NAME;
        }

        if ($Log) {

            if (!@$NamesArr[$Log]) $nsProduct->Redir("default", "", "admin");
            $EmailName = $Lang[$NamesArr[$Log]];
        }
        $PageTitle = $Lang['CreateNew'];
    }

    $EditArr['Subject']= V($EditArr['Subject'], V($EditEmail->SUBJECT, $CurrentCompany->NAME.' : '.$EmailName));
    $EditArr['Body'] = V($EditArr['Body'], V($EditEmail->BODY));
    $EditArr['List'] = V($EditArr['List'], V($EditEmail->RECEPIENTS, @$nsUser->ALLOW_SCHEDULE_EMAILS? '' : $nsUser->UserInfo['EMAIL']));
    $EditArr['Email'] = V($EditArr['Email'], V($EditEmail->RECEPIENT));
    $EditArr['Comment'] = V($EditArr['Comment'], V($EditEmail->COMMENT));
    $EditArr['SendAs'] = V($EditArr['SendAs'], V($EditEmail->ATTACH_TYPE, 'xls'));
    $EditArr['NoRowsLimit'] = V($EditArr['NoRowsLimit'], V($EditEmail->Params['NoRowsLimit'], 0));
    $EditArr['SendOnlyNew'] = V($EditArr['SendOnlyNew'], V($EditEmail->Params['SendOnlyNew'], 0));
    $EditArr['SendAtDate'] = V($EditArr['SendAtDate'], date('Y-m-d', V($EditEmail->SEND_AT, time())));
    $EditArr['SendAtTime'] = V($EditArr['SendAtTime'], date('H:i',V($EditEmail->SEND_AT, time()+600)));
    $EditArr['PeriodCnt'] = V($EditArr['PeriodCnt'], V($EditEmail->PeriodCnt, ''));
    $EditArr['Period'] = V($EditArr['Period'], V($EditEmail->Period, ''));
    $EditArr['PeriodStart'] = V($EditArr['PeriodStart'], V($EditEmail->PeriodStart, 0));
    $EditArr['Subject'] = str_replace('&raquo;', '>', $EditArr['Subject']);

    $AllowCron=true;
    $WrongPeriod=false;
    if ($Settings['All']->CRON_ENABLE) {
        $Query = "SELECT IF(STAMP > DATE_ADD(?, INTERVAL -1 HOUR),1,0) AS CHCK FROM ?_cron_log ORDER BY STAMP DESC LIMIT 1";
        if (!$Db->ReturnValue($Query,gmdate("Y-m-d H:i:s",time()))) $AllowCron=false;
    } else $AllowCron=false;

    $WrongPeriod = CheckWrongPeriod(@$ReportDynamicPeriod, $EditArr['Period']);

    $Get = "EditId=$EditId&EmailMode=$EmailMode&QuerySetId=$QuerySetId&";
    $Get .= "CacheId=$CacheId&Mode=$Mode&Additional=$Additional&Log=$Log&SplitId=$SplitId";

    $ProgPath[0]['Name']=$Lang['MyTracker'];
    $ProgPath[0]['Url']=getURL("my_tracker", "Mode=email", "admin");
    $ProgPath[1]['Name']=$PageTitle;
    $ProgPath[1]['Url']=getURL("email", $Get, "admin");

    if (!$ax) include $nsTemplate->Inc("inc/header");
    if (!$ax) include $nsTemplate->Inc("inc/submenu");
    include $nsTemplate->Inc("admin.email_edit");
    if (!$ax) include $nsTemplate->Inc("inc/footer");
}


if (!$EditId) {

    $PageTitle = $Lang['ScheduledList'];
    $ProgPath[1]['Name']=$PageTitle;
    $ProgPath[1]['Url']=getURL("my_tracker", "Mode=email", "admin");

    $Query = "
        SELECT *,
            UNIX_TIMESTAMP(DATE_ADD(SEND_AT, INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE)) AS SEND_AT,
            IF( LAST_SENT IS NOT NULL, UNIX_TIMESTAMP(DATE_ADD(LAST_SENT, INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE)), 0) AS LAST_SENT
        FROM ?_email_schedule S
        WHERE S.COMPANY_ID=?cp
        ORDER BY S.ENABLED DESC, S.SUBJECT ASC
    ";
    $Sql = new Query($Query, false, array('cp'=>$CpId));
    $Emails = array();
    while ($Row=$Sql->Row()) {
        $Row->Period = $Row->PeriodCnt = $Row->PeriodStart = false;
        if ($Row->SCHEDULE) {
            $Arr = explode('-', $Row->SCHEDULE);
            $Row->Period = $Arr[1];
            $Row->PeriodCnt = $Arr[0];
            $Row->PeriodStart = $Arr[2];
        }
        $Row->TYPE = $Lang['OneTime'];
        if ($Row->SCHEDULE) {
            $tmp = explode('-', $Row->SCHEDULE);
            $Row->TYPE = $Lang['every'];
            if ($tmp[0] > 1) $Row->TYPE .= $tmp[0] . ' '.$Lang['ScheduleType1'][$tmp[1]] ;
            else $Row->TYPE .= $Lang['ScheduleType'][$tmp[1]] ;
            if ($tmp[2]>0) {
                if ($tmp[2]==7) $tmp[2]=0;
                $Row->TYPE .= $Lang['at'] . $Lang['DayOfWeek'][$tmp[2]];
            }
        }
        $Row->REPORT_TYPE='';
        $Params = unserialize($Row->PARAMETERS);
        if ($Params['EmailMode']=='SPLIT') {
            $Row->REPORT_TYPE = $Lang['SplitTest']. $Db->ReturnValue("SELECT * FROM ?_camp_piece WHERE ID=?", $Params['SplitId']);
        }
        if ($Params['Log']) {
            $Row->REPORT_TYPE = $Lang[$NamesArr[$Params['Log']]];
        }
        if ($Params['EmailMode']=='NATURAL') $Row->REPORT_TYPE = $Lang['MNatural'];
        if ($Params['EmailMode']=='PAID') $Row->REPORT_TYPE = $Lang['MPaidAdv'];
        if ($Params['EmailMode']=='CUSTOM') $Row->REPORT_TYPE = $Lang['CustomReport'];
        $Emails[] = $Row;
    }

    if (!$ax) include $nsTemplate->Inc("inc/header");
    if (!$ax) include $nsTemplate->Inc("inc/submenu");
    if (empty($Emails)) include $nsTemplate->Inc('inc/no_records');
    else include $nsTemplate->Inc("admin.email");
    if (!$ax) include $nsTemplate->Inc("inc/footer");
}


function ProcessEmailForm($Id, $Arr) {
    global $CacheId, $SplitId, $Log, $Mode, $EmailMode, $Additional, $nsUser;
    global $Db, $nsProduct, $Logs, $Lang, $CpId, $CurrentCompany, $LangConfig;

    if (!$Arr['List']) $Arr['List']=$Arr['Email'];
    if (!$Arr['List'] || $Arr['List']=='all') return $Logs->Err($Lang['ChooseReceps']);
    if (!@$Arr['Subject']) $Arr['Subject'] = $CurrentCompany->NAME;
    $Arr['NoRowsLimit'] = V($Arr['NoRowsLimit'], false);
    $Arr['SendOnlyNew'] = V($Arr['SendOnlyNew'], false);
    $Arr['Body'] = V($Arr['Body'], '');
    $Arr['Comment'] = V($Arr['Comment'], '');
    $Arr['SendAs'] = V($Arr['SendAs'], 'xls');
    $Arr['SendAtDate'] = V($Arr['SendAtDate']);
    $Arr['SendAtTime'] = V($Arr['SendAtTime']);
    if (!in_array($Arr['SendAs'], array('csv', 'xls', 'html', 'xml'))) $Arr['SendAs'] = 'xls';
    $SearchKey = emailSearchKey($EmailMode,$CacheId,$Log,$SplitId);
    $Arr['Period'] = V($Arr['Period']);
    $Arr['PeriodStart'] = V($Arr['PeriodStart'], '0');
    if (in_array($Arr['Period'], array('','d'))) $Arr['PeriodStart']=0;
    $Arr['PeriodCnt'] = V($Arr['PeriodCnt'], $Arr['Period'] ? 1 : false);
    if ($Arr['Period'] && $Arr['PeriodCnt']) $Schedule = "{$Arr['PeriodCnt']}-{$Arr['Period']}-{$Arr['PeriodStart']}";
    else $Schedule = null;
    $SendAt = null;

    $Arr['List'] = str_replace(",", "\n", $Arr['List']);
    $Arr['List'] = str_replace(";", "\n", $Arr['List']);
    $Arr['List'] = preg_replace('/\n+/', "\n", $Arr['List']);

    if ($Mode=='OneTime' || $Mode=='Schedule') {
        if (!$Schedule && (!$Arr['SendAtDate'] || !$Arr['SendAtTime'])) return $Logs->Err($Lang['ChooseTime']);
        if (!$Schedule && $Arr['SendAtDate'] && $Arr['SendAtTime']) $SendAt = $Arr['SendAtDate'].':'.$Arr['SendAtTime'].':00';

        if ($Id == 'new') {
            if ($Schedule) $SendAt = EmailGetNextDate($Schedule, time());

            $Params = serialize(array('CacheId'=>$CacheId, 'Additional'=>$Additional, 'Log'=>$Log, 'SplitId'=>$SplitId, 'EmailMode'=>$EmailMode,
                                                     'NoRowsLimit'=>$Arr['NoRowsLimit']));
            $Query = "INSERT INTO ?_email_schedule ( COMPANY_ID, SUBJECT, BODY, RECEPIENTS, ATTACH_TYPE, SEND_AT,
                                                                                         SCHEDULE, PARAMETERS, ENABLED,COMMENT,SEARCH_KEY)
                                                                                         VALUES (?,?,?,?,?,?,?,?,?,?,?)";
            $Db->Query($Query, $CpId, $Arr['Subject'], $Arr['Body'], $Arr['List'], $Arr['SendAs'],
                                   $SendAt, $Schedule, $Params, 1, $Arr['Comment'],$SearchKey);
            $Id = $Db->LastInsertId;
        } else {
            $Query = "SELECT *, UNIX_TIMESTAMP(SEND_AT) AS STAMP FROM ?_email_schedule WHERE COMPANY_ID=? AND ID=?";
            $Sch = $Db->Select($Query, false, $CpId, $Id);
            $ParamArr = @unserialize($Sch->PARAMETERS);
            $ParamArr['NoRowsLimit']=$Arr['NoRowsLimit'];
            $ParamArr['SendOnlyNew']=$Arr['SendOnlyNew'];
            $Params = serialize($ParamArr);
            if ($Schedule != $Sch->SCHEDULE || !$Sch->SEND_AT || ($Schedule && $Sch->STAMP < time()-86400)) $SendAt = EmailGetNextDate($Schedule, time());

            $Query = "UPDATE ?_email_schedule SET SUBJECT=?, BODY=?, RECEPIENTS=?, ATTACH_TYPE=?, SEND_AT=?,
                                                                                         SCHEDULE=?, PARAMETERS=?, COMMENT=? WHERE ID=?";
            $Db->Query($Query, $Arr['Subject'], $Arr['Body'], $Arr['List'], $Arr['SendAs'], $SendAt, $Schedule, $Params, $Arr['Comment'], $Id);
        }

        if ($CacheId&&$Schedule) {
            $CacheObj = new nsQueryCache($CpId, false, $CacheId);
            $CacheObj->GetCacheId();
            if (!$CacheObj->CacheType) $CacheObj->SetCacheType(6);
        }

        $WrongPeriod = CheckWrongPeriod(@$_REQUEST['ReportDynamicPeriod'], @$Arr['Period']);
        if ($WrongPeriod) $nsProduct->Redir('email', "EditId=$Id", 'admin');

        if (@$nsUser->ALLOW_SCHEDULE_EMAILS) $nsProduct->Redir('my_tracker', "Mode=email&HlId=$Id", 'admin');
        else $nsProduct->Redir('email', "EditId=$Id", 'admin');
    }

    if ($Mode=='Immediate') {
        if (!$Log) {
            SendReport($Arr['List'],
                                  PrepareReportForEmail($CacheId, $CpId, $Additional, $Arr['SendAs'], array('SplitId'=>$SplitId, 'Subject'=>$Arr['Subject'])),
                                  array('Subject'=>$Arr['Subject'], 'Body'=>$Arr['Body'], 'SendAs'=>$Arr['SendAs'], 'SplitId'=>$SplitId)
                                 );
            die($Lang['MsgSent']);
        }
        else {
            SendReport($Arr['List'],
                                  PrepareLogForEmail($Log, $CpId, $Additional, $Arr['SendAs'], array('NoLimit'=>$Arr['NoRowsLimit'], 'Subject'=>$Arr['Subject'])),
                                  array('Subject'=>$Arr['Subject'], 'Body'=>$Arr['Body'], 'SendAs'=>$Arr['SendAs'])
                                 );
            die($Lang['MsgSent']);
        }
    }
}

function CheckWrongPeriod( $DynamicPeriod = array(), $SchedulePeriod=false ) {
    if (in_array($DynamicPeriod, array('-1', '0-a-0'))) return false;
    if (is_string($DynamicPeriod)) $DynamicPeriod = explode('-', $DynamicPeriod);
    if (empty($DynamicPeriod) || !$SchedulePeriod) return false;
    return (ComparePeriods($DynamicPeriod[1], $SchedulePeriod) > -1 && $DynamicPeriod[2]==0);
}

function ToggleEmail($Id) {
    global $CpId, $Db;
    $Check = $Db->Select("SELECT * FROM ?_email_schedule WHERE ID = ? AND COMPANY_ID=?", false,$Id, $CpId);
    if (!$Check) die();
    $Db->Query("UPDATE ?_email_schedule SET ENABLED = ? WHERE ID=?", ($Check->ENABLED ? 0 : 1), $Id);
    exit;
}

function DeleteEmail($Id) {
    global $CpId, $Db;
    $Params=unserialize($Db->ReturnValue("SELECT PARAMETERS FROM ?_email_schedule WHERE COMPANY_ID=? AND ID=?", $CpId, $EditId));
    if (!empty($Params)) {
        $CacheObj = new nsQueryCache($CpId, false, $Params['CacheId']);
        $CacheObj->GetCacheId();
        if ($CacheObj->CacheType==6) $CacheObj->SetCacheType(0);
    }
    $Db->Query( "DELETE FROM ?_email_schedule WHERE ID=? AND COMPANY_ID=?", $Id, $CpId) ;
    exit;
}

function emailSearchKey($EmailMode=false, $CacheId=false, $Log=false, $SplitId=false) {
    if (in_array($EmailMode, array('NATURAL', 'PAID', 'CUSTOM'))) return $EmailMode.$CacheId;
    if ($EmailMode=='SPLIT') return $EmailMode.$SplitId;
    return $EmailMode;
}

?>