<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==3&&!$nsUser->ADMIN) $nsProduct->Redir("default", "", "admin");
if ($nsProduct->LICENSE!=3&&!$nsUser->SUPER_USER) $nsProduct->Redir("default", "", "admin");

ExtendUser();

require_once SELF."/lib/delete/period.func.php";
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/lib/reports/static_report.func.php";
require_once SELF."/lib/reports/misc.func.php";

$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/top_panel.inc");
$nsLang->TplInc("inc/reports");
$nsLang->TplInc("constructor/periods");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$Lang['Title'];
$ProgPath[1]['Url']=getURL("removal", "", "admin");
$MenuSection="admin";

$Query = "SELECT * FROM ?_client WHERE HIDDEN!='1' ORDER BY NAME";
$Sql = new Query($Query);
$ClientsArr=array();
while ($Row=$Sql->Row()) $ClientsArr[]=$Row; 


$EditArr=V($_REQUEST['EditArr']);
$RunNow=V($_REQUEST['RunNow']);

$ToAll=V($_REQUEST['ToAll']);

if (!$nsUser->DEMO) {
    if ($EditArr) UpdateSettings($EditArr);
    if ($RunNow) SetRunNow();
}


$Query = "SELECT * FROM ?_config WHERE SITE_ID=0";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) $Settings[$Row->COMPANY_ID]=$Row;

if ($Settings[0]->DELETE_RUN_NOW) $Logs->Alert($Lang['Waiting']);

$EditArr['DeleteEnable']=V($EditArr['DeleteEnable'], V($Settings[0]->DELETE_ENABLE,0));
$EditArr['DeleteRunPeriod']=V($EditArr['RunPeriod'], V($Settings[0]->DELETE_RUN_PERIOD));
$EditArr['DeleteKeepPeriod']=V($EditArr['KeepPeriod'], V($Settings[0]->DELETE_KEEP_PERIOD));
$EditArr['DeleteFunc']=V($EditArr['DeleteFunc'], V($Settings[0]->DELETE_FUNCS,''));
$EditArr['DeleteSubFunc']=V($EditArr['DeleteSubFunc'], V($Settings[0]->DELETE_SUB_FUNCS,''));
$EditArr['RangeStart']=V($EditArr['RangeStart'], V($Settings[0]->DELETE_RANGE_START,''));
$EditArr['RangeEnd']=V($EditArr['RangeEnd'], V($Settings[0]->DELETE_RANGE_END,''));

$Params=explode("|",$EditArr['DeleteFunc']);
$SubParams=explode("|",$EditArr['DeleteSubFunc']);
$RunPeriod=explode("|",$EditArr['DeleteRunPeriod']);
$RunPeriod[0]=V($RunPeriod[0]);
$RunPeriod[1]=V($RunPeriod[1]);
$RunPeriod[2]=V($RunPeriod[2]);
$EditArr['TZ']=V($EditArr['TZ'], isset($RunPeriod[3])?$RunPeriod[3]:$nsUser->TZ);


$KeepPeriod=explode("-",$EditArr['DeleteKeepPeriod']);
$KeepPeriod[0]=V($KeepPeriod[0], 0);
$KeepPeriod[1]=V($KeepPeriod[1]);

$ShowClientPeriods=false;
if ($nsProduct->LICENSE!=3 || count($ClientsArr)==1) $ShowClientPeriods=false;


$Query = "SELECT * FROM ?_static_report_group ORDER BY NAME";
$RGroups=array();
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (isset($Lang[$Row->NAME])) $Row->NAME=$Lang[$Row->NAME];       
    $RGroups[$Row->ID]=$Row;
}

$Query = "
    SELECT SR.*, CL.NAME AS CLIENT_NAME, COUNT(SRA.ID) AS ARCH
    FROM ?_static_report SR
        LEFT JOIN ?_client CL
            ON CL.ID=SR.COMPANY_ID
        LEFT JOIN ?_static_report_archive SRA
            ON SRA.REPORT_ID=SR.ID
    GROUP BY SR.ID
    ORDER BY SR.GROUP_ID, SR.NAME
";
$ReportArr=array();
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if (isset($Lang[$Row->NAME])) $Row->NAME=$Lang[$Row->NAME];       
    $ReportArr[$Row->GROUP_ID][$Row->ID]=$Row;
}


$ClientKeepPeriod=array();
$ClientRemovalEnable=array();
foreach ($ClientsArr as $Cl) {
    if (V($Settings[$Cl->ID]->DELETE_KEEP_PERIOD)) {
        $ClientKeepPeriod[$Cl->ID]=explode("-",$Settings[$Cl->ID]->DELETE_KEEP_PERIOD);
        $ShowClientPeriods=true;
    }
    if (@$Settings[$Cl->ID]->DELETE_RANGE_START) $ShowClientPeriods=true;
    if (@$Settings[$Cl->ID]->DELETE_ENABLE != 3) $ShowClientPeriods=true;
    $ClientKeepPeriod[$Cl->ID][0]=V($ClientKeepPeriod[$Cl->ID][0]);
    $ClientKeepPeriod[$Cl->ID][1]=V($ClientKeepPeriod[$Cl->ID][1]);
    $ClientRangeStart[$Cl->ID]= V($Settings[$Cl->ID]->DELETE_RANGE_START, '');
    $ClientRangeEnd[$Cl->ID]= V($Settings[$Cl->ID]->DELETE_RANGE_END, '');
    $ClientRemovalEnable[$Cl->ID]=$Settings[$Cl->ID]->DELETE_ENABLE;
}

$MinDeleteDate=false;
$MinStamp=false;
$CpArr=array();

if ($Settings[0]->ARCHIVE_ENABLE) {
    $Query = "SELECT ID FROM ?_client";
    $Sql = new Query($Query);
    $SelectArr=array(); $FromArr=array(); $SelectStr=""; $FromStr="";
    while ($Row=$Sql->Row()) {
        $SelectArr[]="DATE_FORMAT(MIN(C{$Row->ID}.NEXT_ARCHIVE_START_DATE),'%Y-%m-%d') AS M{$Row->ID}";
        $SelectArr[]="UNIX_TIMESTAMP(MIN(C{$Row->ID}.NEXT_ARCHIVE_START_DATE)) AS U{$Row->ID}";
        $FromArr[]=PFX."_tracker_{$Row->ID}_static_archive_cache C{$Row->ID}";
        $CpArr[]=$Row->ID;
    }
    $SelectStr=implode(", ",$SelectArr);
    $FromStr=implode(", ",$FromArr);
    $Query = "SELECT $SelectStr FROM $FromStr";
    $MinDates=$Db->Select($Query);
    $MinStamp=time();
    $MinDeleteDate=false;
    foreach ($CpArr as $CpId) {
        $U="U$CpId";
        $M="M$CpId";
        if ($MinDates->$U<$MinStamp) {
            $MinStamp=$MinDates->$U;
            $MinDeleteDate=$MinDates->$M;
        }
    }
}

$KeepPeriodDate=GetKeepPeriodDate($Settings[0]->DELETE_KEEP_PERIOD);

if ($MinDeleteDate) {
    $MinDeleteDateAlert=$Db->ReturnValue("SELECT IF (? < ?, 1, 0)", $MinDeleteDate, $KeepPeriodDate);
    if($MinDeleteDateAlert) $Logs->Alert(str_replace("{DATE}", _date($MinStamp), $Lang['MinRemovalDate']));
}

include $nsTemplate->Inc();



function UpdateSettings($Arr=array())
{
    global $Db, $nsProduct, $Logs;
    extract($Arr);
    $DeleteEnable=V($DeleteEnable,0);
    $ClientEnable=V($ClientEnable,0);
    $RunPeriod=V($RunPeriod,array());
    $KeepPeriod=V($KeepPeriod,array());
    $ClientKeepPeriod=V($ClientKeepPeriod,array());
    $Params=V($Params,array());
    $SubParams=V($SubParams,array());
    $ClientRemovalEnable=V($ClientRemovalEnable,array());
    $RangeStart = V($RangeStart,null);
    $RangeEnd = V($RangeEnd,null);
    $ClientRangeStart = V($ClientRangeStart, array());
    $ClientRangeEnd = V($ClientRangeEnd, array());

    if (!$RangeStart || !$RangeEnd) $RangeStart = $RangeEnd = null;

    if (!isset($Params['DeleteStat'])) {
        unset($Params['PagesOnly']);
        $Params['KeepStat']=1;
    }
    elseif (isset($Params['DeleteStat'])) {
        unset($Params['KeepStat']);
        unset($Params['DeleteStat']);
    }
    foreach ($Params as $k=>$v) {if ($v!=1) unset($Params[$k]);}
    $DeleteFunc=implode("|",array_keys($Params));

    foreach ($SubParams as $k=>$v) {if ($v!=1) unset($SubParams[$k]);}
    $DeleteSubFunc=implode("|",array_keys($SubParams));

    $DeleteRunPeriod='';
    $RunPeriod[0]=V($RunPeriod[0]);
    $RunPeriod[1]=V($RunPeriod[1]);
    $RunPeriod[2]=V($RunPeriod[2]);
    $RunPeriod[3]=V($Arr['TZ'],0);
    if (V($RunPeriod[0])&&V($RunPeriod[1])&&V($RunPeriod[2])) {
        $DeleteRunPeriod=$RunPeriod[0].'|'.$RunPeriod[1].'|'.$RunPeriod[2].'|'.$RunPeriod[3];
    }

    $DeleteKeepPeriod='';
    $KeepPeriod[0]=V($KeepPeriod[0], '0');
    $KeepPeriod[1]=V($KeepPeriod[1], 'd');
    if (!$RangeStart) {
        $DeleteKeepPeriod=$KeepPeriod[0].'-'.$KeepPeriod[1];
    }

    $Query = "
        UPDATE ?_config SET  

            DELETE_ENABLE=?, DELETE_FUNCS=?, DELETE_SUB_FUNCS=?,
            DELETE_RUN_PERIOD=?, DELETE_KEEP_PERIOD=?, DELETE_RANGE_START=?, DELETE_RANGE_END=?

        WHERE COMPANY_ID=0 AND SITE_ID=0
    ";
    $Db->Query($Query, $DeleteEnable, $DeleteFunc, $DeleteSubFunc,$DeleteRunPeriod,$DeleteKeepPeriod,
                            $RangeStart,$RangeEnd);
    if (!$DeleteEnable) $Db->Query("UPDATE ?_config SET DELETE_RUN_NOW='0'");

    if ($ClientEnable) {
        foreach ($ClientRemovalEnable as $CpId=>$v) {
            $Query="UPDATE ?_config SET DELETE_ENABLE=? WHERE COMPANY_ID=? AND SITE_ID=0";
            $Db->Query($Query,$v,$CpId);            
        }
        foreach ($ClientKeepPeriod as $CpId=>$Row) {
            $DeleteKeepPeriod='';
            $Row[0]=V($Row[0]);
            $Row[1]=V($Row[1]);
            if (V($Row[0])&&V($Row[1])) $DeleteKeepPeriod=$Row[0].'-'.$Row[1];
            if (@$ClientRangeStart[$CpId]&&@$ClientRangeEnd[$CpId]) $DeleteKeepPeriod = '';
            $Query="UPDATE ?_config SET DELETE_KEEP_PERIOD=?,
                           DELETE_RANGE_START=NULL, DELETE_RANGE_END=NULL
                           WHERE COMPANY_ID=? AND SITE_ID=0";
            $Db->Query($Query,$DeleteKeepPeriod,$CpId);
        }
        foreach ($ClientRangeStart as $CpId=>$RangeStart) {
            $RangeEnd = @$ClientRangeEnd[$CpId];
            if ( (!$RangeStart || !$RangeEnd)) {
                $Query="UPDATE ?_config SET DELETE_RANGE_START=NULL, DELETE_RANGE_END=NULL 
                                WHERE COMPANY_ID=? AND SITE_ID=0";
                $Db->Query($Query,$CpId);
                if (@$ClientRemovalEnable[$CpId]==4) {
                    $Query="UPDATE ?_config SET DELETE_ENABLE = 3 WHERE COMPANY_ID=? AND SITE_ID=0";
                    $Db->Query($Query,$CpId);                                    
                }
                continue;
            }
            $Query="UPDATE ?_config SET DELETE_RANGE_START=?, DELETE_RANGE_END=? 
                            WHERE COMPANY_ID=? AND SITE_ID=0";
            $Db->Query($Query,$RangeStart,$RangeEnd,$CpId);
        }
    } else {
        $Query = "UPDATE ?_config SET DELETE_RANGE_START = NULL, DELETE_RANGE_END = NULL, 
                            DELETE_KEEP_PERIOD='', DELETE_ENABLE=3 WHERE COMPANY_ID!=0 AND SITE_ID=0";
        $Db->Query($Query);
    }

    if ($DeleteRunPeriod) {
        $NextDate=GetNextDeleteDate($DeleteRunPeriod);
        $Query = "UPDATE ?_config SET DELETE_NEXT_DATE=? WHERE COMPANY_ID=0 AND SITE_ID=0";
        $Db->Query($Query,$NextDate);
    }

    $nsProduct->Redir("removal");    
}




function SetRunNow()
{
    global $Db, $nsProduct;
    
    $Query = "UPDATE ?_config SET DELETE_RUN_NOW=1 WHERE COMPANY_ID=0 AND SITE_ID=0";
    $Db->Query($Query);
    
    $nsProduct->Redir("removal");
}

?>