<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if ($nsProduct->LICENSE==4) $nsProduct->Redir("default", "", "admin"); 

/////////////////////////////////////////////
///////// require libraries here
require_once SYS."/system/lib/validate.func.php";
require_once SYS."/system/lib/sort.func.php";
require_once SELF."/lib/store.func.php";
require_once SELF."/lib/delete.func.php";
require_once SELF."/lib/reports/hidden_reports.func.php";
$nsLang->TplInc("inc/menu");


/////////////////////////////////////////////
///////// prepare any variables

extract(VPack(array('EditId','DeleteId','EditArr','GrpId','EditPage','AddPage','DeletePage',
                                'NewPage','MoveCampTo','AddToSite')));

if (!ValidId($CpId)) $nsProduct->Redir("default", "", "admin");
$MenuSection="split_test";

if (ValidId($EditId)) $SplitTest=GetSplit($EditId);
if (!ValidId($GrpId)&&ValidId($SplitTest->CAMPAIGN_ID)) $GrpId=$SplitTest->CAMPAIGN_ID;
$PageTitle=ValidId($SplitTest->ID)?stripslashes($SplitTest->NAME):$Lang['SplitTest'];

$SitesArr=array();
$Query = "SELECT ID, HOST, USE_HOSTS FROM ?_site WHERE COMPANY_ID=?";
$Sql = new Query($Query, false, $CompId);
while ($Row=$Sql->Row()) $SitesArr[]=$Row;
$SelectNeeded=false;
$SplitTestLink = false;

$ProgPath[0]['Name']=$Lang['MSplits'];
$ProgPath[0]['Url']=getURL("split_list", "CpId=$CpId", "admin");
if (ValidId($SplitTest->ID)) {
	$ProgPath[1]['Name']=stripslashes($SplitTest->NAME);
	$ProgPath[1]['Url']=$nsProduct->SelfAction("EditId=$EditId");
}

/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {

	if (ValidId($EditId)&&ValidArr($EditArr)) UpdateSplitTest($EditId, $EditArr);
	if (V($EditId)=="new"&&ValidArr($EditArr)) CreateNewSplit($EditArr);
	if (ValidId($DeleteId)) DeleteSplit($CpId, $DeleteId);
	if (ValidId($DeletePage)&&ValidId($EditId)) DelPageFromSplit($DeletePage);

}
/////////////////////////////////////////////
///////// display section here

if (V($NewPage)&&ValidId($EditId)) {
	$PageSiteId=0;
	$CompanySiteCnt=0;
	$SiteIdCnt=0;
	$CheckArr=parse_url($NewPage);
	if (!V($CheckArr['scheme'])) $NewPage="http://".$NewPage;
	$NewPageArr=PreparePathAddr($NewPage);
	if ($NewPageArr===false) $Logs->Err(str_replace("{ADDR}", $NewPage, $Lang['UnableToParse']));
	else {
		//  ns_skip,  
		if (strpos($NewPageArr['query'], "ns_skip")!==false) {
			$NewPageArr['query']=preg_replace("/ns_skip=[^&]*/", "", $NewPageArr['query']);
		}
		
        $SiteHostId=false;
		if (!$AddToSite) {
			$Query = "
					SELECT COUNT( DISTINCT SH.SITE_ID) 
					FROM ?_site_host SH
						INNER JOIN ?_site S 
							ON S.ID=SH.SITE_ID
					WHERE SH.HOST=? AND S.COMPANY_ID=?
				";
			$SiteIdCnt=$Db->ReturnValue($Query, $NewPageArr['host'], $CompId);
			$CompanySiteCnt=$Db->ReturnValue("SELECT COUNT(ID) FROM ?_site WHERE COMPANY_ID=?", $CompId);
			$PageSite=$Db->Select("SELECT ID, SITE_ID FROM ?_site_host WHERE HOST=?", false, $NewPageArr['host']);
            $PageSiteId=$PageSite->SITE_ID;
            $SiteHostId=$PageSite->ID;
		}
		else {
			$Query = "SELECT ID FROM ?_site_host WHERE HOST = ? AND SITE_ID=?";
			$CheckId=$Db->ReturnValue($Query, $NewPageArr['host'], $AddToSite);
			if (!$CheckId) {
				$Query = "INSERT INTO ?_site_host (HOST, ENABLED, SITE_ID) VALUES (?, '1', ?)";
				$Db->Query($Query, $NewPageArr['host'], $AddToSite);
                $SiteHostId=$Db->LastInsertId;
				$PageSiteId=$AddToSite;
			}
			else $PageSiteId=$AddToSite;
		}
		
		if ($SiteIdCnt>1 || ($CompanySiteCnt && !$PageSiteId)) $SelectNeeded=true;
		if ($CompanySiteCnt==1 && !$PageSiteId) {
			$SelectNeeded=false;
			$Query = "SELECT ID FROM ?_site WHERE COMPANY_ID=?";
			$SiteId = $Db->ReturnValue($Query, $CompId);
			$Query = "INSERT INTO ?_site_host (HOST, ENABLED, SITE_ID) VALUES (?, '1', ?)";
			$Db->Query($Query, $NewPageArr['host'], $SiteId);
            $SiteHostId=$Db->LastInsertId;
			$PageSiteId=$SiteId;
		}
		
		if ($PageSiteId&&!$SelectNeeded) {
			$PageId=GetPageId($NewPageArr, $PageSiteId);
			$QueryId=(V($NewPageArr['query']))?GetQueryId($NewPageArr['query']):0;
            SetPage2QueryRelation($PageSiteId,$SiteHostId,$PageId,$QueryId);
			if (ValidId($PageId)&&$PageId>0) AddPageToSplit($PageId, $QueryId, $NewPage);
			else $Logs->Err(str_replace("{ADDR}", $NewPage, $Lang['UnableAddPage']));
			$NewPage="";
		}
		elseif (!$PageSiteId&&!$SelectNeeded) $Logs->Err(str_replace("{HOST}",$NewPageArr['host'], $Lang['InvalidHost']));
	}
}

//// new split
if ($EditId=="new") {
	$EditArr['Name']=V($EditArr['Name']);
	$EditArr['Descr']=V($EditArr['Descr']);
    $EditArr['Rem']=V($EditArr['Rem']);
    $EditArr['Method']=V($EditArr['Method']);
	$TableCaption=$Lang['CaptionNew'];
	$SubMenu[0]['Name']=$Lang['BackToList'];
	$SubMenu[0]['Link']=getURL("split_list");
	include $nsTemplate->Inc("admin.split_test");
}


//// edit split

if ($EditId!='new'&&!$EditPage) {

	$Query = "SELECT SSL_LINK FROM ?_config WHERE COMPANY_ID=0";
	$SSLink=$Db->ReturnValue($Query);
	if ($SSLink) {
		$HL=$nsProduct->HL;
		$nsProduct->HL=$SSLink;
	}
	
	if (!MOD_R) $SLink = getURL("split", "s=".$SplitTest->SPLIT_ID, "track");
	else {
		$SLink = str_replace(".html", "", getURL("split", "", "track"));
		$SLink .= "/s".$SplitTest->SPLIT_ID."/";
	}
	if ($SplitTest->PAGE_CNT>0) $SplitTestLink = "<a target=_blank href=\"$SLink\">$SLink</a>";
	
	if ($SSLink) {
		$nsProduct->HL=$HL;
	}

	$EditArr['Name']=V($EditArr['Name'],V($SplitTest->NAME));
	$EditArr['Descr']=V($EditArr['Descr'],V($SplitTest->DESCRIPTION));
    $EditArr['Rem']=V($EditArr['Rem'],V($SplitTest->REMEMBER_PAGE));
    $EditArr['Method']=V($EditArr['Method'],V($SplitTest->DISTR_METHOD));
	$EditArr['Watch']=(CheckSubWatch($EditId, $nsUser->UserId()))?1:0;

	$TableCaption=$Lang['CaptionEdit'].stripslashes($SplitTest->NAME);
	$PagesArr=GetSplitPages($SplitTest->SPLIT_ID);

	$SubMenu[0]['Name']=$Lang['MoveToSplitList'];
	$SubMenu[0]['Link']=getURL("split_list");
    
    if (!empty($SitesArr)) {
	$SubMenu[2]['Name']=$Lang['ChoosePage'];
	$SubMenu[2]['Link']=getURL("split_test", "EditPage=new&EditId=$EditId");
    }
    if (!empty($SitesArr) && $SplitTest->PAGE_CNT>0) {
	$SubMenu[3]['Name']=$Lang['SplitStat'];
	$SubMenu[3]['Link']=getURL("split_test", "SplitId=$EditId", "report");
    }
    
    if ($SplitTest->PAGE_CNT>0) {
    $SubMenu[4]['Name']=$Lang['CodeGen'];
    $SubMenu[4]['Link']=getURL("campaign_link", "SplitId=$EditId", "admin");
    }

	include $nsTemplate->Inc("admin.split_test");
}

//// new page
if (V($EditPage)=="new") {
	$TableCaption=$Lang['CaptionNew'];
	$SubMenu[0]['Name']=$Lang['BackToEdit'];
	$SubMenu[0]['Link']=getURL("split_test", "EditId=$EditId&GrpId=$GrpId");

	$InSplit=array();
	$Query = "SELECT PAGE_ID FROM ?_split_page WHERE SPLIT_ID=?";
	$Sql = new Query($Query, false, $SplitTest->SPLIT_ID);
	while ($Row=$Sql->Row()) $InSplit[]=$Row->PAGE_ID;
    
    $Query = "
		SELECT TCP.COMPANY_ID
         FROM ?_split_test TST
         INNER JOIN ?_camp_piece TCP ON TCP.ID=TST.SUB_ID
         WHERE TST.SUB_ID=?
	";
	$CompanyId=$Db->ReturnValue($Query, $EditId);
    
    $SiteIds=array();
    $Query = "SELECT ID FROM ?_site WHERE COMPANY_ID=?";
    $Sql = new Query($Query, false, $CompanyId);
    while ($Row=$Sql->Row()) $SiteIds[]=$Row->ID;
    $SiteIdStr=implode(",",$SiteIds);

	$Query = "
		SELECT
        DISTINCT PQ.PAGE_ID,
        PQ.*, 
        SH.HOST, SP.PATH, PT.TITLE
        FROM ?_page_query PQ
        INNER JOIN ?_site_host SH
            ON SH.ID=PQ.SITE_HOST_ID
        INNER JOIN ?_site_page SP
            ON SP.ID=PQ.PAGE_ID
        LEFT JOIN ?_page_title PT
            ON PT.ID=PQ.TITLE_ID
        WHERE PQ.SITE_ID IN ($SiteIdStr)
        ORDER BY SH.HOST, SP.PATH
	";
	$Sql = new Query($Query);
	$PagesTree=array();
	while ($Row=$Sql->Row()) {
		if (in_array($Row->PAGE_ID, $InSplit)) $Arr['no_link']=1;
		else $Arr['no_link']=0;
        $Arr['host']=$Row->HOST;
		$Arr['path']=$Row->PATH;
		$Arr['name']=$Row->TITLE;
		$Arr['id']=$Row->PAGE_ID;
		$Arr['host_id']=$Row->SITE_HOST_ID;
		$PagesTree[$Row->HOST][$Row->PAGE_ID]=$Arr;
	}

	include $nsTemplate->Inc("inc/header");
	include $nsTemplate->Inc("inc/submenu");
	foreach($PagesTree as $Host=>$Pages) {
		include $nsTemplate->Inc("admin.split_page");
	}
	include $nsTemplate->Inc("inc/footer");
}



/////////////////////////////////////////////
///////// process functions here

function CreateNewSplit($Arr)
{
	global $Db, $Logs, $nsProduct, $Lang, $CurrentCompany, $GrpId;
	if (!$GrpId) $GrpId=0;
	extract($Arr);
	if (!V($Rem)) $Rem=0;
	if(!$Name) $ErrArr['Name']=$Lang['MustFill'];
	if (isset($ErrArr)) {$Logs->Err($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}
	$CompId=$CurrentCompany->ID;
	$Query = "INSERT INTO ?_camp_piece 
        (CAMPAIGN_ID, NAME, DESCRIPTION, COMPANY_ID) 
        VALUES (?, ?, ?, ?)";
	$Db->Query($Query, $GrpId, $Name, $Descr, $CompId);
	$NewId=$Db->LastInsertId;
	$Query = "INSERT INTO ?_split_test 
        (SUB_ID, COMPANY_ID, REMEMBER_PAGE, DISTR_METHOD) 
        VALUES (?, ?, ?, ?)";
	$Db->Query($Query, $NewId, $CompId, $Rem, $Method);
    $NewSplitId=$Db->LastInsertId;

    $Cache = new nsQueryCache($CurrentCompany->ID);
    $Cache->Mode="SPLIT";
    $Cache->UpdateInterval=360;
    $Cache->QueryParams=SplitQueryParams($NewId);
    $Cache->CreateCacheRecord(1);
    $Cache->SetCacheType(2);

	SaveSplitToFile($NewId, "split_test.nodb");
	$nsProduct->Redir("split_test", "RCrt=1&EditId=$NewId&GrpId=$GrpId");
}


function UpdateSplitTest($Id, $Arr)
{
	global $Db, $Logs, $nsProduct, $Lang, $nsUser;
	extract($Arr);
	if(!$Name) $ErrArr['Name']=$Lang['MustFill'];
	if (!V($Rem)) $Rem=0;
	if (isset($ErrArr)) {$Logs->Err($Lang['FormErr']); $GLOBALS['ErrArr']=$ErrArr; return;}
	$Query = "UPDATE ?_camp_piece SET NAME = ?, DESCRIPTION = ? WHERE ID = ?";
	$Db->Query($Query, $Name, $Descr, $Id);
	$Query = "UPDATE ?_split_test SET REMEMBER_PAGE = ?, DISTR_METHOD=? WHERE SUB_ID=?";
	$Db->Query($Query, $Rem, $Method, $Id);
	if (V($Watch)&&!CheckSubWatch($Id, $nsUser->UserId())) SetSubWatch($Id, $nsUser->UserId());
	if (!V($Watch)) RemoveSubWatch($Id, $nsUser->UserId());
	
	$WrRes=true;
	$WrRes=SaveSplitToFile($Id, "split_test.nodb");
	$nsProduct->Redir("split_test", "RUpd=1&EditId=$Id");
}


function MoveSubCamp($CampId, $MoveTo) {
	global $Db, $nsProduct;
	$Query = "UPDATE ?_camp_piece SET CAMPAIGN_ID=? WHERE ID=?";
	$Db->Query($Query, $MoveTo, $CampId);
	$nsProduct->Redir("split_test", "RUpd=1&EditId=$CampId");
}

function AddPageToSplit($Id, $QueryId=0, $FullPath=false)
{
	global $Db, $SplitTest, $Lang, $Logs;
	$Query = "INSERT INTO ?_split_page 
        (SPLIT_ID, PAGE_ID, QUERY_ID, FULL_PATH) 
        VALUES (?, ?, ?, ?)";
	$Db->Query($Query, $SplitTest->SPLIT_ID, $Id, $QueryId, $FullPath);
	$WrRes=true;
	$WrRes=SaveSplitToFile(false, "split_test.nodb", $SplitTest->SPLIT_ID);
	$Logs->Msg($Lang['RecordUpdated']);
	//if (!$WrRes) $Logs->Err($Lang['WriteErr']);
}

function DelPageFromSplit($Id)
{
	global $Db, $SplitTest, $Lang, $Logs;
	$Query = "DELETE FROM ?_split_page WHERE ID=?";
	$Db->Query($Query, $Id);
	$WrRes=true;
	$WrRes=SaveSplitToFile(false, "split_test.nodb", $SplitTest->SPLIT_ID);
	$Logs->Msg($Lang['RecordDeleted']);
	//if (!$WrRes) $Logs->Err($Lang['WriteErr']);
}




function SetSubWatch($GrpId, $UserId)
{
	global $Db;
	$Query = "INSERT INTO ?_watch (SUB_ID, USER_ID) VALUES (?, ?)";
	$Db->Query($Query, $GrpId, $UserId);
}

function RemoveSubWatch($GrpId, $UserId)
{
	global $Db;
	$Query = "DELETE FROM ?_watch WHERE SUB_ID=? AND USER_ID=?";
	$Db->Query($Query, $GrpId, $UserId);
}


function CheckSubWatch($GrpId, $UserId)
{
	global $Db;
	$Query = "SELECT ID FROM ?_watch WHERE SUB_ID=? AND USER_ID=?";
	return $Db->ReturnValue($Query, $GrpId, $UserId);
}



/////////////////////////////////////////////
///////// free section





function GetPageId($PathArr=false, $StId=false)
{
	global $Db;
	$Path=$PathArr['path'];
	$Query = "SELECT ID FROM ?_site_page WHERE PATH = ? AND SITE_ID=?";
	$CheckId=$Db->ReturnValue($Query, $Path, $StId);
	if (ValidId($CheckId)) return $CheckId;
	$Query = "INSERT INTO ?_site_page (SITE_ID, PATH) VALUES (?, ?)";
	$Db->Query($Query, $StId, $Path);
	return $Db->LastInsertId;
}

function GetSplit($Id)
{
	global $Db;
	$Query = "
		SELECT TCP.*, TST.ID AS SPLIT_ID, TST.REMEMBER_PAGE, TST.DISTR_METHOD
			FROM ?_camp_piece TCP
				INNER JOIN ?_split_test TST
					ON TST.SUB_ID=TCP.ID
			WHERE TCP.ID = ?
	";
	$SplitTest=$Db->Select($Query, false, $Id);
    if ($SplitTest) {
        $Query = "SELECT COUNT(*) FROM ?_split_page WHERE SPLIT_ID = ?";
        $SplitTest->PAGE_CNT = $Db->ReturnValue($Query, $SplitTest->SPLIT_ID);
    } else $SplitTest->PAGE_CNT = 0;
	return $SplitTest;
}




function GetSplitPages($Id)
{
	$PagesArr=array();
	$Query = "
		SELECT TS.*, SI.HOST, TQ.QUERY_STRING, TSP.ID AS TSP_ID, 
			TSP.FULL_PATH
			FROM ?_split_page TSP
			INNER JOIN ?_site_page TS
				ON TS.ID=TSP.PAGE_ID
			INNER JOIN ?_site SI 
				ON SI.ID = TS.SITE_ID
			LEFT JOIN ?_query TQ
				ON TQ.ID=TSP.QUERY_ID
			WHERE SPLIT_ID=?
	";
	$Sql = new Query($Query, false, $Id);
	while ($Row=$Sql->Row())	{
		$Row->SCHEME="";
		if ($Row->FULL_PATH) {
			$Check=parse_url($Row->FULL_PATH);
			$Row->SCHEME=$Check['scheme']."://";
			$Row->HOST=$Check['host'];
		}
		$Row->PATH=$Row->SCHEME.$Row->HOST."<br>".$Row->PATH;
		if($Row->QUERY_STRING) $Row->PATH.="?".$Row->QUERY_STRING;
		$PagesArr[]=$Row;
	}
	if (count($PagesArr)>0) return $PagesArr;
	else return false;
}



function PreparePathAddr($Addr)
{
	$Arr=@parse_url(urldecode(urldecode($Addr)));
	if (!isset($Arr['path'])) $Arr['path']="";
	$Arr['path']=ereg_replace("/+", "/", $Arr['path']);
	if ($Arr['path']=="") $Arr['path']="/";
	if (!V($Arr['host'])) return false;
	$Arr['host']=ToLower($Arr['host']);
	if (!isset($Arr['query'])) $Arr['query']="";
	return $Arr;
}

function SetPage2QueryRelation($StId,$SiteHostId,$PageId,$QueryId)
{
    global $Db;
    if (!$QueryId) $QueryId=0;
    $Query = "SELECT ID FROM ?_page_query WHERE SITE_HOST_ID=? AND PAGE_ID=? AND QUERY_ID=?";
    $CheckId=$Db->ReturnValue($Query, $SiteHostId, $PageId, $QueryId);
    if (!$CheckId) {
        $Query = "INSERT INTO ?_page_query (SITE_ID,SITE_HOST_ID,PAGE_ID,QUERY_ID) VALUES (?,?,?,?)";
        $Db->Query($Query,$StId,$SiteHostId,$PageId,$QueryId);
    }
}


function GetQueryId($Qr=false)
{
	if (!$Qr) return 0;
	global $Db;	
	$Qr=escape_string($Qr);
	$Query = "SELECT ID FROM ?_query WHERE MD5_SEARCH=MD5(?)";
	$CheckId=$Db->ReturnValue($Query, $Qr);
	if (ValidId($CheckId)) return $CheckId;
	$Query ="INSERT INTO ?_query (QUERY_STRING, MD5_SEARCH) VALUES (?, MD5(?))";
	$Db->Query($Query, $Qr, $Qr);
	return (ValidId($Db->LastInsertId))?$Db->LastInsertId:0;
}


?>