<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");
if (($nsProduct->LICENSE==3&&$nsUser->ADMIN)
	|| ($nsProduct->LICENSE!=3&&$nsUser->SUPER_USER)) {

}
else $nsProduct->Redir("default", "", "admin");

$DevSendURL="http://sales/pub/ua.html";

require_once SELF."/class/pagenums2.class.php";
require_once SELF."/class/ua_tracker.class.php";
$UAParser = new UATrackerParser(SELF."/xml/");
$UAParser->LoadXmlData('browser.xml');
$UAParser->LoadXmlData('os.xml');
$UAParser->LoadXmlData('other.xml');

$nsSession->start();

$PageTitle=$Lang['Title'];
$nsLang->TplInc("inc/top_panel.inc");
$ProgPath[0]['Name']=$Lang['Administr'];
$ProgPath[0]['Url']=getURL("admin", "", "admin");
$ProgPath[1]['Name']=$PageTitle;
$ProgPath[1]['Url']=getURL("user_agent", "", "admin");
$MenuSection="admin";

$FormClicked=V($_REQUEST['FormClicked']);
$Filter=V($_REQUEST['Filter'],$FormClicked?false:V($_SESSION['uaFilter']));
$BrowserId=V($_REQUEST['BrowserId']);
$OSId=V($_REQUEST['OSId']);
$EngineId=V($_REQUEST['EngineId']);
$RobotId=V($_REQUEST['RobotId']);
$Mode=V($_REQUEST['Mode']);
$SelUA=V($_REQUEST['SelUA'],array());
$IgnoreBrowserId=V($_REQUEST['IgnoreBrowserId']);
$IgnoreRobotId=V($_REQUEST['IgnoreRobotId']);
$Sent=V($_REQUEST['Sent']);
$SendComment=V($_REQUEST['SendComment']);
$PerPage = V($_REQUEST['PerPage'], V($_SESSION['__uaPerPage'], 50));
$_SESSION['__uaPerPage']=$PerPage;
$UAList=array();

$Get="BrowserId=$BrowserId&OSId=$OSId&EngineId=$EngineId&RobotId=$RobotId";

$_SESSION['uaFilter']=$Filter;
if ($Sent) $Logs->Msg($Lang['DataSent']);

if (!empty($SelUA)&&$Mode=='Delete') RemoveAgents($SelUA);
if (!empty($SelUA)&&$Mode=='Ban') BanAgents($SelUA);
if (!empty($SelUA)&&$Mode=='UnBan') UnBanAgents($SelUA);
if (!empty($SelUA)&&$Mode=='Send') SendUAToDev($SelUA);
if ($BrowserId&&$FormClicked) IgnoreBrowser($BrowserId,$IgnoreBrowserId);
if ($RobotId&&$FormClicked) IgnoreRobot($RobotId,$IgnoreRobotId);

$Browsers=array();
$Query = "SELECT * FROM ?_visitor_agent_browser ORDER BY NAME";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if ($Row->BAN) $IgnoreBrowserId=$Row->ID;
    $Browsers[]=$Row;
}

$OS=array();
$Query = "SELECT * FROM ?_visitor_agent_os ORDER BY NAME";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) $OS[]=$Row;

$Engine=array();
$Query = "SELECT * FROM ?_visitor_agent_engine ORDER BY NAME";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) $Engine[]=$Row;

$Robot=array();
$Query = "SELECT * FROM ?_visitor_agent_robot ORDER BY NAME";
$Sql = new Query($Query);
while ($Row=$Sql->Row()) {
    if ($Row->BAN) $IgnoreRobotId=$Row->ID;
    $Robot[]=$Row;
}



$WhereArr=array(); $WhereStr="";
$Args=array();
if ($BrowserId) {$WhereArr[]=" VA.BROWSER_ID=?b "; $Args['b']=$BrowserId; }
if ($OSId) {$WhereArr[]=" VA.OS_ID=?os "; $Args['os']=$OSId; }
if ($EngineId) {$WhereArr[]=" VA.ENGINE_ID=?e "; $Args['e']=$EngineId; }
if ($RobotId) {$WhereArr[]=" VA.ROBOT_ID=?r "; $Args['r']=$RobotId; }
if ($Filter) {$WhereArr[]=" VA.USER_AGENT LIKE ?f "; $Args['f']="%$Filter%"; }

if (!$BrowserId && !$OSId && !$EngineId && !$RobotId) 
    $WhereArr[]=" (VA.BROWSER_ID=0 AND VA.OS_ID=0 AND VA.ENGINE_ID=0 AND VA.ROBOT_ID=0) ";

$WhereStr=(!empty($WhereArr))?" WHERE ".implode(" AND ",$WhereArr):"";

$Query = "SELECT COUNT(*) FROM ?_visitor_agent VA $WhereStr";
$Cnt=$Db->ReturnValue($Query,$Args);
$Pages = new PageNums($Cnt,$PerPage);
$Pages->Args="&BrowserId=$BrowserId&OSId=$OSId&EngineId=$EngineId&RobotId=$RobotId&Filter=$Filter";

$Query = "
    SELECT VA.*, 
    AB.NAME AS BROWSER_NAME, AO.NAME AS OS_NAME, AE.NAME AS ENGINE_NAME, AR.NAME AS ROBOT_NAME,
    AB.NAME_KEY AS B_KEY, AO.NAME_KEY AS O_KEY, AR.NAME_KEY AS R_KEY,
    AB.BAN AS AB_BAN,
    AR.BAN AS AR_BAN
    FROM ?_visitor_agent VA
        LEFT JOIN ?_visitor_agent_browser AB ON AB.ID=VA.BROWSER_ID
        LEFT JOIN ?_visitor_agent_os AO ON AO.ID=VA.OS_ID
        LEFT JOIN ?_visitor_agent_engine AE ON AE.ID=VA.ENGINE_ID
        LEFT JOIN ?_visitor_agent_robot AR ON AR.ID=VA.ROBOT_ID 
    $WhereStr 
    ORDER BY VA.BAN ASC, VA.USER_AGENT 
    LIMIT {$Pages->PageStart}, {$Pages->Limit}
";
$Sql = new Query($Query,false,$Args);
while ($Row=$Sql->Row()) {
    $Row->Brands=array();
    if ($Row->ROBOT_ID) {$Row->BROWSER_ID=0; $Row->OS_ID=0;}
    if ($Row->BROWSER_ID) {
        $Str="";
        $URL=@$UAParser->XMLData['browser'][$Row->B_KEY]['url'];
        if ($URL) $Str.="<a href=\"$URL\" target=_blank>"; 
        $Str.="{$Row->BROWSER_NAME}";
        if ($Row->BROWSER_VERSION) $Str.=" ({$Row->BROWSER_VERSION})";
        if ($URL) $Str.="</a>";
        $Row->Brands[]=$Str;
    }
    if ($Row->OS_ID) {
        $Str="";
        $URL=@$UAParser->XMLData['os'][$Row->O_KEY]['url'];
        if ($URL) $Str.="<a href=\"$URL\" target=_blank>"; 
        $Str.="{$Row->OS_NAME}";
        if ($Row->OS_VERSION) $Str.=" ({$Row->OS_VERSION})";
        if ($URL) $Str.="</a>";
        $Row->Brands[]=$Str;
    }
    if ($Row->ROBOT_ID) {
        $Str="";
        $URL=@$UAParser->XMLData['other'][$Row->R_KEY]['url'];
        if ($URL) $Str.="<a href=\"$URL\" target=_blank>"; 
        $Str.="{$Row->ROBOT_NAME}";
        if ($Row->ROBOT_VERSION) $Str.=" ({$Row->ROBOT_VERSION})";
        if ($URL) $Str.="</a>";
        $Row->Brands[]=$Str;
    }
    $UAList[]=$Row;
}

include $nsTemplate->Inc("admin.user_agent");



function RemoveAgents($Arr)
{
    global $Db,$nsProduct,$Get;
    $Query = "DELETE FROM ?_visitor_agent WHERE ID IN (?)";
    $Db->Query($Query,$Arr);
    $nsProduct->Redir("user_agent",$Get,"admin");
}


function BanAgents($Arr)
{
    global $Db,$nsProduct,$Get;
    $Query = "UPDATE ?_visitor_agent SET BAN='1' WHERE ID IN (?)";
    $Db->Query($Query,$Arr);
    $nsProduct->Redir("user_agent",$Get,"admin");    
}

function UnBanAgents($Arr)
{
    global $Db,$nsProduct,$Get;
    $Query = "UPDATE ?_visitor_agent SET BAN='0' WHERE ID IN (?)";
    $Db->Query($Query,$Arr);
    $nsProduct->Redir("user_agent",$Get,"admin");
}

function IgnoreBrowser($Id,$Ignore=0)
{
    global $Db,$nsProduct,$Get;
    $Query = "UPDATE ?_visitor_agent_browser SET BAN=? WHERE ID =?";
    $Db->Query($Query,$Ignore,$Id);    
    $nsProduct->Redir("user_agent",$Get,"admin");    
}

function IgnoreRobot($Id,$Ignore=0)
{
    global $Db,$nsProduct,$Get;
    $Query = "UPDATE ?_visitor_agent_robot SET BAN=? WHERE ID =?";
    $Db->Query($Query,$Ignore,$Id);    
    $nsProduct->Redir("user_agent",$Get,"admin");        
}

function SendUAToDev($Arr)
{
    global $DevSendURL, $nsProduct, $Get,$SendComment;
    $URL=$DevSendURL;
    $URL.="?";
    
    $Query = "SELECT * FROM ?_visitor_agent WHERE ID IN (?)";
    $Sql = new Query($Query,false,$Arr);
    while ($Row=$Sql->Row()) $URL.="&ua[]=".htmlspecialchars($Row->USER_AGENT);
    
    $URL.="&return=".htmlspecialchars(getURL('user_agent','Sent=1&'.$Get));
    $URL.="&v=".$nsProduct->VERSION;
    $URL.="&comment=".htmlspecialchars($SendComment);
    
    Header("Location: $URL");
    exit;
}
?>