<?
if (!defined("NS_TRACKER_INDEX")) exit;
/////////////////////////////////////////////
///////// permission check here
if (!$nsUser->Logged()) $nsProduct->Redir("login", "", "admin");

require_once SELF."/class/map.class.php";
$Map= new TrackerMap();

/////////////////////////////////////////////
///////// require libraries here
$nsLang->TplInc("inc/top_panel.inc");
$nsLang->TplInc("constructor/report_constructor");
$nsLang->TplInc("inc/getuserhost");

/////////////////////////////////////////////
///////// prepare any variables

extract(VPack(array('ViewId','VisId','EditArr','NewIp','DeleteIp','AddNewTag','DeleteTag','View')));

$ProgPath[0]['Name']=$Lang['MyTracker'];
$ProgPath[0]['Url']=getUrl("my_tracker", "", "admin");

if (!$VisId&&!$ViewId) $nsProduct->Redir("default", "", "admin");

$Mode=false;
if (ValidId($VisId)) $Mode="edit";
if (ValidId($ViewId)) {
	$Mode="view";
	$VisId=$ViewId;
}

if (V($NewIp)&&!ValidIpTempl($NewIp)) {
	$Logs->Err($Lang['InvalidIp']);
	$NewIp=false;
}

$PageTitle=$Lang['Title'];
$TableCaption=$Lang['Visitor']." $VisId";
$MenuSection="my_tracker";


//$CpId=false;
//$AllClients=false;
$IpArr=array();

if ($nsUser->ADMIN) {
	//$AllClients=1;
	//$CpId=false;
}
else {
	$CpId=$nsUser->COMPANY_ID;
}

$SubMenu[0]['Name']=$Lang['ShowPaths'];
$SubMenu[0]['Link']=getURL("visitor_path", "VisId=$VisId&CpId=$CpId", "report");

if ($Mode=="edit") {
	$SubMenu[1]['Name']=$Lang['VisitorInfo'];
	$SubMenu[1]['Link']=getURL("visitor", "ViewId=$VisId&CpId=$CpId", "admin");
}
if ($Mode=="view") {
	$SubMenu[1]['Name']=$Lang['EditVisitor'];
	$SubMenu[1]['Link']=getURL("visitor", "VisId=$VisId&CpId=$CpId", "admin");
}

$SubMenu[2]['Name']=$Lang['AddSale'];
$SubMenu[2]['Link']=getURL("sale", "VisId=$VisId&CpId=$CpId", "admin");


$UsersWhere="";
if (!$nsUser->ADMIN) $UsersWhere=" AND CV.COMPANY_ID=".$CurrentCompany->ID;
$Query = "
	SELECT 
	V.*, I.IP AS LAST_IP,
	VA.USER_AGENT, VA.BROWSER_ID, VA.OS_ID, VA.ENGINE_ID, 
    VA.BROWSER_VERSION, VA.OS_VERSION, VA.ENGINE_VERSION,
    VA.ID AS USER_AGENT_ID,
	AB.NAME AS BROWSER_NAME, AO.NAME AS OS_NAME, AE.NAME AS ENGINE_NAME,
	CV.NAME, CV.DESCRIPTION, CV.COMPANY_ID, CV.ID AS CLIENT_VIS_ID,
	W.ID AS WATCH,
    CO.ID AS COUNTRY_ID, CO.NAME AS COUNTRY_NAME,
    CI.ID AS CITY_ID, CI.NAME AS CITY_NAME,
    CI.LATITUDE, CI.LONGITUDE
	FROM ?_visitor V
    LEFT JOIN ?_country CO
        ON CO.ID=V.LAST_COUNTRY_ID
    LEFT JOIN ?_city CI
        ON CI.ID=V.LAST_CITY_ID
	LEFT JOIN ?_ip I
		ON I.ID=V.LAST_IP_ID
	LEFT JOIN ?_visitor_agent VA
		ON VA.ID=V.LAST_AGENT_ID
	LEFT JOIN ?_visitor_agent_browser AB
		ON AB.ID=VA.BROWSER_ID
    LEFT JOIN ?_visitor_agent_os AO
        ON AO.ID=VA.OS_ID
    LEFT JOIN ?_visitor_agent_engine AE
        ON AE.ID=VA.ENGINE_ID
	LEFT JOIN ?_client_visitor CV
		ON CV.VISITOR_ID=V.ID $UsersWhere
	LEFT JOIN ?_watch W
		ON W.USER_ID=? AND W.VISITOR_ID=V.ID
	WHERE V.ID=?
";
$Visitor=$Db->Select($Query, false, $nsUser->UserId(), $VisId);
if (!$Visitor->COMPANY_ID) $Visitor->COMPANY_ID=$CpId;
if (V($Visitor->NAME)) $TableCaption=$Visitor->NAME;
$Visitor->WATCH=$Db->ReturnValue("SELECT ID FROM ?_watch WHERE VISITOR_ID=? AND USER_ID=?", $VisId, $nsUser->UserId());
$CpId=$Visitor->COMPANY_ID;

if (V($Visitor->NAME)) {
	$ProgPath[1]['Name']=$Visitor->NAME;
	$ProgPath[1]['Url']=getUrl("visitor", "CpId=$CpId&ViewId=".$Visitor->ID, "admin");
}
else {
	$ProgPath[1]['Name']=$Lang['Visitor']." ".$Visitor->ID;
	$ProgPath[1]['Url']=getUrl("visitor", "CpId=$CpId&ViewId=".$Visitor->ID, "admin");
}

if ($Visitor->CITY_ID) {
    $Map->AddDot(array('lable'=>$Visitor->CITY_NAME, 'latitude'=>$Visitor->LATITUDE, 
                                        'longitude'=>$Visitor->LONGITUDE));
    $Map->Zoom='3';
}


$VisTags=array();
$Tags=array();
$Query = "SELECT V.* 
        FROM ?_visitor_tag_rel VT 
        INNER JOIN ?_tag V
            ON V.ID=VT.TAG_ID 
        WHERE VT.COMPANY_ID=?";
$Sql = new Query($Query,false,$CpId);
while ($Row=$Sql->Row()) $Tags[$Row->ID]=$Row;

$Query = "SELECT TAG_ID FROM ?_visitor_tag_rel WHERE COMPANY_ID=? AND VISITOR_ID=?";
$Sql = new Query($Query,false,$CpId,$VisId);
while ($Row=$Sql->Row()) $VisTags[]=$Row->TAG_ID;

/////////////////////////////////////////////
///////// call any process functions

if (!$nsUser->DEMO) {
    if ($AddNewTag) AddNewTag($VisId,$AddNewTag);
    if ($DeleteTag) RemoveTag($VisId,$DeleteTag);
	if (!empty($EditArr)) UpdateVisitor($VisId, $EditArr);
	if (ValidId($Visitor->CLIENT_VIS_ID)&&$NewIp) AddIp($NewIp, $Visitor->CLIENT_VIS_ID);
	if (ValidId($Visitor->CLIENT_VIS_ID)&&ValidId($DeleteIp)) RemoveIp($DeleteIp, $Visitor->CLIENT_VIS_ID);
}

/////////////////////////////////////////////
///////// display section here
$GrpIpArr=array();
$IpTemplArr=array();

if (ValidId($Visitor->CLIENT_VIS_ID)) {
	$Query = "SELECT ID, IP FROM ?_client_visitor_ip WHERE CLIENT_VISITOR_ID=?";
	$Sql = new Query($Query, false, $Visitor->CLIENT_VIS_ID);
	while ($Row=$Sql->Row()) {
		$IpArr[]=$Row;
		if (strpos($Row->IP, "*")===false) $GrpIpArr[]="'".$Row->IP."'";
		else $IpTemplArr[]=$Row->IP;
	}
}


if (!ValidArr($EditArr)) {
	$EditArr['Name']=htmlspecialchars(stripslashes($Visitor->NAME));
	$EditArr['Descr']=htmlspecialchars(stripslashes($Visitor->DESCRIPTION));
	$EditArr['Watch']=$Visitor->WATCH;
}
if (ValidArr($EditArr)) {
	$EditArr['Name']=htmlspecialchars(stripslashes($EditArr['Name']));
	$EditArr['Descr']=htmlspecialchars(stripslashes($EditArr['Descr']));
	$EditArr['Watch']=$Visitor->WATCH;
}

$IdsStr="";
if (!$nsUser->ADMIN) {
	$SiteIds=array();
	$Query = "SELECT ID FROM ?_site WHERE COMPANY_ID=?";
	$Sql= new Query($Query, false, $nsUser->COMPANY_ID);
	while ($Row=$Sql->Row()) $SiteIds[]=$Row->ID;
	$IdsStr=implode(",",$SiteIds);
}

	$WhereIpIn="";
	if (count($GrpIpArr)>0) $WhereIpIn="I.IP IN (".implode(",", $GrpIpArr).")";
	$WhereIpTempl="";
	if (count($IpTemplArr)>0) {
		$LikeArr=array();
		for($i=0;$i<Count($IpTemplArr);$i++) {
			$IpTemplArr[$i]=str_replace("*", "%", $IpTemplArr[$i]);
			$LikeArr[]="I.IP LIKE '".$IpTemplArr[$i]."'";
		}
		$WhereIpTempl="(".implode(" OR ", $LikeArr).")";
	}

	$WhereArr=array();
	if (!V($WhereIpIn)&&!V($WhereIpTempl)) $WhereArr[]="S_LOG.VISITOR_ID=$VisId";
	if ($IdsStr) $WhereArr[]="S_LOG.SITE_ID IN (".$IdsStr.")";
	if ($WhereIpIn) $WhereArr[]=$WhereIpIn;
	if ($WhereIpTempl) $WhereArr[]=$WhereIpTempl;
	$WhereArr[]="S_LOG.PAGE_ID>0";

	$WhereStr="";
	if (count($WhereArr)>0) $WhereStr=" WHERE ".implode(" AND ", $WhereArr);


if ($Visitor->COMPANY_ID) {

	////   
	$Query = "
		SELECT 
		COUNT(*) 
		FROM ?_{$Visitor->COMPANY_ID}_stat_log S_LOG 
		INNER JOIN ?_ip I
		ON I.ID=S_LOG.IP_ID
		$WhereStr
	";
	$TotalCnt=$Db->ReturnValue($Query);

	////   
	$Query = "
		SELECT
		COUNT(S_LOG.ID)
		FROM ?_{$Visitor->COMPANY_ID}_stat_action S_ACTION
		INNER JOIN ?_{$Visitor->COMPANY_ID}_stat_log S_LOG
			ON S_LOG.ID=S_ACTION.LOG_ID
		INNER JOIN ?_ip I
			ON I.ID=S_LOG.IP_ID
			$WhereStr
	";
	$ActionCnt=$Db->ReturnValue($Query);

	////  
	$Query = "
		SELECT
		COUNT(S_LOG.ID)
		FROM ?_{$Visitor->COMPANY_ID}_stat_sale S_SALE
		INNER JOIN ?_{$Visitor->COMPANY_ID}_stat_log S_LOG
			ON S_LOG.ID=S_SALE.LOG_ID
		INNER JOIN ?_ip I
			ON I.ID=S_LOG.IP_ID
			$WhereStr
	";
	$SaleCnt=$Db->ReturnValue($Query);

	////  
	$Query = "
		SELECT
		COUNT(S_LOG.ID)
		FROM ?_{$Visitor->COMPANY_ID}_stat_click S_CLICK
		INNER JOIN ?_{$Visitor->COMPANY_ID}_stat_log S_LOG
			ON S_LOG.ID=S_CLICK.LOG_ID
		INNER JOIN ?_ip I
			ON I.ID=S_LOG.IP_ID
			$WhereStr
	";
	$ClickCnt=$Db->ReturnValue($Query);

	///  
	$RefArr=array();
	$KeyArr=array();
	$DistKey=array();
	$Query = "
		SELECT
		R.ID, R.REFERER, 
		UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE)) AS STAMP,
		RS.NATURAL_KEY,
		K.KEYWORD

		FROM ?_{$Visitor->COMPANY_ID}_stat_log S_LOG
		INNER JOIN ?_referer_set RS
		ON RS.ID=S_LOG.REFERER_SET
		INNER JOIN ?_referer R
		ON R.ID=RS.REFERER_ID
		LEFT JOIN ?_keyword K
		ON K.ID=RS.NATURAL_KEY
		INNER JOIN ?_ip I
			ON I.ID=S_LOG.IP_ID

			$WhereStr
		
		ORDER BY S_LOG.STAMP ASC
	";
	//echo $Query;
	$Sql = new Query($Query);
	while ($Row=$Sql->Row()) {
		$RefArr[]=$Row;
		if ($Row->NATURAL_KEY>0&&!in_array($Row->KEYWORD, $DistKey)) {
			$KeyArr[]=$Row;
			$DistKey[]=$Row->KEYWORD;
		}
	}
	$RefCnt=count($RefArr);
	$KeyCnt=count($DistKey);

    $Sales=array();
    $SaleProducts=array();
    $SalesAmount=0;
    if ($SaleCnt) {

        $Query = "
            SELECT S_SALE.*, 
            UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL '{$nsUser->SQL_TZ}' HOUR_MINUTE)) AS STAMP
            FROM ?_{$Visitor->COMPANY_ID}_stat_sale S_SALE
            INNER JOIN ?_{$Visitor->COMPANY_ID}_stat_log S_LOG ON S_LOG.ID=S_SALE.LOG_ID
            WHERE S_LOG.VISITOR_ID=?
        ";
        $Sql = new Query($Query,false,$Visitor->ID);
        while ($Row=$Sql->Row()) {
            $Sales[$Row->ID]=$Row;
            $SalesAmount+=$Row->COST;
        }

        $Query = "
            SELECT SS.SALE_ID, SI.NAME, SS.COST, SS.QUANT
            FROM ?_sale_set SS
            INNER JOIN ?_sale_item SI ON SI.ID=SS.ITEM_ID
            WHERE SS.SALE_ID IN (?)
        ";
        $Sql = new Query($Query,false,array_keys($Sales));
        while ($Row=$Sql->Row()) {
            $Row->NAME=stripslashes($Row->NAME);
            $SaleProducts[$Row->SALE_ID][]=$Row;
        }

    }

    $Actions=array();
    if ($ActionCnt) {

        $Query = "
            SELECT VA.ID, VA.NAME, AI.NAME AS ACTION_ITEM, AI.ID AS ACTION_ITEM_ID
            FROM ?_{$Visitor->COMPANY_ID}_stat_action S_ACTION
            INNER JOIN ?_{$Visitor->COMPANY_ID}_stat_log S_LOG ON S_LOG.ID=S_ACTION.LOG_ID
            INNER JOIN ?_visitor_action VA ON VA.ID=S_ACTION.ACTION_ID
                LEFT JOIN ?_action_set ASET ON ASET.STAT_ACTION_ID=S_ACTION.ID
                LEFT JOIN ?_action_item AI ON AI.ID=ASET.ACTION_ITEM_ID
            WHERE S_LOG.VISITOR_ID=?
        ";
        $Sql = new Query($Query,false,$Visitor->ID);
        while ($Row=$Sql->Row()) {
            $Actions[$Row->ID][$Row->ACTION_ITEM_ID]=$Row;
        }

    }
    
    $Clicks=array();
    if ($ClickCnt) {
        $Query = "
            SELECT CP.ID, CP.NAME, K.ID AS K_ID, K.KEYWORD
            FROM ?_{$Visitor->COMPANY_ID}_stat_click S_CLICK
            INNER JOIN ?_{$Visitor->COMPANY_ID}_stat_log S_LOG ON S_LOG.ID=S_CLICK.LOG_ID
            INNER JOIN ?_camp_piece CP ON CP.ID=S_CLICK.CAMP_ID
            INNER JOIN ?_keyword K ON K.ID=S_CLICK.KEYWORD_ID
            WHERE S_LOG.VISITOR_ID=?
        ";
        $Sql = new Query($Query,false,$Visitor->ID);
        while ($Row=$Sql->Row()) {
            $Clicks[$Row->ID][$Row->K_ID]=$Row;
        }
    }

}

if ($View!='ajax') include $nsTemplate->Inc();
else include $nsTemplate->Inc('ajax/visitor_card.inc');

/////////////////////////////////////////////
///////// process functions here


function UpdateVisitor($Id, $EditArr)
{
	global $Db, $nsProduct, $nsUser, $CurrentCompany, $Lang;
	global $Logs, $NewIp;
	if (!ValidId($CurrentCompany->ID)) {
		$Logs->Err($Lang['ChooseClientForSave']);
		return;
	}
	extract($EditArr);
	if (!V($Watch)) $Watch=0;
	$Query = "SELECT ID FROM ?_client_visitor WHERE VISITOR_ID = ? AND COMPANY_ID=?";
	$Check=$Db->ReturnValue($Query, $Id, $CurrentCompany->ID);
	if ($Check) $Query = "UPDATE ?_client_visitor SET NAME = ?, DESCRIPTION = ? WHERE VISITOR_ID = $Id AND COMPANY_ID=".$CurrentCompany->ID;
	else $Query = "INSERT INTO ?_client_visitor (NAME, DESCRIPTION, VISITOR_ID, COMPANY_ID) VALUES (?, ?, $Id, ".$CurrentCompany->ID.")";
	$Db->Query($Query, $Name, $Descr);
	$CheckWatch=CheckVisWatch($Id, $nsUser->UserId());
	if (V($Watch)==1&&!$CheckWatch) SetVisWatch($Id, $nsUser->UserId());
	if (!V($Watch)&&$CheckWatch) RemoveVisWatch($Id, $nsUser->UserId());
	$nsProduct->Redir("visitor", "RUpd=1&VisId=$Id&NewIp=$NewIp", "admin");
}



function SetVisWatch($VisId, $UserId)
{
	global $Db;
	$Query = "INSERT INTO ?_watch (VISITOR_ID, USER_ID) VALUES (?, ?)";
	$Db->Query($Query, $VisId, $UserId);
}

function RemoveVisWatch($VisId, $UserId)
{
	global $Db;
	$Query = "DELETE FROM ?_watch WHERE VISITOR_ID=? AND USER_ID=?";
	$Db->Query($Query, $VisId, $UserId);
}


function CheckVisWatch($VisId, $UserId)
{
	global $Db;
	$Query = "SELECT ID FROM ?_watch WHERE VISITOR_ID=? AND USER_ID=?";
	return $Db->ReturnValue($Query, $VisId, $UserId);
}

function AddIp($Ip, $VisId) 
{
	global $Db;
	$Query="SELECT ID FROM ?_client_visitor_ip WHERE CLIENT_VISITOR_ID=? AND IP=?";
	$Check=$Db->ReturnValue($Query, $VisId, $Ip);
	if ($Check) return false;
	$Query = "INSERT INTO ?_client_visitor_ip (CLIENT_VISITOR_ID, IP) VALUES (?, ?)";
	$Db->Query($Query, $VisId, $Ip);
}

function RemoveIp($IpId, $VisId)
{
	global $Db;
	$Query = "DELETE FROM ?_client_visitor_ip WHERE ID=? AND CLIENT_VISITOR_ID=?";
	$Db->Query($Query, $IpId, $VisId);
}

function AddNewTag($VisId,$Tag)
{
    global $Db,$CpId,$nsProduct,$Mode,$EditArr;
    $TagId=GetTagId($Tag);
    $Query = "SELECT ID FROM ?_visitor_tag_rel WHERE COMPANY_ID=? AND VISITOR_ID=? AND TAG_ID=?";
    $CheckId=$Db->ReturnValue($Query,$CpId,$VisId,$TagId);
    if ($CheckId) return $CheckId;
    $Query = "INSERT INTO ?_visitor_tag_rel (COMPANY_ID,VISITOR_ID,TAG_ID) VALUES (?,?,?)";
    $Db->Query($Query,$CpId,$VisId,$TagId);
    
    if ($Mode!='Edit') $nsProduct->Redir('visitor',"ViewId=$VisId");
}

function GetTagId($Tag)
{
    global $Db, $CpId;
    $Query = "SELECT ID FROM ?_tag WHERE MD5_HASH = MD5(?)";
    $CheckId=$Db->ReturnValue($Query,$Tag);
    if ($CheckId) return $CheckId;
    $Query = "INSERT INTO ?_tag (MD5_HASH,TAG) VALUES (MD5(?),?)";
    $Db->Query($Query,$Tag,$Tag);
    return $Db->LastInsertId;
}

function RemoveTag($VisId,$TagId)
{
    global $Db,$CpId,$nsProduct,$Mode;
    $Query = "DELETE FROM ?_visitor_tag_rel WHERE COMPANY_ID=? AND VISITOR_ID=? AND TAG_ID=?";
    $Db->Query($Query,$CpId,$VisId,$TagId);
    $nsProduct->Redir("visitor",($Mode=='Edit'?"VisId":"ViewId")."=$VisId");
}

/////////////////////////////////////////////
///////// library section


?>