<?
if (!defined("NS_TRACKER_INDEX")) exit;
if (function_exists("ini_set")) @set_time_limit(0);
if ($nsProduct->VERSION!=$TrackerVersion) exit;
$SetSleepMessageFunc="SetSleepMessage";

require_once SELF. '/lib/cron/cron.func.php';
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/class/split_v2.class.php";
require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/lib/reports/static_report.func.php";
require_once SELF."/lib/reports/do_cache.func.php";

$RunId=md5(time());
$CpTZ=array();
$RunMode=0;

$CheckCacheId=V($_GP['CheckCacheId']);
$DoCacheId=V($_GP['DoCacheId']);
$SetToCache=V($_GP['SetToCache']);
$CpId=V($_GP['CpId']);
$Add=V($_GP['Add']);
$AddHash=V($_GP['AddHash']);
$UserId=V($_GP['UserId']);
$ReportId=V($_GP['ReportId']);
$FunnelId=V($_GP['FunnelId']);
$CustomReportId=V($_GP['CustomReportId']);
$SetUpdateCacheMode=V($_GP['SetUpdateCacheMode']);
$GetSqlCacheId=V($_GP['GetSqlCacheId']);

$SkipCache=false;

if (!isset($Settings)) $Settings=GetSettings();
if (!defined("NO_CRON_COMMENTS")) define("NO_CRON_COMMENTS",true);
if (!function_exists("CheckCpuLoad")) { function CheckCpuLoad() {return 0;} }
if (!V($CurrentTask)) $CurrentTask="CACHE";

if ($CheckCacheId) CheckCacheId($CheckCacheId, $CpId, $Add);
if ($DoCacheId) RunRequestedCache($DoCacheId, $CpId, $Add);
if ($SetToCache) SetToCache($SetToCache, $CpId, $Add, $AddHash);
if ($SetUpdateCacheMode) SetUpdateCacheMode($SetUpdateCacheMode,$UserId);
if ($GetSqlCacheId) GetReportSql($GetSqlCacheId, $ReportId);

if ( (!$Settings['All']->CACHE_DYNAMIC_ENABLE || !$Settings['All']->CACHE_AUTO_ENABLE) && !$GetSqlCacheId && !$FunnelId) {
    RunAllCache(true); // express mode only
    if (function_exists("FinishCronTask")) FinishCronTask();
    $SkipCache=true;
    return;
}

$SaveMode=""; //        SortRows
$OrderBy="";
$OrderTo="";

if (!NO_CRON_COMMENTS) echo "Caching... \n";
if (!$SkipCache) RunAllCache();

//////////////////////////////////////////////////////////////////////

// RunMode: 1 popular, 2 hidden, 3 static, 4 request, 5 message

function RunAllCache($ExpressOnly=false)
{
    global $Db;
        $Query = "
            SELECT C.ID, CO.TIMEZONE, CO.CACHE_DYNAMIC_ENABLE
            FROM ?_client C
                INNER JOIN ?_config CO
                    ON CO.COMPANY_ID=C.ID AND CO.SITE_ID=0
            ORDER BY C.ID
        ";
    $Sql = new Query($Query);
    $ClientArr=array();
    $FullClientArr = array();
    $ClientTZ=array();
    while ($Row=$Sql->Row()) {
        $FullClientArr[]=$Row->ID;
        $ClientTZ[$Row->ID]=$Row->TIMEZONE;
        if (!$Row->CACHE_DYNAMIC_ENABLE) continue;
        $ClientArr[]=$Row->ID;
    }

    CacheExpress($ClientArr);
    CacheFunnels($FullClientArr);
    CleanReportTimeStat();
    if ($ExpressOnly) return false;

    for ($i=0;$i<count($ClientArr);$i++) {
        CachePopular($ClientArr[$i]);
        CacheHiddenReports($ClientArr[$i]);
        CleanCache($ClientArr[$i]);
        CleanLog($ClientArr[$i]);
    }
    CacheStaticReport($ClientArr, $ClientTZ);
    CacheExpress($ClientArr);
    FinishCache();
}

function CacheFunnels($FullClientArr, $NoComment=NO_CRON_COMMENTS)
{
    global $Db, $RunMode;
    $RunMode=4;
    $Cnt=0;
    foreach ($FullClientArr as $CpId) {
        if (IsCronTaskFinished()) return false;
        $Query = "SELECT * FROM ?_{$CpId}_cache WHERE TO_CACHE='1' AND CACHE_TYPE='5' ORDER BY ID LIMIT 1";
        $Cache= $Db->Select($Query);
        if (!$Cache) continue;
        CheckCpuLoad($CpId,$NoComment);
        $RunMode=4;
        DoCache($Cache, $CpId,$NoComment);
        $Cnt++;
    }
    if ($Cnt>0) CacheFunnels($FullClientArr);
}

function CacheExpress($ClientArr, $NoComment=NO_CRON_COMMENTS)
{
    global $Db, $RunMode;
    $RunMode=4;
    $Cnt=0;
    foreach ($ClientArr as $CpId) {
        if (IsCronTaskFinished()) return false;
        $Query = "SELECT * FROM ?_{$CpId}_cache WHERE TO_CACHE='1' ORDER BY ID LIMIT 1";
        $Cache= $Db->Select($Query);
        if (!$Cache) continue;
        CheckCpuLoad($CpId,$NoComment);
        $RunMode=4;
        DoCache($Cache, $CpId,$NoComment);
        $Cnt++;
    }
    if ($Cnt>0) CacheExpress($ClientArr);
}


function CachePopular($CpId=false, $NoComment=NO_CRON_COMMENTS)
{
    if (!$CpId) return false;
    global $Db, $Settings, $RunMode;
    $RunMode=1;
    $Cnt=$Settings['All']->CACHE_POPULAR_CNT;
    if (!$Cnt) return false;
    $CacheUpdate=V($Settings['All']->CACHE_UPDATE_TIME,'');
    $TimeArr=array();
    $UpdateMin=false;
    if ($CacheUpdate) {
        $Arr=explode("|",$CacheUpdate);
        foreach ($Arr as $val) {
            $SubArr=explode("-",$val);
            $TimeArr[$SubArr[0]]=$SubArr[1];
            $UpdateMin=$SubArr[1];
        }
    }
    if (empty($TimeArr)) return false;
    $Period=$Settings['All']->CACHE_POPULAR_PERIOD;
    if (!$Period) $Period='d';
    $PArr=array("h"=>"HOUR", "d"=>"DAY", "w"=>"WEEK", "m"=>"MONTH", "y"=>"YEAR");
    $Period=$PArr[$Period];
    $Stamp=gmdate("Y-m-d H:i:s", time());

    $Query = "
        SELECT
            CP.CACHE_ID,
            CP.ADDITIONAL AS ADDI, CP.ADDITIONAL_TASK AS ADDT,
            COUNT(CP.ID) AS CNT,
            AVG(CL.RUN_TIME) as AVG_TIME,
            UNIX_TIMESTAMP('$Stamp')-UNIX_TIMESTAMP(C.LAST_CACHED) AS TIME_DIFF,
            C.*
            FROM ?_{$CpId}_cache_popularity CP
                INNER JOIN ?_{$CpId}_cache C
                    ON C.ID=CP.CACHE_ID
                INNER JOIN ?_{$CpId}_cache_cron_log CL
                    ON CL.CACHE_ID=CP.CACHE_ID
            WHERE CP.STAMP >= DATE_ADD('$Stamp', INTERVAL -1 $Period)
                        AND C.CACHE_TYPE='0'
                        AND CL.STAMP >= DATE_ADD('$Stamp', INTERVAL -1 $Period)
            GROUP BY CP.ADDITIONAL, CP.CACHE_ID
            HAVING CNT >= $Cnt
    ";
    $Sql = new Query($Query);
    $CacheArr=array();
    while($Row=$Sql->Row()) $CacheArr[]=$Row;
    for($i=0;$i<count($CacheArr);$i++) {
        if (IsCronTaskFinished()) return false;
        foreach ($TimeArr as $T=>$P) if((double)$CacheArr[$i]->AVG_TIME<(double)$T) $UpdateMin=$P;
        if ($CacheArr[$i]->TIME_DIFF<$UpdateMin) continue;
        CheckCpuLoad($CpId,$NoComment);
        $RunMode=1;
        $Add=$CacheArr[$i]->ADDT;
        DoCache($CacheArr[$i], $CpId, $NoComment, $Add);
    }
}


function CacheStaticReport($ClientArr=array(), $ClientTZ=array(), $NoComment=NO_CRON_COMMENTS)
{
    global $Db,$Logs,$CronStartTime,$PrevCronDuration, $RunMode;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Perc=0;
    $CpId=0;
    $Query = "
            SELECT R.ID, RP.ID AS PERIOD_ID, RP.PERIOD, RP.NEXT_UPDATE_TIME, R.ADDITIONAL_TASK
                FROM ?_static_report_periods RP
                INNER JOIN ?_static_report R
                    ON R.ID=RP.REPORT_ID
                ORDER BY RP.NEXT_UPDATE_TIME ASC
    ";
    $Sql = new Query($Query);
    while ($Period=$Sql->Row()) {
        if ($Perc>=80) return;
        $CheckId=$Period->ID;
        $PeriodId=$Period->PERIOD_ID;
        $D=$Period->PERIOD;
        $NextUpdateTime=$Period->NEXT_UPDATE_TIME;
        $DoUpdateTime=false;
        $RunMode=3;

        foreach ($ClientArr as $CpId) {
            $TZ=SqlTZ($ClientTZ[$CpId]);
            $Skip=$Db->ReturnValue("SELECT IF( '$NextUpdateTime' < DATE_ADD('$Stamp', INTERVAL '$TZ' HOUR_MINUTE) ,1,0)");
            if (!$Skip) continue;
            $DoUpdateTime=true;
            if (!$NoComment) echo "CpId: $CpId, Static report id: $CheckId , DP: $D\n";
            $Query = "
                    SELECT C.*, RC.REPORT_ID
                    FROM ?_{$CpId}_static_report_cache RC
                    INNER JOIN ?_{$CpId}_cache C
                        ON C.ID=RC.CACHE_ID
                    WHERE REPORT_ID=$CheckId AND PERIOD_ID=$PeriodId";
            $SubSql= new Query($Query);
            $CacheArr=array();
            while($Row=$SubSql->Row()) $CacheArr[]=$Row;
            for($i=0;$i<count($CacheArr);$i++) {
                if (IsCronTaskFinished()) return false;
                CheckCpuLoad($CpId,$NoComment);
                $RunMode=3;
                DoCache($CacheArr[$i], $CpId, $NoComment, $Period->ADDITIONAL_TASK);
            }
        }

        if ($DoUpdateTime) {
            $Query = "UPDATE ?_static_report SET LAST_UPDATED = '$Stamp' WHERE ID = $CheckId";
            $Db->Query($Query);
            SetUpdateTime($CheckId, $PeriodId, NextUpdateTime($CpId, $CheckId, $PeriodId));
        }

        CacheExpress($ClientArr);
        if (!$DoUpdateTime) break;
        $CurrentTime=$Db->GetMicrotime();
        $Diff=$CurrentTime-$CronStartTime;
        $Perc=ceil(100*$Diff/$PrevCronDuration);
    }
}

function RunRequestedCache($Id, $CpId=false, $Add=false)
{
    if (!$CpId) return false;
    global $Db, $RunMode;
    $RunMode=4;
    if (function_exists("ini_set")) @ini_set("max_execution_time", 0);
    $IdArr=explode("|", $Id);
    $Cached=false;
    foreach ($IdArr as $Id) {
        if (!$Id) continue;
        $Query = "SELECT * FROM ?_{$CpId}_cache WHERE ID = ?";
        $Cache=$Db->Select($Query, false, $Id);
        if (!$Cache) continue;
        $Cache->ADDITIONAL_TASK=$Add;
        DoCache($Cache, $CpId, true);
        $Cached=true;
    }
    if ($Cached) echo '1';
    FinishCache(true);
}

function SetToCache($Id, $CpId=false, $Add=false, $AddHash=false)
{
    if (!$CpId) return false;
    global $Db, $UserId, $ReportId, $FunnelId, $CustomReportId;
    $IdArr=explode("|",$Id);
    foreach ($IdArr as $Id) {
        $Query = "UPDATE ?_{$CpId}_cache SET TO_CACHE='1', ADDITIONAL_TASK=? WHERE ID = ? ";
        $Db->Query($Query, $Add, $Id);
    }

    $Stamp=gmdate("Y-m-d H:i:s", time());
    if ($UserId) {
        if (!$ReportId) $ReportId=0;
        if (!$FunnelId) $FunnelId=0;
        if (!$CustomReportId) $CustomReportId=0;
        $Query = "INSERT INTO ?_user_cache (USER_ID, CACHE_ID, REPORT_ID, FUNNEL_ID, CUSTOM_REPORT, STAMP, COMPANY_ID)
                            VALUES (?,?,?,?,?,?,?)";
        $Db->Query($Query,$UserId,$Id,$ReportId,$FunnelId,$CustomReportId,$Stamp, $CpId);
    }

    if ($UserId && !$ReportId && !$FunnelId) {
        foreach ($IdArr as $Id) {
            $Query = "INSERT INTO ?_{$CpId}_cache_popularity (STAMP, CACHE_ID, ADDITIONAL_TASK, ADDITIONAL) VALUES (?,?,?,?)";
            $Db->Query($Query,$Stamp,$Id,$Add,$AddHash);
        }
    }

    echo '1';
    FinishCache(true);
}

function SetUpdateCacheMode($Mode=0,$UserId=false)
{
    global $Db;
    if ($Mode && $UserId) {
        $Query = "UPDATE ?_user_settings SET CACHE_UPDATE_MODE=? WHERE USER_ID=?";
        $Db->Query($Query,$Mode,$UserId);
    }
    echo '1';
    exit;
}

function CacheHiddenReports($CpId=false, $NoComment=NO_CRON_COMMENTS)
{
    if (!$CpId) return false;
    global $Db, $RunMode, $CronStartTime,$PrevCronDuration;
    $RunMode=2;
    $Perc=0;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "
        SELECT *
            FROM ?_{$CpId}_cache
            WHERE CACHE_TYPE='2' AND
                (UNIX_TIMESTAMP('$Stamp')-UNIX_TIMESTAMP(LAST_CACHED))/60 >= UPDATE_INTERVAL
            ORDER BY LAST_CACHED ASC
    ";
    $Sql = new Query($Query);
    $CacheArr=array();
    while($Row=$Sql->Row()) $CacheArr[]=$Row;
    for($i=0;$i<count($CacheArr);$i++) {
        if (IsCronTaskFinished()) return false;
        if ($Perc>=80) return;
        CheckCpuLoad($CpId,$NoComment);
        $RunMode=2;
        DoCache($CacheArr[$i], $CpId, $NoComment);
        $CurrentTime=$Db->GetMicrotime();
        $Diff=$CurrentTime-$CronStartTime;
        $Perc=ceil(100*$Diff/$PrevCronDuration);
    }
}




/////////////////////////////////////////////////////////////////////////
// LIBRARY


function FinishCache($Die=false)
{
    if ($Die) exit;
    if (function_exists("FinishCronTask")) FinishCronTask();
    else exit;
}









function ShowQuery($Query, $Time, $NoComment=NO_CRON_COMMENTS)
{
    if ($NoComment) return false;
    echo $Query;
    echo "\n\n\n";
}


function CleanLog($CpId=false)
{
    if (!$CpId) return false;
    global $Db;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "DELETE FROM ?_{$CpId}_cache_cron_log WHERE STAMP <= DATE_ADD('$Stamp', INTERVAL -1 MONTH)";
    $Db->Query($Query);
}


function CleanCache($CpId=false)
{
    if (!$CpId) return false;
    global $Db;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "DELETE FROM ?_{$CpId}_cache_popularity WHERE STAMP <= DATE_ADD('$Stamp', INTERVAL -1 MONTH)";
    $Db->Query($Query);
    $Arr=array();

    $Query = "
        SELECT C.ID
            FROM  ?_{$CpId}_cache C
            LEFT JOIN ?_{$CpId}_cache_popularity CP
                ON CP.CACHE_ID=C.ID
            WHERE C.CACHE_TYPE=0 AND C.TO_CACHE!='1'
                        AND C.LAST_CACHED < DATE_ADD('$Stamp', INTERVAL -1 YEAR)
                        AND CP.ID IS NULL
    ";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $Arr[]=$Row->ID;

    if (empty($Arr)) return false;

    $Query = "DELETE FROM ?_{$CpId}_cache WHERE ID IN (?)";
    $Db->Query($Query, $Arr);
    $Query = "DELETE FROM ?_{$CpId}_cache_data WHERE CACHE_ID IN (?)";
    $Db->Query($Query, $Arr);
    $Query = "DELETE FROM ?_{$CpId}_cache_cron_log WHERE CACHE_ID IN (?)";
    $Db->Query($Query, $Arr);

}


function CleanReportTimeStat()
{
    global $Db, $Settings;
    $KeepDays=$Settings['All']->CACHE_SMART_KEEP_DAYS;

    if ($KeepDays==0) {
        $Query = "TRUNCATE TABLE ?_report_time_stat";
        $Db->Query($Query);
        return;
    }

    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "
        DELETE FROM ?_report_time_stat
            WHERE STAMP <= DATE_ADD('$Stamp', INTERVAL -$KeepDays DAY)
    ";
    $Db->Query($Query);
}

function CreateCronRecord($CacheId=0, $CpId=0, $ReportId=0)
{
    if (!defined("CRON_MODE")) return 0;
    global $Db, $RunId,$Logs, $RunMode;
    if (!$CpId) return 0;
    $RunMode=V($RunMode,0);
    if (!$ReportId) $ReportId=0;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "INSERT INTO ?_{$CpId}_cache_cron_log
                    (CACHE_ID, STAMP, RUN_ID, REPORT_ID, RUN_MODE)
                    VALUES (?,?,?,?,?)";
    $Db->Query($Query, $CacheId, $Stamp, $RunId, $ReportId, $RunMode);
    return $Db->LastInsertId;
}

function UpdateCronLog($LogId=0, $RunTime=0, $CpuLoad=0, $CpuLoadBefore=0, $CpId=0)
{
    if (!defined("CRON_MODE")) return false;
    global $Db, $Logs;
    if (!$LogId) return false;
    if (!$CpId) return false;
    $Err=GetErrText();
    $Query = "UPDATE ?_{$CpId}_cache_cron_log SET RUN_TIME=?, ERRORS=?, CPU_LOAD=?, CPU_LOAD_BEFORE=? WHERE ID=?";
    $Db->Query($Query, $RunTime, ($Err)?$Err:"", $CpuLoad, $CpuLoadBefore, $LogId);
    DisplayErrors();
    $_SESSION['__Errors']=array();
}

function SetSleepMessage($CpId=false, $CpuLoad=0)
{
    if (!$CpId) return false;
    global $Db, $RunId, $RunMode;
    $RunMode=5;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "INSERT INTO ?_{$CpId}_cache_cron_log (STAMP, RUN_ID, RUN_MODE, MESSAGE, CPU_LOAD) VALUES (?, ?, ?, ?, ?)";
    $Db->Query($Query, $Stamp, $RunId, $RunMode, "x-sleep", $CpuLoad);
}

function CacheDone($CpId=false,$CacheId=false, $TZ=false)
{
    if (!$CpId||!$CacheId) return false;
    global $Db;
    $Stamp=gmdate("Y-m-d H:i:s", time());
    $Query = "UPDATE ?_{$CpId}_cache SET TO_CACHE='0', LAST_CACHED=?, LAST_CACHED_TZ=? WHERE ID=?";
    $Db->Query($Query,$Stamp,$TZ, $CacheId);
    $Query = "UPDATE ?_user_cache SET DONE=1 WHERE CACHE_ID=? AND DONE=0";
    $Db->Query($Query, $CacheId);
}



////////////////////////////////////////////////////////////////////////

function CheckCacheId($Id, $CpId=false, $Additional=false)
{
    if (!$CpId) return false;
    global $Db;
    $IdArr=explode("|", $Id);

    foreach ($IdArr as $Id) {
        $Query = "SELECT * FROM ?_{$CpId}_cache WHERE ID = $Id";
        $Cache=$Db->Select($Query);
        if ($Cache->TO_CACHE) {
            echo '0';
            FinishCache(true);
        }
        $Query = "SELECT ID FROM ?_{$CpId}_cache_data WHERE CACHE_ID=? AND (LIMIT_EXCEED=0 OR ADDITIONAL=?) ";
        $CheckId=$Db->ReturnValue($Query, $Id, $Additional);
        if (!$CheckId) {
            echo '0';
            FinishCache(true);
        }
    }

    if ($CheckId) echo "1";
    else echo "0";
    FinishCache(true);
}

function GetReportSql($CacheId=false, $ReportId=false)
{
    global $CpId, $Db;
    $Query = "SELECT * FROM ?_{$CpId}_cache WHERE ID=?    ";
    $Cache= $Db->Select($Query, false, $CacheId);
    if (!$Cache) exit;
    $AddTask=false;
    if ($ReportId) {
        $Report=$Db->Select("SELECT * FROM ?_static_report WHERE ID=?",false,$ReportId);
        $AddTask=$Report->ADDITIONAL_TASK;
    }
    $Sql = DoCache($Cache,$CpId,true,$AddTask,"QUERY");
    echo nl2br(trim($Sql));
    exit;
}
?>