<?

require_once SELF.'/class/button.class.php';

class ReportData {

    function ReportData($Mode="NATURAL")
    {
        global $Lang;
        $this->Mode=$Mode;
        $this->SuperColumnEnable=false; //     colspan
        $this->EnableHighlight=false; //     
        $this->ShowNextStep=true; //      
        $this->ShowSimpleName=false; //       
        $this->EnableSorting=true; //    
        $this->NameColumn="Name"; // ,       
        $this->EnableSubValues=true; //    
        $this->CurrentPath=getURL();
        $this->CurrentOrderBy="";
        $this->CurrentOrderTo="";
        $this->JsIncluded=false;
        $this->Report=false; //    
        $this->NameColWidth="20";
        $this->ShowSubSum = false; //   ( ,   )
        $this->ShowRealSum = false; //    ()
        $this->ShowLimitExceed = false; //    ,     
        $this->GraphPlace=-1; // -1  , 0  , 1  
        $this->CssIncluded = false;
        //      
        //       
        $this->ColumnOrder = array("Name",
                                            "Online", "CntClick","UniClick", "Visits", "New", "Returning",
                                            "CntCamp", "UniCamp", "Camp",
                                            "CntSale","UniSale","Income",
                                            "CntAction","UniAction",
                                            "ROI","CampCost","TotalIncome",
                                            "ActionConv","SaleConv");
        //     colspan
        //       
        $this->SuperColumns=array(
            "Click"=>array("Name"=>($Mode=="NATURAL")?@$Lang['RHeaderPV']:@$Lang['RHeaderClick'],"Cnt"=>0, "OrderBy"=>array()),
            "Visitor"=>array("Name"=>@$Lang['RHeaderVisitor'],"Cnt"=>0, "OrderBy"=>array()),
            "Sale"=>array("Name"=>@$Lang['RHeaderSale'],"Cnt"=>0,"OrderBy"=>array()),
            "Action"=>array("Name"=>@$Lang['RHeaderAction'],"Cnt"=>0,"OrderBy"=>array()),
            "Conv"=>array("Name"=>@$Lang['RHeaderConversion'],"Cnt"=>0,"OrderBy"=>array()),
            "Camp"=>array("Name"=>@$Lang['RHeaderClick'], "Cnt"=>0, "OrderBy"=>array())
        );
        $this->Columns = array();
        $this->ColumnsSubSum = $this->ColumnsSubMax = $this->ColumnsSumMin = $this->ColumnsSubAvg = array();
        $this->Rows=array();
        $this->Graphs=array();

        $this->_NameColumn=false;
        $this->_ColWidth=0;
        $this->_GraphDisplayed = false;

        $this->CacheId=false;
        $this->ReportId=false;

        $this->BottomCaption = false;
        $this->TopCaption = false;
        $this->XlsExportEnable = @function_exists('iconv'); //     xls
        $this->CsvExportEnable = true;
        $this->PrintEnable = V($_REQUEST['_print'])?false:true;
        $this->EmailEnable = true;
        $this->SaveEnable = false;
        $this->SaveLink = false;
        $this->SaveJs = false;
        $this->RefreshLink = '';
        $this->RefreshJs = '';
        $this->ShowNoRecords = false;
        $this->Id = 1;

        // email variables
        $this->FileData = false;
        $this->ReturnFileMode=false;
        $this->EmailMode=false;
        $this->JsFilterObject = false;

        $this->CaptionButtonsLeft=array();
        $this->CaptionButtonsRight=array();

        // rss
        $this->RssLink = false;
    }

    function AddColumn($Key=false,$Name=false,$OrderBy=false,$ParentKey=false,$Percents=false,$NoSplit=false)
    {
        if (!$Key) return false;
        $ColIndex=0;
        if ($Key==$this->NameColumn) $this->_NameColumn=true;
        if ($ParentKey) {
            $this->SuperColumnEnable=true; //     
            $this->SuperColumns[$ParentKey]['Cnt']++; //   colspan
            $ColIndex=$this->SuperColumns[$ParentKey]['Cnt'];
            if ($OrderBy) $this->SuperColumns[$ParentKey]['OrderBy'][]=$OrderBy;
            //     
        }
        if (is_array($Percents)) {
            extract($Percents); //      
            $Percents = @$Percents['Percents'];
        }
        $this->Columns[$Key]=array("Name"=>$Name,"OrderBy"=>$OrderBy,
                                                        "ParentKey"=>$ParentKey, "Percents"=>$Percents,
                                                        "ColIndex"=>$ColIndex, "NoSplit"=>$NoSplit, 'NoWrap'=>@$NoWrap, 'Align'=>@$Align,
                                                        "NoFormat"=>@$NoFormat, 'FormatFunc'=>@$FormatFunc, 'Width'=>@$Width,
                                                        'CustomColumn'=>@$CustomColumn, 'CheckBox'=>@$CheckBox, 'Icons'=>@$Icons,
                                                        'String'=>@$String, 'Money'=>@$Money);
    }

    function RemoveColumn($Key=false)
    {
        if (!$Key || !isset($this->Columns[$Key])) return false;
        if ($this->Columns[$Key]['ParentKey']) {
            $PKey=$this->Columns[$Key]['ParentKey'];
            $this->SuperColumns[$PKey]['Cnt']--;
            $SCEnable=false;
            foreach ($this->SuperColumns as $k=>$v) if ($v['Cnt']>0) $SCEnable=true;
            $this->SuperColumnEnable=$SCEnable;
        }
        if ($Key==$this->NameColumn) $this->_NameColumn=false;
        unset($this->Columns[$Key]);
    }

    function AddGraph($Key=false, &$GraphObj)
    {
        if ($this->GraphPlace==-1) return false;
        if (!$Key || !$GraphObj) return false;
        if (is_array($Key)) foreach ($Key as $v) {if (isset($this->Columns[$v]))  {$Key=$v; break;}}
        if (is_array($Key)) return false;
        if (!isset($this->Columns[$Key])) return false;
        $this->Graphs[$Key]=&$GraphObj;
    }

    function AddRow($Row=false)
    {
        if (!$Row) return false;
        $this->Rows[]=$Row;
    }

    function AddRows($Arr=array())
    {
        foreach ($Arr as $Row) $this->AddRow($Row);
    }

    function MakeSum()
    {
        foreach ($this->Columns as $k=>$v) {
            foreach ($this->Rows as $i=>$Row) {
                if ($k=='Name') continue;
                if (!isset($Row[$k])) continue;
                if (!isset($this->ColumnsSubSum[$k])) $this->ColumnsSubSum[$k]=0;
                if (!isset($this->ColumnsSubMax[$k])) $this->ColumnsSubMax[$k]=0;
                if (!isset($this->ColumnsSubAvg[$k])) $this->ColumnsSubAvg[$k]=0;
                if (!isset($this->ColumnsSubMin[$k])) $this->ColumnsSubMin[$k]=$Row[$k];
                $this->ColumnsSubSum[$k] += $Row[$k];
                $this->ColumnsSubMax[$k] = max($this->ColumnsSubMax[$k], $Row[$k]);
                $this->ColumnsSubMin[$k] = min($this->ColumnsSubMin[$k], $Row[$k]);
            }
        }
        foreach ($this->Columns as $k=>$v) {
            if (!isset($this->ColumnsSubMax[$k]) || !isset($this->ColumnsSubMin[$k])) continue;
            $this->ColumnsSubAvg[$k] = ceil(($this->ColumnsSubMin[$k]+$this->ColumnsSubMax[$k])/2);
        }
    }

    function HasColumn($Key)
    {
        if (is_array($Key)) {
            foreach ($Key as $v) if (isset($this->Columns[$v])) return true;
            return false;
        }
        return isset($this->Columns[$Key]);
    }

    function ColWidth($Key=false)
    {
        if($Key && isset($this->Columns[$Key]['Width'])) return $this->Columns[$Key]['Width'];
        if($this->_ColWidth>0) return $this->_ColWidth;
        $this->_ColWidth=ceil((100-($this->_NameColumn?$this->NameColWidth:0))/count($this->Columns));
        return $this->_ColWidth;
    }

    function SetDisplayGraph()
    {
        $this->_GraphDisplayed = true;
        if (!empty($this->Graphs)) {
            foreach ($this->ColumnOrder as $Key) {
                if (isset($this->Graphs[$Key])) {
                    $this->Graphs[$Key]->Display=true;
                    break;
                }
            }
        }
    }

    function HtmlDump()
    {
        global $nsProduct,$Lang,$nsUser,$nsTemplate, $CurrentCompany, $GroupBy, $Get, $WhereArr;
        global $ViewDate,$CpId;
        $this->ShowNextStep = V($GLOBALS['Print'])? false : $this->ShowNextStep;
        $IncPrintHeader = false;
        if (V($GLOBALS['Print']) && !@$GLOBALS['PrintHeaderIncluded']) $IncPrintHeader=true;
        if ($IncPrintHeader) include $nsTemplate->Inc('inc/print_header');
        if (!$this->_GraphDisplayed) $this->SetDisplayGraph();
        $this->PrepareButtons();
        include $nsTemplate->Inc("constructor/constructor_data");
        if ($IncPrintHeader) include $nsTemplate->Inc('inc/print_footer');
    }

    function CsvExport($Filename=false, $Separator=";")
    {
        if (!$Filename) $Filename = $this->Filename('cvs');
        global $CurrentCompany, $Lang;
        $Data="";
        $i=0;
        foreach ($this->ColumnOrder as $Key) {
            if (!isset($this->Columns[$Key])) continue;
            if (@$this->Columns[$Key]['CustomColumn']) continue;
            if ($i>0) $Data.=$Separator;
            $Data.=$this->CsvEscape($this->Columns[$Key]['Name'],$Separator);
            $i++;
        }
        $Data.="\n";

        foreach ($this->Rows as $Row) {
            $i=0;
            foreach ($this->ColumnOrder as $Key) {
                if (!isset($this->Columns[$Key])) continue;
                if (@$this->Columns[$Key]['CustomColumn']) continue;
                if ($i>0) $Data.=$Separator;
                if ($Key==$this->NameColumn) {
                    $Data.=$this->CsvEscape($Row[$Key],$Separator);
                    $i++; continue;
                }
                $Str=V($Row[$Key]);
                if (!@$this->Columns[$Key]['FormatFunc']) {
                    if (in_array($Key,array("Income", "TotalIncome", "CampCost")))
                        $Str=ShowCost(V($Row[$Key],0),@$CurrentCompany->CUR);
                    elseif (!$this->Columns[$Key]['NoFormat'])  $Str=number_format(V($Row[$Key],0),",");
                    if ($this->Columns[$Key]['Percents']) $Str.="%";
                    if ($this->EnableSubValues) {
                        if (isset($Row[$Key.'Perc'])&&$Row[$Key.'Perc']>0) $Str.=" (".$Row[$Key.'Perc']."%)";
                        if (isset($Row[$Key.'OneOf'])) $Str.=" (".$Row[$Key.'OneOf'].")";
                    }
                } else {
                    $F = $this->Columns[$Key]['FormatFunc'];
                    $Str = strip_tags($F($Str));
                }
                $Data.=$this->CsvEscape($Str,$Separator);
                $i++;
            }
            $Data.="\n";
        }

        if ($this->ShowSubSum && count($this->Rows) > 1 && !empty($this->ColumnsSubSum)) {
            foreach (array('ColumnsSubSum', 'ColumnsSubMin', 'ColumnsSubAvg', 'ColumnsSubMax') as $f) {
                $i=0;
                foreach ($this->ColumnOrder as $Key) {
                    if (!isset($this->Columns[$Key])) continue;
                    if ($i>0) $Data.=$Separator;
                    $Column=$this->Columns[$Key];
                    if ($this->NameColumn==$Key)  $Data.=$this->CsvEscape(@$Lang[$f],$Separator);
                    elseif (!$this->Columns[$Key]['Percents']) {
                        $Arr =& $this->$f;
                        $Str = V($Arr[$Key],0);
                        if (in_array($Key,array("Income", "TotalIncome", "CampCost")))
                            $Str = ShowCost($Str,$CurrentCompany->CUR);
                        else  $Str= number_format($Str,",");
                        $Data.=$this->CsvEscape($Str,$Separator);
                        $i++;
                    }
                }
                $Data.="\n";
            }
        }

        if ($this->ShowRealSum && count($this->Rows) > 1 && empty($this->ColumnsRealSum)) {
            $i = 0;
            foreach ($this->ColumnOrder as $Key) {
                if (!isset($this->Columns[$Key])) continue;
                if ($i>0) $Data.=$Separator;
                $Column=$this->Columns[$Key];
                if ($this->NameColumn==$Key) $Data.=$this->CsvEscape(@$Lang['RealColumnSum'],$Separator);
                elseif (!$this->Columns[$Key]['Percents'] && !in_array($Key,array('ROI','CampCost')) ) {
                    $Str = V($this->ColumnsRealSum[$Key],0);
                    if (in_array($Key,array("Income", "TotalIncome", "CampCost")))
                        $Str = ShowCost($Str,$CurrentCompany->CUR);
                    else $Str = number_format($Str,",");
                    $Data.=$this->CsvEscape($Str,$Separator);
                    $i++;
                }
            }
            $Data.="\n";
        }

        if ($this->ReturnFileMode) return $Data;
        header("Content-type: application/ofx");
        header("Content-Disposition: attachment; filename=$Filename");
        echo $Data;
        exit;
    }

    function XlsXmlExport($Filename='export.xls') {
        global $LangConfig, $CurrentCompany;

        $Data='<?xml version="1.0"?><?mso-application progid="Excel.Sheet"?>';
        $Data.='<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
                       xmlns:o="urn:schemas-microsoft-com:office:office"
                       xmlns:x="urn:schemas-microsoft-com:office:excel"
                       xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
                       xmlns:html="http://www.w3.org/TR/REC-html40">';
        $Data.='<DocumentProperties xmlns="urn:schemas-microsoft-com:office:office"><Version>12.00</Version></DocumentProperties>';
        $Data.='<Worksheet ss:Name="1"><Table>'."\n";
        require_once SYS.'/system/class/convertcharset/convert_charset.class.php';
        $Convert=new nsConvertCharset();

        $R=0; $i=0;
        foreach ($this->Rows as $Row) {
            if ($R==1000) {
                $Worksheet =& $Workbook->addWorksheet();
                $Worksheet->setInputEncoding(@$LangConfig['charset']);
                $R=0;
            }
            if ($R==0) {
                $Col=0;
                $Data .= '<Row>'."\n";
                foreach ($this->ColumnOrder as $Key) {
                    if (!isset($this->Columns[$Key])) continue;
                    if (@$this->Columns[$Key]['CustomColumn']) continue;

                    $Str=$Convert->Convert($this->Columns[$Key]['Name'], @$LangConfig['charset'], 'UTF-8');
                    $Data .= '<Cell>';
                    $Data .= '<Data ss:Type="String">'.htmlspecialchars($Str).'</Data>';
                    $Data .= '</Cell>'."\n";
                    $Col++;
                    $i++;
                }
                $Data .= '</Row>'."\n";
                $R++;
            }

            $Col=0;
            $Data .= '<Row>'."\n";
            foreach ($this->ColumnOrder as $Key) {
                if (!isset($this->Columns[$Key])) continue;
                if (@$this->Columns[$Key]['CustomColumn']) continue;
                if ($Key==$this->NameColumn) {
                    $Worksheet->writeString($R, $Col, $Row[$Key]);
                    $Col++; continue;
                }
                $Str=V($Row[$Key]);

                if (!@$this->Columns[$Key]['FormatFunc']) {
                    if (in_array($Key,array("Income", "TotalIncome", "CampCost")))
                        $Str=ShowCost(V($Row[$Key],0),@$CurrentCompany->CUR);
                    elseif (!$this->Columns[$Key]['NoFormat'])  $Str=number_format(V($Row[$Key],0),",");
                    if ($this->Columns[$Key]['Percents']) $Str.="%";
                    if ($this->EnableSubValues) {
                        if (isset($Row[$Key.'Perc'])&&$Row[$Key.'Perc']>0) $Str.=" (".$Row[$Key.'Perc']."%)";
                        if (isset($Row[$Key.'OneOf'])) $Str.=" (".$Row[$Key.'OneOf'].")";
                    }
                } else {
                    $F = $this->Columns[$Key]['FormatFunc'];
                    $Str = strip_tags($F($Str));
                }
                $Str=$Convert->Convert($Str, @$LangConfig['charset'], 'UTF-8');
                $Data .= '<Cell>';
                $Data .= '<Data ss:Type="String">'.htmlspecialchars($Str).'</Data>';
                $Data .= '</Cell>'."\n";

                $Col++;
                $i++;
            }
            $Data .= '</Row>'."\n";
            $R++;
        }

        if ($this->ShowSubSum && count($this->Rows) > 1 && !empty($this->ColumnsSubSum)) {
            foreach (array('ColumnsSubSum', 'ColumnsSubMin', 'ColumnsSubAvg', 'ColumnsSubMax') as $f) {
                $R++;
                $Col=0;
                foreach ($this->ColumnOrder as $Key) {
                    if (!isset($this->Columns[$Key])) continue;
                    $Column=$this->Columns[$Key];
                    if ($this->NameColumn==$Key) $Worksheet->write($R, $Col, @$Lang[$f]);
                    elseif (!$this->Columns[$Key]['Percents']) {
                        $Arr =& $this->$f;
                        $Str = V($Arr[$Key],0);
                        if (in_array($Key,array("Income", "TotalIncome", "CampCost")))
                            $Str = ShowCost($Str,$CurrentCompany->CUR);
                        else  $Str= number_format($Str,",");
                        $Str=$Convert->Convert($Str, @$LangConfig['charset'], 'UTF-8');
                        $Data .= '<Cell>';
                        $Data .= '<Data ss:Type="String">'.htmlspecialchars($Str).'</Data>';
                        $Data .= '</Cell>'."\n";
                    }
                    $Col++;
                }
            }
        }

        if ($this->ShowRealSum && count($this->Rows) > 1 && empty($this->ColumnsRealSum)) {
            $R++; $Col = 0;
            foreach ($this->ColumnOrder as $Key) {
                if (!isset($this->Columns[$Key])) continue;
                $Column=$this->Columns[$Key];
                if ($this->NameColumn==$Key) $Worksheet->write($R, $Col, @$Lang['RealColumnSum']);
                elseif (!$this->Columns[$Key]['Percents'] && !in_array($Key,array('ROI','CampCost')) ) {
                    $Str = V($this->ColumnsRealSum[$Key],0);
                    if (in_array($Key,array("Income", "TotalIncome", "CampCost")))
                        $Str = ShowCost($Str,$CurrentCompany->CUR);
                    else $Str = number_format($Str,",");
                    $Str=$Convert->Convert($Str, @$LangConfig['charset'], 'UTF-8');
                    $Data .= '<Cell>';
                    $Data .= '<Data ss:Type="String">'.htmlspecialchars($Str).'</Data>';
                    $Data .= '</Cell>'."\n";
                }
                $Col++;
            }
        }

        $Data.='</Table></Worksheet></Workbook>'."\n";

        if ($this->ReturnFileMode) return $Data;
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"$Filename\"");
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
        header("Pragma: public");

        if (!$this->ReturnFileMode) exit;
    }

    function XlsExport($Filename=false, $StorePath=false, $AdditionalLines=array())
    {
        if (!$Filename) $Filename = $this->Filename('xls');
        global $CurrentCompany, $LangConfig, $Logs, $Lang, $nsLang;
        if (!@function_exists('iconv')) return $Logs->Err(@$Lang['ExportIconv']);
        if (!is__writable(SELF.'/store')) return $Logs->Err(@$Lang['TempIsNotWritable']);
        require_once SELF.'/class/excel/Writer.php';

        $nsLang->TplInc('inc/filter');

        // Creating a workbook
        $Workbook = new Spreadsheet_Excel_Writer();
        $Workbook->setVersion(8);

        // sending HTTP headers
        if (!$this->ReturnFileMode) $Workbook->send($Filename);

        // Creating a worksheet
        $Worksheet =& $Workbook->addWorksheet();
        $Workbook->setTempDir(SELF.'/store');
        $Worksheet->setInputEncoding(@$LangConfig['charset']);

        $SubHeader =& $Workbook->addFormat(array('left'=>1, 'bottom'=>2));
        $SingleHeader =& $Workbook->addFormat(array('left'=>1, 'bottom'=>2, 'bold'=>1, 'align'=>'vcenter'));
        $SingleHeader2 =& $Workbook->addFormat(array('left'=>1, 'bottom'=>2, 'bold'=>1));
        $SuperHeader =& $Workbook->addFormat(array('left'=>1, 'bottom'=>1, 'bold'=>1));
        $NameCol =& $Workbook->addFormat(array('left'=>1, 'bold'=>1));
        $SectionCol =& $Workbook->addFormat(array('left'=>1));
        $PercentColumn =& $Workbook->addFormat();
        $PercentColumn->setNumFormat('0.00%');
        $SectionColPerc =& $Workbook->addFormat(array('left'=>1));
        $SectionColPerc->setNumFormat('0.00%');
        $TitleCol =& $Workbook->addFormat(array('bottom'=>1));
        $SectionEmpty =& $Workbook->addFormat(array('left'=>1));
        $RowEmpty =& $Workbook->addFormat(array('bottom'=>2));
        $RowEmpty2 =& $Workbook->addFormat(array('bottom'=>1));
        $CellBlank =& $Workbook->addFormat(array());
        $Title =& $Workbook->addFormat(array('bottom'=>1, 'align'=>'center'));
        $Title->setAlign('vcenter');

        $Worksheet->write(0, 0, strip_tags((@$this->ReportCaptionLast ? $this->ReportCaptionLast: $this->TopCaption)), $Title);

        $PrevSuperColumn='';
        $Level1=array();
        $Level2=array();
        $ParentStart=array();
        $TotalCols = 0;
        $Col=0;
        $Spacers = array();
        foreach ($this->ColumnOrder as $k) {
            if (!isset($this->Columns[$k])) continue;
            if (@$this->Columns[$k]['CustomColumn']) continue;
            $R=1;
            $Column =& $this->Columns[$k];
            if (!isset($Level2[$k])) $Level2[$k] = 1;
            if ($this->EnableSubValues) foreach ($this->Rows as $Row) {
                if ( @$Row[$k.'Perc'] ) $Level2[$k]=2;
                if ( @$Row[$k.'OneOf'] ) $Level2[$k]=2;
            }
            if (in_array($k, array('ActionConv', 'SaleConv'))) $Level2[$k]=2;
            $TotalCols += $Level2[$k];
            $Parent = $Column['ParentKey'];
            if (!isset($Level1[$Parent])) $Level1[$Parent] = $Level2[$k];
            else  $Level1[$Parent] += $Level2[$k];

            if ($this->SuperColumnEnable) {
                if (!$Parent) {
                    for ($i=0; $i< $Level2[$k]; $i++) {
                        $Worksheet->write($R, $Col+$i, ($i==0 ? $Column['Name'] : ''), $SingleHeader);
                        $Worksheet->write($R+1, $Col+$i, '', $SingleHeader);
                    }
                    $Worksheet->mergeCells($R, $Col, $R+1, $Col+$Level2[$k]-1); //    ,     
                    $R++;
                }
                if ($Parent && $PrevSuperColumn != $Parent) {
                    $ParentStart[$Parent]=$Col;
                    for ($i=0; $i< $Level2[$k]; $i++) {
                        $Worksheet->write($R, $Col+$i, $this->SuperColumns[$Parent]['Name'], $SuperHeader);
                        $Worksheet->write($R+1, $Col+$i, $Column['Name'], $SubHeader);
                    }
                    $R++;
                }
                if ($Parent && $PrevSuperColumn == $Parent) {
                    for ($i=0; $i< $Level2[$k]; $i++) {
                        $Worksheet->write($R, $Col+$i, '', $SuperHeader);
                        $Worksheet->write($R+1, $Col+$i, $Column['Name'], $SubHeader);
                    }
                    $R++;
                }
            } else {
                $Worksheet->write($R, $Col, $Column['Name'], $SingleHeader2);
            }
            if ($Level2[$k]>1) {
                $Worksheet->mergeCells($R, $Col, $R, $Col+$Level2[$k]-1); //   ,     
            }
            $R++;
            $PrevSuperColumn = $Parent;

            foreach ($this->Rows as $Row) {
                if ($k==$this->NameColumn) {
                    $Worksheet->writeString($R, $Col, @$Row[$k], $NameCol);
                }
                else {
                    $Str = V($Row[$k],'');
                    if (!@$Column['FormatFunc']) {
                        if (in_array($k,array("Income", "TotalIncome", "CampCost")) || @$Column['Money'])
                            $Str=ShowCost($this->XlsNumber($Str),@$CurrentCompany->CUR, true);
                        elseif (!@$Column['String']) $Str=$this->XlsNumber($Str);
                    } else {
                        $F = $Column['FormatFunc'];
                        $Str = !@$Column['String'] ? $this->XlsNumber(strip_tags($F($Str))) : strip_tags($F($Str));
                    }
                    if (!$Column['Percents'] && !@$Column['String'] && !in_array($k,array("Income", "TotalIncome", "CampCost")))
                        $Worksheet->writeNumber($R, $Col, $Str,$SectionCol);
                    elseif ($Column['Percents']) $Worksheet->write($R, $Col, $Str/100,$SectionColPerc);
                    else $Worksheet->writeString($R, $Col, $Str, $SectionCol);
                }
                if ($Level2[$k] > 1) {
                    if ( @$Row[$k.'Perc'] && $Row[$k.'Perc']>0 ) $Str = $this->XlsNumber($Row[$k.'Perc']);
                    if ( @$Row[$k.'OneOf'] ) $Str ="(".$Row[$k.'OneOf'].")";
                    if ( @$Row[$k.'Perc']) $Worksheet->write($R, $Col+1, $Str/100, $PercentColumn);
                    else $Worksheet->write($R, $Col+1, $Str);
                }
                $R++;
            }

            if ( ($this->ShowSubSum && count($this->Rows) > 1 && !empty($this->ColumnsSubSum)) ||
                  ($this->ShowRealSum && !empty($this->ColumnsRealSum))) {
                //    
                $Worksheet->write($R, $Col, '', $SectionCol);
                $Worksheet->writeBlank($R+1, $Col, $RowEmpty);
                if ($Level2[$k] > 1) for ($i = 0; $i < $Level2[$k]; $i++) {
                    $Worksheet->write($R, $Col+$i, '');
                    $Worksheet->writeBlank($R+1, $Col+$i, $RowEmpty);
                }
                $Spacers[] = $R+1;
                $R+=2;
            }

            if ($this->ShowSubSum && count($this->Rows) > 1 && !empty($this->ColumnsSubSum)) {
                foreach (array('ColumnsSubSum', 'ColumnsSubMin', 'ColumnsSubAvg', 'ColumnsSubMax') as $f) {

                    if ($this->NameColumn==$k) $Worksheet->write($R, $Col, @$Lang[$f], $SectionCol);
                    elseif (!@$Column['Percents']) {
                        $Arr =& $this->$f;
                        $Str = V($Arr[$k],0);
                        if (in_array($k,array("Income", "TotalIncome", "CampCost"))) {
                            $Str = ShowCost($this->XlsNumber($Str),$CurrentCompany->CUR, true);
                            $Worksheet->write($R, $Col, $Str, $SectionCol);
                        }
                        else  {
                            $Str= $this->XlsNumber($Str);
                            $Worksheet->writeNumber($R, $Col, $Str, $SectionCol);
                        }
                    }
                    else {
                        $Worksheet->write($R, $Col, '', $SectionCol);
                    }
                    if ($Level2[$k] > 1) for ($i = 0; $i < $Level2[$k]; $i++) $Worksheet->write($R, $Col+$i, '');
                    $R++;
                }
            }

            if ($this->ShowSubSum && count($this->Rows) > 1 && !empty($this->ColumnsSubSum) &&
                $this->ShowRealSum && !empty($this->ColumnsRealSum)) {
                //    
                $Worksheet->writeBlank($R, $Col, $RowEmpty);
                if ($Level2[$k] > 1) for ($i = 0; $i < $Level2[$k]; $i++) {
                    $Worksheet->writeBlank($R, $Col+$i, $RowEmpty);
                }
                $Spacers[] = $R;
                $R++;
            }

            if ($this->ShowRealSum && count($this->Rows) > 1 && !empty($this->ColumnsRealSum)) {
                if ($this->NameColumn==$k) $Worksheet->write($R, $Col, @$Lang['RealColumnSum'], $SectionCol);
                elseif (!$this->Columns[$k]['Percents'] && !in_array($k,array('ROI','CampCost')) ) {
                    $Str = V($this->ColumnsRealSum[$k],0);
                    if (in_array($k,array("Income", "TotalIncome", "CampCost"))) {
                        $Str = ShowCost($this->XlsNumber($Str),$CurrentCompany->CUR, true);
                        $Worksheet->write($R, $Col, $Str, $SectionCol);
                    }
                    else {
                        $Str = $this->XlsNumber($Str);
                        $Worksheet->writeNumber($R, $Col, $Str, $SectionCol);
                    }
                }
                else {
                    $Worksheet->write($R, $Col, '', $SectionCol);
                }
                if ($Level2[$k] > 1) for ($i = 0; $i < $Level2[$k]; $i++) $Worksheet->write($R, $Col+$i, '');
                $R++;
            }

            $Col+=$Level2[$k];
        }

        //  
        for ($i = 1; $i < $TotalCols; $i++) $Worksheet->write(0, $i, '', $Title);
        $Worksheet->mergeCells(0,0,0, $TotalCols-1);
        $Worksheet->setRow(0, 40);

        if (!empty($AdditionalLines) && is_array($AdditionalLines)) {
            for ($i = 0; $i < $TotalCols; $i++) $Worksheet->writeBlank($R, $i, $RowEmpty2);
            $Spacers[] = $R;
            $R++;

            foreach ($AdditionalLines as $k=>$v) {
                if (!$v) continue;
                if (isset($Lang[$k])) $v = preg_replace('/[:]/','',$Lang[$k]).': '.$v;
                if ($k != 'URL') $Worksheet->write($R, 0, $v);
                else $Worksheet->writeUrl($R, 0, $v);
                $Worksheet->mergeCells($R, 0, $R, $TotalCols-1);
                $R++;
            }
        }

        //  
        foreach ($ParentStart as $k=>$Col)  $Worksheet->mergeCells(1, $Col, 1, $Col+$Level1[$k]-1);
        //   
        foreach ($Spacers as $R)  $Worksheet->mergeCells($R, 0,$R, $TotalCols-1);

        // Let's send the file
        $Workbook->close();
        if (!$this->ReturnFileMode) exit;
    }

    function XlsNumber( $Str ) {
        if (!$Str) return 0;
        if (preg_match('/[^\d\.,+\-%]/', $Str)) return $Str;
        $Perc = false;
        if (preg_match('/%/', $Str)) {
            $Perc = true;
            $Str = str_replace('%', '', $Str);
        }
        $Str = str_replace(',', '.', $Str);
        $Str = (double) $Str;
        if ( intval($Str) == $Str ) $Str = intval($Str);
        return $Perc ? $Str.'%' : $Str;
    }

    function CheckExport( $ExportParams = array() ) {
        global $Lang, $CpId, $nsProduct;

        if ((V($_REQUEST['_xml']) == $this->Id || V($_REQUEST['_xls']) == $this->Id) && $this->XlsExportEnable)
            $this->XlsExport(null, false, $ExportParams);
        if (V($_REQUEST['_csv']) == $this->Id && $this->CsvExportEnable) $this->CsvExport(false, $Lang['SeparatorValue']);
        if (V($_REQUEST['_print']) == $this->Id && $this->PrintEnable) $GLOBALS['Print']=1;
    }

    function CsvEscape($Str="", $Separator=";")
    {
        return (strpos($Str, $Separator)!==false) ?  "\"".str_replace('"', '""', $Str)."\"" : $Str;
    }

    function GetFile($DataMode='xls', $GetMode='data', $AdditionalLines=array()) {
        $this->ReturnFileMode = $GetMode=='tmpfile' ? 2 : 1;
        if ($DataMode=='csv') $this->FileData = $this->CsvExport();
        elseif ($DataMode=='xml') $this->FileData = $this->XlsXmlExport();
        elseif ($DataMode=='html' || $DataMode=='xls')  {
            $GLOBALS['CurrentReportDataInstance'] =& $this;
            ob_start( 'ReportDataFileCallback' );
            if ($DataMode=='html') $this->HtmlDump();
            if ($DataMode=='xls') $this->XlsExport(null, false, $AdditionalLines);
            ob_end_clean();
            unset($GLOBALS['CurrentReportDataInstance']);
        }
        $this->ReturnFileMode=false;
    }

    function FileData($DataMode='xls', $GetMode='data', $AdditionalLines=array()) {
        if ($GetMode == 'tmpfile') $this->FileData = $this->GetNewTmpName($DataMode);
        $this->GetFile($DataMode, $GetMode, $AdditionalLines);
        return $this->FileData;
    }

    function EmailURL() {
        if (in_array($this->EmailMode, array('NATURAL', 'PAID', 'CUSTOM')))
            return getURL('email', "EmailMode={$this->EmailMode}&EditId=new&QuerySetId={$this->Report->QuerySetId}&"
                                                    ."CacheId={$this->Report->CacheId}&Additional=".urlencode($this->Report->AdditionalTask()), 'admin');
        if (in_array($this->EmailMode, array('Hits','Actions','Ref','Key', 'Clicks', 'Sales', 'Split', 'Fraud')))
            return getURL('email', "EmailMode={$this->EmailMode}&EditId=new&Log={$this->EmailMode}", 'admin');
        if ($this->EmailMode=='SPLIT') {
            return getURL('email', "EmailMode={$this->EmailMode}&EditId=new&SplitId={$this->Report->SplitId}&CacheId={$this->Report->CacheId}", 'admin');
        }
    }

    function ExportRss($RssTitle, $RssLink, $Template) {
        global $Lang, $LangConfig;
        include $Template;
    }

    function PrepareButtons() {
        global $Lang, $nsProduct;

        if ($this->RefreshLink && $this->PrintEnable) $this->CaptionButtonsLeft[]= new Button(array(
                    'Href'=>$this->RefreshLink, 'Js'=>@$this->RefreshJs,
                    'Icons'=>array(
                            array('URL'=>FileLink('images/refresh.gif'), 'W'=>18, 'H'=>18, 'Style'=>'vertical-align:-5px;', 'Id'=>'refresh'.$this->Id),
                            array('URL'=>FileLink('images/circle_02.gif'), 'W'=>18, 'H'=>18, 'Style'=>'vertical-align:-5px;display:none;', 'Id'=>'loading'.$this->Id)
                        )
        ));
        if (@$this->CloseLink && $this->PrintEnable) $this->CaptionButtonsLeft[]= new Button(array(
                'Href'=>$this->CloseLink, 'Js'=>@$this->CloseJs, 'Id'=>'close'.$this->Id,
                'Icon'=>array('URL'=>FileLink('images/close_block.gif'), 'W'=>18, 'H'=>18, 'Style'=>'vertical-align:-5px;')
        ));
        if (@$this->GotoLink && $this->PrintEnable) $this->CaptionButtonsLeft[] = new Button(array(
                'Href'=>$this->GotoLink, 'Js'=>@$this->GotoJs, 'Id'=>'goto'.$this->Id,
                'Icon'=>array('URL'=>FileLink('images/goto_block.gif'), 'W'=>18, 'H'=>18, 'Style'=>'vertical-align:-5px;')
        ));

        if ($this->SaveEnable) $this->CaptionButtonsRight[] = new Button(array(
                'Href'=>$this->SaveLink, 'Js'=>@$this->SaveJs, 'Title'=>$Lang['SaveReport'],
                'Icon'=>array('URL'=>FileLink('images/save.gif'), 'W'=>16, 'H'=>16)
        ));

        if (!empty($this->Rows)) {
            if ($this->XlsExportEnable) $this->CaptionButtonsRight[] = new Button(array(
                'Href'=>getURL($nsProduct->Action, $_SERVER['QUERY_STRING'].'&_xml='.$this->Id, $nsProduct->Section),
                'Title'=>$Lang['ExportXls'], 'Icon'=>array('URL'=>FileLink('images/xls.gif'), 'W'=>16, 'H'=>16)
            ));
            if ($this->CsvExportEnable) $this->CaptionButtonsRight[] = new Button(array(
                'Href'=>getURL($nsProduct->Action, $_SERVER['QUERY_STRING'].'&_csv='.$this->Id, $nsProduct->Section),
                'Title'=>$Lang['ExportCsv'], 'Icon'=>array('URL'=>FileLink('images/csv.gif'), 'W'=>16, 'H'=>16)
            ));
            if ($this->PrintEnable) $this->CaptionButtonsRight[] = new Button(array(
                'Href'=>getURL($nsProduct->Action, $_SERVER['QUERY_STRING'].'&_print='.$this->Id, $nsProduct->Section),
                'Title'=>$Lang['Print'], 'Icon'=>array('URL'=>FileLink('images/print.gif'), 'W'=>16, 'H'=>16)
            ));
            if ($this->EmailEnable && @$this->EmailMode) $this->CaptionButtonsRight[] = new Button(array(
                'Href'=>$this->EmailURL(), 'Title'=>$Lang['SetupEmail'], 'Id'=>'AEmail'.$this->Id,
                'Icon'=>array('URL'=>FileLink('images/email.gif'), 'W'=>16, 'H'=>16)
            ));
            if ($this->RssLink) $this->CaptionButtonsRight[] = new Button(array(
                'Href'=>$this->RssLink, 'Title'=>$Lang['RssSubscribe'], 'Icon'=>array('URL'=>FileLink('images/icon_rss.gif'), 'W'=>16, 'H'=>16)
            ));
        }

    }

    function Filename($Ext='', $Name='') {
        if (@$this->Filename) return $this->Filename;
        if (!$Name) $Name = @$this->ReportCaptionLast ? $this->ReportCaptionLast : @$this->TopCaption;
        if (!$Name) $Filename='export';
        else {
            $Filename = $Name;
            $Filename = strip_tags($Filename);
            $Filename = preg_replace('/\s+/', ' ', $Filename);
            $Filename = preg_replace('/[\s\.]/', '_', $Filename);
            $Filename = preg_replace('/[\\:\/\.><&;]/', '', $Filename);
            $Filename = preg_replace('/__/', '_', $Filename);
        }
        $Len = strlen($Filename);
        if ($Len>50) {
            $Diff = ($Len-50)+3;
            $Tmp = substr($Filename, 0, ceil(($Len/2)-($Diff/2)));
            $Tmp2 = substr($Filename, ceil(($Len/2)+($Diff/2)));
            $Filename = $Tmp.'---'.$Tmp2;
        }
        $Ext = preg_replace('/[^\d\w]/', '', $Ext);
        return $Filename.'.'.$Ext;
    }
}

function ReportDataFileCallback($Data) {
        if (!@$GLOBALS['CurrentReportDataInstance']) return false;
        $GLOBALS['CurrentReportDataInstance']->FileData = $Data;
        return false;
}

?>