jQuery.eventData = function (ev, tag, exactTarget) {
    if (!ev) ev=window.event;
	if (ev.specialTarget) var target = ev.specialTarget;
	else var target = (ev.target) ? ev.target : ev.srcElement;

    if (target&&tag) while (target.tagName.toLowerCase() != tag.toLowerCase()) {
        if (exactTarget) break;
        target=target.parentNode;
        if (target.tagName.toLowerCase()=='body') break;
    }
    if (target&&tag&&target.tagName.toLowerCase() != tag.toLowerCase()) target=false;

    var data = $(target).offset();
    data.target=target;
    data.ev=ev;
    return data;
}

jQuery.varDump = function (d,target) {
    var s = '';
    if (typeof(d) == "object") {
        s += typeof(d) + " {\n";
        for (var k in d) s += k+": "+d[k]+"\n";
        s += "}\n"
    } else {
        s += "" + d + "\n";
    }
    return target? $( (typeof(target)=='string'?'#'+target:target) ).html(s):s;
}

jQuery.parentPath = function (o) {
    var arr = []
    while (o.get(0).tagName.toLowerCase() != 'body') {
        var str = o.get(0).tagName
        str += o.attr('id') ? '#'+o.attr('id') : ''  
        arr.push( str )
        o = o.parent()
    }
    return arr.join(' < ')
}