<?
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/class/graph.class.php";
require_once SELF."/lib/reports/misc.func.php";

$SiteId = V($_REQUEST['SiteId']);
define('NO_SESSION_DATES', true);

$nsLang->TplInc("constructor/report_constructor");
$nsLang->TplInc("inc/report_headers");
$nsLang->TplInc("constructor/periods");
$nsLang->TplInc("constructor/constructor_form");
$nsLang->TplInc("constructor/report_description");

UserColumns();
$SWFIncluded=true;

$GroupBy=$_REQUEST['GroupBy']='Date';
$_REQUEST['DynamicPeriod']='7-d-1';
$_REQUEST['OrderBy']='NAME';
$_REQUEST['OrderTo']='DESC';
$_REQUEST['WhereArr'] = array(0=>array('Mode'=>'Date','Id'=>''));
$SaveMode = 'NATURAL';

require_once SELF."/lib/reports/const_groups.arr.php";
require_once SELF."/lib/reports/prepare_vars.inc.php";

$Report = new Constructor($CpId,'NATURAL');
$Report->GroupBy=$GroupBy;
$Report->NewVsRet=true;
$Report->MakeSum=false;
$Report->SiteId = $SiteId;
$Report->CacheAgeLimit=60;
$Report->PageLimit=7;
$Report->OrderBy=$OrderBy;
$Report->OrderTo=$OrderTo;
$Report->CacheType = 2;
$Report->CountIfNoCache = true;
$Report->NoCacheUpdate = true;

if ($DynamicPeriod!="-1" && $DynamicPeriod!=="" ) {
    $DynamicDate=GetDateFromPeriod($DynamicPeriod,true);
    $Report->StartDate=$DynamicDate['StartDate'];
    $Report->EndDate=$DynamicDate['EndDate'];
    $Report->ViewDate="";
}

require_once SELF."/lib/reports/const_where.inc.php";
require_once SELF."/lib/reports/prepare_groups.inc.php";
require_once SELF."/lib/reports/const_groupby.inc.php";

$Report->SessVisits=true;
$Report->DisableDatesFill=false;

$Report->Calculate();
$Report->SetCacheType(2);
$Report->SetUpdateInterval(180);
if ($Report->CacheTZ=='' && !$Report->TakenFromCache) $Report->AddToCache();

if (isset($Report->StatArr['__total'])) unset($Report->StatArr['__total']);

$Report->FillDates();

$RData = new ReportData('NATURAL');
$RData->GraphPlace=0;
$Row=false;
$z=0;
if (!$Report->TakenFromCache) foreach ($Report->StatArr as $i=>$Row) {
    include SELF."/lib/reports/prepare_names.inc.php";
    $Row['Position']=$z;
    $Row['ActionConvOneOf']=$Report->OneOf(V($Row['UniAction'],0),V($Row['UniClick'],0));
    $Row['SaleConvOneOf']=$Report->OneOf(V($Row['UniSale'],0),V($Row['UniClick'],0));
    $Report->StatArr[$i]=$Row;     
    $z++;
}

if (!empty($Report->StatArr)) foreach ($Report->StatArr as $i=>$Row) { 
    foreach ($Row as $k=>$v) $RData->AddColumn($k);
    break;
}

$nsUser->Columns->NEWRET = true;
$nsUser->Columns->VISITS = true;
$nsUser->Columns->HITS = true;
$nsUser->Columns->SALES = true;
$nsUser->Columns->ACTIONS = false;
$nsUser->Columns->CLICKS = true;
$nsUser->Columns->ROI = false;
$nsUser->Columns->CONVERSIONS = true;

$StatArrName="StatArr";
$DateFormat=$GroupBy;
//////////////// 
include_once SELF."/lib/reports/date_graph.inc.php";

$GrNames = array('UniClick'=>'VisitorGraph','SaleConv'=>'SaleConvGraph','Income'=>'IncomeGraph');
$i=0;

if ($Report->TakenFromCache) include $nsTemplate->Inc("constructor/cache_update");
else echo '<div id=SpacerMedium></div>';

foreach (array('UniClick', 'SaleConv','Income') as $k) {
    $Row =& $RData->Graphs[$k];
    if (!$Row) {
        echo '<div id="GR_'.$SiteId.$GrNames[$k].'" style="'.($i==0?'':'display:none;').'">';
        include $nsTemplate->Inc('inc/no_records');
        echo '</div>';
        $i++;
        continue;
    }
    $Row->ID = $SiteId.$Row->ID;
    $Row->Display=$i==0?true:false;
    $Row->Name = false;    
    $Row->Dump();
    $i++;
}

exit;
?>