<?
if ($nsProduct->LICENSE==4) exit;
$RData = new ReportData();
$RData->EnableSorting=false;
$RData->ShowNextStep=false;
$RData->ShowSimpleName=true;
$RData->EnableSubValues=false;
$RData->ShowNoRecords = true;
$RData->Id = 'lclick';

$RData->ColumnOrder = array('Stamp','Host','Visitor','Campaign','Source','Keyword','NatKeyword');
$RData->AddColumn('Stamp', $Lang['Time'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Host', $Lang['SiteHost'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Visitor', $Lang['Visitor'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Campaign', $Lang['Campaign'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Source', $Lang['Source'], false, false, array('NoFormat'=>true));
$RData->AddColumn('Keyword', $Lang['PaidKeyword'], false, false, array('NoFormat'=>true));
$RData->AddColumn('NatKeyword', $Lang['NatKeyword'], false, false, array('NoFormat'=>true));

$RData->TopCaption = $Lang['LastClicks'];
$RData->RefreshLink = 'javascript:;';
$RData->RefreshJs = "loadDashReport('LastClicks', '".getURL('client_page','Mode=lastclick&ax=1')."', '{$RData->Id}')";
$RData->CloseLink = 'javascript:;';
$RData->CloseJs = "$('#Report_{$RData->Id}').hide(); $('#SpacerLarge', '#Caption_{$RData->Id}').hide(); $('#close{$RData->Id}, #goto{$RData->Id}').hide(); ";
$RData->GotoLink = getURL('logs','Mode=Clicks&CpId='.$CpId,'report');

$Now = gmdate("Y-m-d H:i:s", time());
$Query = "SELECT DATE_FORMAT(DATE_ADD('$Now', INTERVAL -7 DAY), '%Y-%m-%d %H:%i:%s')";
$FromStamp = $Db->ReturnValue($Query);

$Query = "
    SELECT
    S_LOG.ID,
    UNIX_TIMESTAMP(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) AS STAMP,
    (TO_DAYS(DATE_ADD(?now, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE)) - 
        TO_DAYS(DATE_ADD(S_LOG.STAMP, INTERVAL '$nsUser->SQL_TZ' HOUR_MINUTE))) AS NOT_TODAY,
    
    S_LOG.VISITOR_ID, I.IP, CV.NAME AS VISITOR_NAME,
    S_CLICK.CAMP_ID, CP.NAME,
    S_CLICK.KEYWORD_ID, K.KEYWORD, K1.KEYWORD AS NATURAL_KEYWORD,
    H.HOST AS SOURCE_HOST, HG.NAME AS HOST_GRP_NAME,
    SH.HOST

    FROM ?_{$CpId}_stat_click S_CLICK
    INNER JOIN ?_{$CpId}_stat_log S_LOG ON S_LOG.ID=S_CLICK.LOG_ID

    INNER JOIN ?_site_host SH ON SH.ID=S_LOG.SITE_HOST_ID
    INNER JOIN ?_visitor V ON V.ID=S_LOG.VISITOR_ID
    INNER JOIN ?_camp_piece CP ON CP.ID=S_CLICK.CAMP_ID
    INNER JOIN ?_ip I ON I.ID=S_LOG.IP_ID

    LEFT JOIN ?_host H ON H.ID=S_CLICK.SOURCE_HOST_ID
    LEFT JOIN ?_host_grp HG ON HG.ID=H.GRP_ID
    LEFT JOIN ?_keyword K ON K.ID=S_CLICK.KEYWORD_ID
    LEFT JOIN ?_client_visitor CV ON CV.VISITOR_ID=S_LOG.VISITOR_ID AND CV.COMPANY_ID=?cp

    LEFT JOIN ?_referer_set RS ON RS.ID=S_LOG.REFERER_SET
    LEFT JOIN ?_keyword K1 ON K1.ID=RS.NATURAL_KEY
    
    WHERE S_LOG.STAMP > ?stamp
    ORDER BY S_LOG.STAMP DESC
    LIMIT 10
";
$Sql = new Query($Query,false,array('cp'=>$CpId,'now'=>$Now,'stamp'=>$FromStamp));
while ($Row=$Sql->Row()) {
    $Row->VISITOR_NAME=htmlspecialchars(stripslashes($Row->VISITOR_NAME));
    if ($Row->NOT_TODAY == 0) $Arr['Stamp'] = _date($Row->STAMP,'time');
    if ($Row->NOT_TODAY == 1) $Arr['Stamp'] = $Lang['Yesterday'].', '._date($Row->STAMP,'time');
    if ($Row->NOT_TODAY > 1) $Arr['Stamp'] = _date($Row->STAMP,'datetime');
    $Arr['Visitor']= $Row->VISITOR_NAME? $Row->VISITOR_NAME : $Row->IP;
    $Arr['Campaign'] = $Row->NAME;
    $Arr['Keyword'] = $Row->KEYWORD;
    $Arr['NatKeyword'] = $Row->NATURAL_KEYWORD;
    $Arr['Source'] = $Row->HOST_GRP_NAME ? $Row->HOST_GRP_NAME : $Row->SOURCE_HOST;
    $Arr['Host'] = $Row->HOST;
    $Arr['Link_Visitor'] = getURL('visitor_path', "CpId=$CpId&VisId={$Row->VISITOR_ID}&ViewDate=".date("Y-m-d",$Row->STAMP), 'report');    

    $RData->AddRow($Arr);
}

$RData->CheckExport();
$RData->HtmlDump();
exit;
?>