<?

require_once SELF."/lib/delete/commands.func.php";


$RemovalTablesStat=array();
$RemovedSpace=array();
$RemovalKey='x';
$MyVersion=$Db->Version;
$MyVersion=ToFloat($MyVersion)*10;


/*
 * Filter: EndTime (gmt)
 */

function DeleteLogStat($CpId=0,$Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;

    if (!isset($Filter['PagesOnly'])) {
    $V40Syn= "?{PFX}_tracker_{$CpId}_stat_log, ?{PFX}_tracker_{$CpId}_stat_action, ?{PFX}_tracker_action_set, 
                        ?{PFX}_tracker_{$CpId}_stat_click, 
                        ?{PFX}_tracker_{$CpId}_stat_split, ?{PFX}_tracker_{$CpId}_stat_sale, ?{PFX}_tracker_sale_set, 
                        ?{PFX}_tracker_{$CpId}_stat_session_log, 
                        ?{PFX}_tracker_{$CpId}_stat_session, ?{PFX}_tracker_{$CpId}_stat_session_path";
    $V41Syn="S_LOG, S_ACTION, A_SET, S_CLICK, S_SPLIT, S_SALE, SS, SESS_LOG, SESS, SESS_PATH";
    }
    else {
    $V40Syn= "?{PFX}_tracker_{$CpId}_stat_log, ?{PFX}_tracker_{$CpId}_stat_session_log";
    $V41Syn="S_LOG, SESS_LOG";        
    }
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    $WhereStr=""; $UndefWhereStr=""; $WhereArr=array(); $Args=array();

    /*
    if (V($Filter['EndTime'])||isset($Filter['CpKeep'][$CpId])) {
        if (isset($Filter['CpTZ'][$CpId]) && $Filter['CpTZ'][$CpId]>0) $WhereArr[]="S_LOG.STAMP < DATE_ADD(?end, INTERVAL '".(SqlTZ($Filter['CpTZ'][$CpId],SqlTZ($Filter['CpTZ'][$CpId])))."' HOUR_MINUTE)";
        else $WhereArr[]="S_LOG.STAMP < ?end";
        $Args['end']=isset($Filter['CpKeep'][$CpId])?$Filter['CpKeep'][$CpId]:$Filter['EndTime'];
    }*/

    $tz = SqlTZ(@$Filter['CpTZ'][$CpId],SqlTZ(@$Filter['CpTZ'][$CpId]));
    if ( ((@$Filter['StartTime'] && @$Filter['EndTime']) || @$Filter['CpRange'][$CpId]) && !@$Filter['CpKeep'][$CpId]) {
        $WhereArr[]="S_LOG.STAMP BETWEEN DATE_ADD(?start, INTERVAL '$tz' HOUR_MINUTE) AND 
                                                                       DATE_ADD(?end, INTERVAL '$tz' HOUR_MINUTE)";
        $Args['start'] = @$Filter['CpRange'][$CpId]['StartTime']?$Filter['CpRange'][$CpId]['StartTime']: $Filter['StartTime'];
        $Args['end'] = @$Filter['CpRange'][$CpId]['EndTime']?$Filter['CpRange'][$CpId]['EndTime']: $Filter['EndTime'];
    }
    if ( (!@$Filter['StartTime'] && @$Filter['EndTime']) || isset($Filter['CpKeep'][$CpId]) ) {
        if (isset($Filter['CpTZ'][$CpId]) && $Filter['CpTZ'][$CpId]>0) 
            $WhereArr[]="S_LOG.STAMP < DATE_ADD(?end, INTERVAL '$tz' HOUR_MINUTE)";
        else $WhereArr[]="S_LOG.STAMP < ?end";
        $Args['end']=isset($Filter['CpKeep'][$CpId])?$Filter['CpKeep'][$CpId]:$Filter['EndTime'];
    }    


    if (!empty($WhereArr)) $UndefWhereStr="WHERE ".implode(" AND ",$WhereArr);
    $UndefWhereStr=str_replace("S_LOG.", "", $WhereStr);    

    if (isset($Filter['PagesOnly'])) {
        $WhereArr[]="S_ACTION.ID IS NULL";
        $WhereArr[]="A_SET.ID IS NULL";
        $WhereArr[]="S_CLICK.ID IS NULL";
        $WhereArr[]="S_SPLIT.ID IS NULL";
        $WhereArr[]="S_SALE.ID IS NULL";
        $WhereArr[]="SS.ID IS NULL";
        $WhereArr[]="S_LOG.REFERER_SET=0";
    }

    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);

    $Aff=0;
    
    //        
    //$Query = "DELETE FROM ?_{$CpId}_stat_undef $UndefWhereStr";
    //$Db->Query($Query,$Args);
    //$Aff=$Db->LastAffected;

    $Query = "
    DELETE $Str
        FROM ?_{$CpId}_stat_log S_LOG

        #actions
        LEFT JOIN ?_{$CpId}_stat_action S_ACTION
            ON S_ACTION.LOG_ID=S_LOG.ID
        LEFT JOIN ?_action_set A_SET
            ON A_SET.STAT_ACTION_ID=S_ACTION.ID

        LEFT JOIN ?_{$CpId}_stat_click S_CLICK
            ON S_CLICK.LOG_ID=S_LOG.ID

        LEFT JOIN ?_{$CpId}_stat_split S_SPLIT
            ON S_SPLIT.LOG_ID=S_LOG.ID

        #sales
        LEFT JOIN ?_{$CpId}_stat_sale S_SALE
            ON S_SALE.LOG_ID=S_LOG.ID
        LEFT JOIN ?_sale_set SS
            ON SS.SALE_ID=S_SALE.ID

        # sessions
        LEFT JOIN ?_{$CpId}_stat_session_log SESS_LOG
            ON SESS_LOG.LOG_ID=S_LOG.ID
        LEFT JOIN ?_{$CpId}_stat_session SESS
            ON SESS.ID=SESS_LOG.SESSION_ID
        LEFT JOIN ?_{$CpId}_stat_session_path SESS_PATH
            ON SESS_PATH.SESSION_ID=SESS_LOG.SESSION_ID

        $WhereStr
    ";

    $Db->Query($Query,$Args);

    $Aff+=$Db->LastAffected;

    if (isset($Filter['PagesOnly'])) {
        $V40Syn= "?{PFX}_tracker_{$CpId}_stat_session, ?{PFX}_tracker_{$CpId}_stat_session_path";
        $V41Syn="SESS, SESS_PATH";        
        $Str=($MyVersion>40)?$V41Syn:$V40Syn;
        $Query = "
            DELETE $Str
                FROM ?_{$CpId}_stat_session SESS
                LEFT JOIN ?_{$CpId}_stat_session_log SESS_LOG
                    ON SESS_LOG.SESSION_ID=SESS.ID
                LEFT JOIN ?_{$CpId}_stat_session_path SESS_PATH
                    ON SESS_PATH.SESSION_ID=SESS.ID
            WHERE SESS_LOG.ID IS NULL
        ";
        $Db->Query($Query);
        $Aff+=$Db->LastAffected;
    }

    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_log";

    if (!isset($Filter['PagesOnly'])) {
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_action";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_action_set";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_click";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_split";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_sale";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_sale_set";
    }
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_undef";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_session_log";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_session";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_{$CpId}_stat_session_path";    
    
    return $Aff;
}

function DeleteOrphanReferers($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_referer, ?{PFX}_tracker_referer_set";
    $V41Syn="R,RS";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;    
    $WhereStr=""; $WhereArr=array(); $Args=array(); $JoinArr=array(); $JoinStr="";

    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_log S{$i} ON S{$i}.REFERER_SET = RS.ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }
    if (!empty($JoinArr)) $JoinStr=implode(" \n",$JoinArr);    
    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);    

    $Query = "
        DELETE $Str
            FROM ?_referer R
                INNER JOIN ?_referer_set RS
                    ON RS.REFERER_ID=R.ID
                $JoinStr
                $WhereStr
    ";

    $Db->Query($Query,$Args);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_referer";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_referer_set";
            
    return $Db->LastAffected;
}


function DeleteOrphanHost($CpArr=array(),$Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_host";
    $V41Syn="H";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    $WhereStr=""; $WhereArr=array(); $Args=array(); $JoinArr=array(); $JoinStr="";    

    $WhereArr[]="RS.ID IS NULL";
    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_click S{$i} ON S{$i}.SOURCE_HOST_ID = H.ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }
    if (!V($Filter['HostGroups'])) $WhereArr[]="H.GRP_ID=0";

    if (!empty($JoinArr)) $JoinStr=implode(" \n",$JoinArr);    
    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);        

    $Query = "
        DELETE $Str
            FROM ?_host H
                LEFT JOIN ?_referer_set RS
                    ON RS.HOST_ID=H.ID
                $JoinStr
                $WhereStr
    ";

    $Db->Query($Query,$Args);

    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_host";
    
    return $Db->LastAffected;    
}


function DeleteOrphanKey($CpArr=array(),$Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_keyword";
    $V41Syn="K";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    $WhereStr=""; $WhereArr=array(); $Args=array(); $JoinArr=array(); $JoinStr="";

    $WhereArr[]="RS.ID IS NULL";
    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_click S{$i} ON S{$i}.KEYWORD_ID = K.ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }

    if (!empty($JoinArr)) $JoinStr=implode(" \n",$JoinArr);    
    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);            
    
    $Query = "
        DELETE $Str
            FROM ?_keyword K
                LEFT JOIN ?_referer_set RS
                    ON RS.NATURAL_KEY=K.ID
                $JoinStr
                $WhereStr
    ";

    $Db->Query($Query,$Args);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_keyword";
    
    return $Db->LastAffected;  
}


function DeleteOrphanIp($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_ip";
    $V41Syn="I";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    $WhereStr=""; $WhereArr=array(); $Args=array(); $JoinArr=array(); $JoinStr="";

    $WhereArr[]="V.ID IS NULL";
    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_log S{$i} ON S{$i}.IP_ID = I.ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }

    if (!empty($JoinArr)) $JoinStr=implode(" \n",$JoinArr);    
    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);            
    
    $Query = "
        DELETE $Str
            FROM ?_ip I
                LEFT JOIN ?_visitor V
                    ON V.LAST_IP_ID=I.ID
                $JoinStr
                $WhereStr
    ";

    $Db->Query($Query,$Args);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_ip";
        
    return $Db->LastAffected;      
}

function DeleteOrphanSaleItem($CpArr=array(),$Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_sale_item";
    $V41Syn="SI";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    
    $Query = "
        DELETE $Str
            FROM ?_sale_item SI
                LEFT JOIN ?_sale_set SS
                    ON SS.ITEM_ID=SI.ID
                LEFT JOIN ?_watch W
                    ON W.SALE_ITEM_ID=SI.ID
        WHERE SS.ID IS NULL AND W.ID IS NULL
    ";

    $Db->Query($Query);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_sale_item";   
     
    return $Db->LastAffected;          
}

function DeleteOrphanActionItem($CpArr=array(),$Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_action_item";
    $V41Syn="AI";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    
    $Query = "
        DELETE $Str
            FROM ?_action_item AI
                LEFT JOIN ?_action_set SS
                    ON SS.ACTION_ITEM_ID=AI.ID
                LEFT JOIN ?_watch W
                    ON W.ACTION_ITEM_ID=AI.ID
        WHERE SS.ID IS NULL AND W.ID IS NULL
    ";

    $Db->Query($Query);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_action_item";   
        
    return $Db->LastAffected;        
}

function DeleteOrphanVisitors($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_visitor";
    $V41Syn="V";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    $WhereStr=""; $WhereArr=array(); $Args=array(); $JoinArr=array(); $JoinStr="";
    
    $WhereArr[]="W.ID IS NULL";
    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_log S{$i} ON S{$i}.VISITOR_ID = V.ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }
    if (V($Filter['NamedVisitors'])) {
        $JoinArr[]="LEFT JOIN ?_client_visitor CV ON CV.VISITOR_ID=V.ID";
        $WhereArr[]="CV.ID IS NULL";
    }

    if (!empty($JoinArr)) $JoinStr=implode(" \n",$JoinArr);    
    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);            
    
    $Query = "
        DELETE $Str
            FROM ?_visitor V
                LEFT JOIN ?_watch W
                    ON W.VISITOR_ID=V.ID
                $JoinStr
           $WhereStr
    ";

    $Db->Query($Query,$Args);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_visitor";   
        
    return $Db->LastAffected;          
}

function DeleteOrphanTags($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_visitor_tag_rel";
    $V41Syn="VT";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;    
    
    $Query = "
        DELETE $Str
        FROM ?_visitor_tag_rel VT
        LEFT JOIN ?_visitor V
            ON V.ID=VT.VISITOR_ID
        WHERE V.ID IS NULL
    ";
    $Db->Query($Query);
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_visitor_tag_rel";
    $Aff=$Db->LastAffected;

    $JoinArr=$WhereArr=array();
    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_sale S{$i} ON S{$i}.ID = SR.SALE_ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }    
    $JoinStr=implode("\n",$JoinArr);
    $WhereStr=implode(" AND ",$WhereArr);

    $V40Syn= "?{PFX}_sale_tag_rel";
    $V41Syn="SR";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;    
    $Query = "
        DELETE $Str
        FROM ?_sale_tag_rel SR
        $JoinStr
        WHERE $WhereStr
    ";
    $Db->Query($Query);
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_sale_tag_rel";
    $Aff=$Db->LastAffected;

    $V40Syn= "?{PFX}_tracker_tag";
    $V41Syn="T";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;

    $Query = "
        DELETE $Str
        FROM ?_tag T
        LEFT JOIN ?_visitor_tag_rel VT ON VT.TAG_ID=T.ID
        LEFT JOIN ?_sale_tag_rel SR ON SR.TAG_ID=T.ID
        WHERE VT.ID IS NULL AND SR.ID IS NULL
    ";
    $Db->Query($Query);
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_tag";    
    $Aff+=$Db->LastAffected;
    return $Aff;
}


function DeleteOrphanBrowser($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_visitor_agent";
    $V41Syn="VA";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    $WhereStr=""; $WhereArr=array(); $Args=array(); $JoinArr=array(); $JoinStr="";

    $WhereArr[]="V.ID IS NULL";
    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_log S{$i} ON S{$i}.AGENT_ID = VA.ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }
    if (!V($Filter['AgentGroups'])) $WhereArr[]=" (VA.BROWSER_ID=0 AND VA.OS_ID=0 AND VA.ENGINE_ID=0 AND VA.ROBOT_ID=0) ";

    if (!empty($JoinArr)) $JoinStr=implode(" \n",$JoinArr);    
    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);            

    $Query = "
        DELETE $Str
            FROM ?_visitor_agent VA
                LEFT JOIN ?_visitor V
                    ON V.LAST_AGENT_ID=VA.ID
                $JoinStr
           $WhereStr
    ";

    $Db->Query($Query,$Args);

    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_visitor_agent";
    
    return $Db->LastAffected;          
}

function DeleteOrphanAddr($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_page_query, ?{PFX}_tracker_page_title";
    $V41Syn="PQ, PT";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    $WhereStr=""; $WhereArr=array(); $Args=array(); $JoinArr=array(); $JoinStr="";
    $WhereArr[]="SPL.ID IS NULL";
    foreach ($CpArr as $i=>$CpId) {
        $JoinArr[]="LEFT JOIN ?_{$CpId}_stat_log S{$i} USE INDEX(QUERY_TRIPLE) ON S{$i}.SITE_HOST_ID = PQ.SITE_HOST_ID AND 
                            S{$i}.PAGE_ID=PQ.PAGE_ID AND S{$i}.QUERY_ID=PQ.QUERY_ID";
        $WhereArr[]="S{$i}.ID IS NULL";
    }
    if (!V($Filter['PageGroups'])) $WhereArr[]="PQ.GRP_ID=0";

    if (!empty($JoinArr)) $JoinStr=implode(" \n",$JoinArr);    
    if (!empty($WhereArr)) $WhereStr="WHERE ".implode(" AND ",$WhereArr);            

    $Query = "
        DELETE $Str
            FROM ?_page_query PQ
                LEFT JOIN ?_page_title PT
                    ON PT.ID=PQ.TITLE_ID
                LEFT JOIN ?_split_page SPL 
                    ON SPL.PAGE_ID=PQ.PAGE_ID AND SPL.QUERY_ID=PQ.QUERY_ID
                $JoinStr
           $WhereStr
    ";
    $Db->Query($Query,$Args);
    $Aff=$Db->LastAffected;
    $Aff+=DeleteOrphanPage();
    $Aff+=DeleteOrphanQuery();

    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_page_query";
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_page_title";
            
    return $Aff;
}

function DeleteOrphanPage($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_site_page";
    $V41Syn="SP";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    
    $Query = "
        DELETE $Str
            FROM ?_site_page SP
                LEFT JOIN ?_page_query PQ
                    ON PQ.PAGE_ID=SP.ID
        WHERE PQ.ID IS NULL
    ";

    $Db->Query($Query);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_site_page";    
    
    return $Db->LastAffected;            
}

function DeleteOrphanQuery($CpArr=array(), $Filter=array())
{
    global $Db, $MyVersion, $Logs, $RemovalTablesStat, $RemovalKey;
    $V40Syn= "?{PFX}_tracker_query";
    $V41Syn="Q";
    $Str=($MyVersion>40)?$V41Syn:$V40Syn;
    
    $Query = "
        DELETE $Str
            FROM ?_query Q
                LEFT JOIN ?_page_query PQ
                    ON PQ.QUERY_ID=Q.ID
        WHERE PQ.ID IS NULL
    ";

    $Db->Query($Query);
    
    $RemovalTablesStat[$RemovalKey][]=PFX."_tracker_query";        
    
    return $Db->LastAffected;            
}





function ClearAllStatistics()
{
    
    global $Db;
    $CpArr=array();
    $Query = "SELECT ID FROM ?_client";
    $Sql = new Query($Query);
    while ($Row=$Sql->Row()) $CpArr[]=$Row->ID;
    
    foreach ($CpArr as $CpId) {
        $Query = "TRUNCATE TABLE ?_{$CpId}_bot_log";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_log";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_action";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_click";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_sale";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_split";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_undef";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_cache";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_cache_cron_log";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_cache_data";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_cache_query_set";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_cache_popularity";
        $Db->Query($Query);    
        $Query = "TRUNCATE TABLE ?_{$CpId}_static_report_cache";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_session";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_session_log";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_stat_session_path";
        $Db->Query($Query);
        $Query = "TRUNCATE TABLE ?_{$CpId}_static_archive_cache";
        $Db->Query($Query);        
        $Query = "TRUNCATE TABLE ?_{$CpId}_delayed";
        $Db->Query($Query);        
    }
    
}


?>