<?


function GetLicenseText($DecodedString=false)
{
	$Arr1=array();
	$License=array();
	$DecodedString=trim($DecodedString);
	if (!$DecodedString) return false;
	$Arr1=explode("\n", $DecodedString);
	for($i=0;$i<count($Arr1);$i++) {
		$Arr2=explode("=", $Arr1[$i]);
		if (!is_array($Arr2)||Count($Arr2)<2) continue;
		$License[$Arr2[0]]=str_replace("&equal;", "=", $Arr2[1]);
	}
	if (count($License)==0) return false;

	if (!isset($License['ID'])) return false;
	if (!isset($License['V'])) return false;
	if (!isset($License['CL'])) return false;
	if (!isset($License['L'])) return false;

    if ( substr($License['ID'], 0, 5) == 'TRIAL') {
        $License['TRIAL']=$License['ID'];
        $License['ID']=1;
    }
	return $License;
}


//    ,     :)
function GetCurrentLicense() {
	// 1- trial, 2- client, 3- agency, 4 - personal
	global $Db, $nsProduct, $BF;
	$MaxVersion=0;
	$nsProduct->LC=array();
	$nsProduct->LICENSE=0;
	$nsProduct->WHITE=false;
	$nsProduct->MAX_SITES=0;
    $nsProduct->TRIAL_SITES=0;
	$nsProduct->DAYS_LEFT=0;
	$nsProduct->MAX_KEY_VERSION=3;
    $nsProduct->MKEY=0;
    $nsProduct->AKEY=0;
    $nsProduct->PKEY=0;
    $nsProduct->KEYS_NUM = 0;
	$Query = "SELECT * FROM ?_license";
    $LPrior = array('3', '2', '4');
	$Sql = new Query($Query);
	while ($Row=$Sql->Row()) {

		$Row->KEY_DECODE=$BF->decrypt($Row->LICENSE_KEY);
		$Row->License=GetLicenseText($Row->KEY_DECODE);
		if (!$Row->License) continue;
        if (!@$Row->License['ID']) continue;

        if (@$Row->License['TL']) {
            $Query = "SELECT TO_DAYS(?) - TO_DAYS(NOW())";
            if ( ($DaysLeft = $Db->ReturnValue($Query,$Row->License['TL'])) < 0 ) {
                $Db->Query("DELETE FROM ?_license WHERE ID=?", $Row->ID);
                continue;
            } elseif ($DaysLeft > $nsProduct->DAYS_LEFT && !$nsProduct->LICENSE ) $nsProduct->DAYS_LEFT = $DaysLeft;
        } elseif (@$Row->License['P']) $nsProduct->DAYS_LEFT = 0;

		$Row->License['L']=intval(@$Row->License['L']);
		if (@$Row->License['L'] > 0 ) {
            $nsProduct->MAX_SITES += $Row->License['L'];
            if ( @$Row->License['TL'] && !$nsProduct->DAYS_LEFT ) $nsProduct->TRIAL_SITES += $Row->License['L'];  
        }
		if (@$Row->License['WL']==1) $nsProduct->WHITE=true;

        if (@$Row->License['P']) {
            foreach ($LPrior as $i=>$p) {
                if ($nsProduct->LICENSE==$LPrior[0]) break;
                $pi1 = 1000; //    
                $pi2 = 0; //  $Row
                if ($nsProduct->LICENSE) for ($j=0; $j < count($LPrior); $j++) if ($LPrior[$j]==$nsProduct->LICENSE) $pi1=$j;
                for ($j=0; $j < count($LPrior); $j++) if ($LPrior[$j]==$Row->License['P']) $pi2=$j;
                if ($pi2 < $pi1) $nsProduct->LICENSE = $Row->License['P']; 
            }
            if ($Row->License['P']==3) $nsProduct->AKEY++;
            if ($Row->License['P']==2) $nsProduct->MKEY++;
            if ($Row->License['P']==4) $nsProduct->PKEY++;       
        }
        $Row->KEY_DECODE = false;
        $Row->LICENSE_KEY = false;
        $nsProduct->KEYS_NUM ++;
		$nsProduct->LC[]=$Row;
	}

    if ($nsProduct->MAX_SITES != $nsProduct->TRIAL_SITES ) $nsProduct->MAX_SITES -= $nsProduct->TRIAL_SITES;

	$nsProduct->WHITE_ENABLE=false;
	$nsProduct->WHITE_POSSIBLE=false;
	$nsProduct->WHITE_NO_LOGO=false;
	$nsProduct->WHITE_NO_COPY=false;
	if ($nsProduct->WHITE) {
		$nsProduct->WHITE_POSSIBLE=true;
		$Check=$Db->Select("SELECT WHITE_NO_LOGO, WHITE_NO_COPY FROM ?_config WHERE COMPANY_ID=0 AND SITE_ID=0");
		$nsProduct->WHITE_NO_LOGO=$Check->WHITE_NO_LOGO;
		$nsProduct->WHITE_NO_COPY=$Check->WHITE_NO_COPY;	
	}
}


function GetFullLicenseArr()
{
	$FullArr=array();
	global $Db, $BF;
	$Query = "SELECT * FROM ?_license";
	$Sql = new Query($Query);
	while ($Row=$Sql->Row()) {
		$Row->KEY_DECODE=$BF->decrypt($Row->LICENSE_KEY);
		$Row->License=GetLicenseText($Row->KEY_DECODE);
		if (!$Row->License) continue;
		foreach ($Row->License as $Key=>$Value) $FullArr[$Key][]=$Value;
	}
	return $FullArr;
}

?>