<?

$nsLang->TplInc("constructor/report_constructor");
$nsLang->TplInc("inc/report_headers");
require_once SELF."/class/cache_v2.class.php";
require_once SELF."/class/report_parent_v2.class.php";
require_once SELF."/class/constructor.class.php";
require_once SELF."/class/split_v2.class.php";
require_once SELF."/class/report_data.class.php";
require_once SELF."/lib/reports/misc.func.php";
require_once SELF."/lib/reports/static_report.func.php";
require_once SYS."/system/lib/validate.func.php";

function CacheReportData($CpId, &$Params) {
    if (!defined('EXTR_REFS')) define('EXTR_REFS', 1);
    extract($Params, EXTR_REFS);
    if (!defined('CRON_MODE')) UserColumns();
    else {
        global $nsUser;
        DummyUser($nsUser);
    }
    $CurrentCompany=GetCurrentCompany($CpId);
    $PrepareCacheMode = true;
    include SELF."/lib/reports/const_path.inc.php";
    include SELF."/lib/reports/process_data.inc.php";
    return @$RData;    //   process_data
}

function SplitReportData($CpId, &$Params) {
    if (!defined('EXTR_REFS')) define('EXTR_REFS', 1);
    extract($Params, EXTR_REFS);
    if (!defined('CRON_MODE')) UserColumns();
    else {
        global $nsUser;
        DummyUser($nsUser);
    }
    $PrepareCacheMode = true;
    $CurrentCompany=GetCurrentCompany($CpId);
    global $nsLang, $Lang;
    $nsLang->TplInc("report.split_test");
    $nsLang->TplInc("inc/report_headers");

    $RData = new ReportData("PAID");
    $RData->EnableSubValues=false;
    $RData->AddColumn('Name',$Lang['SplitStat']);
    $RData->AddColumn("CntClick",$Lang['RHeaderTotal'],false,"Click");
    $RData->AddColumn("UniClick",$Lang['RHeaderUni'],false,"Click");
    $RData->AddColumn("CntSale",$Lang['RHeaderTotal'],false,"Sale");
    $RData->AddColumn("UniSale",$Lang['RHeaderUni'],false,"Sale");
    $RData->AddColumn("Income",$Lang['RHeaderIncome'],false,"Sale");
    $RData->AddColumn("CntAction",$Lang['RHeaderTotal'],false,"Action");
    $RData->AddColumn("UniAction",$Lang['RHeaderUni'],false,"Action");
    $RData->AddColumn("ActionConv",$Lang['RHeaderAction'],false,false,1);
    $RData->AddColumn("SaleConv",$Lang['RHeaderSale'],false,false,1);

    $GroupBy='Page';
    $Report->SplitStat['Name']=$Lang['General'];
    $RData->AddRow($Report->SplitStat);
    if (!empty($Report->PageStat)) {
    foreach ($Report->PageStat as $k=>$v) {
        $v['Name']=$v['Obj']->HOST.$v['Obj']->PATH;
        $RData->AddRow($v);
    }
    }
    return $RData;
}

function DoCache($Cache=false, $CpId=false, $NoComment=NO_CRON_COMMENTS, $Additional=false, $GetMode=false)
{
    $PrepareCacheMode = true;
    if (!$Cache) return false;
    if (!$CpId) return false;
    global $Db, $nsUser, $Lang, $Settings, $CpTZ, $SaveMode, $nsProduct, $CurrentTask;
    $Cpu=array();
    $Cpu[]=GetCpuLoad(false, $NoComment);
    $FormLimit=false;
    $SaveMode=$Cache->MODE; //     SortRows

    //       ,    
    if ($Cache->MODE=='SPLIT') return DoCacheSplit($Cache, $CpId, $NoComment, $GetMode);
    if ($Cache->MODE=='CUSTOM') return DoCacheCustom($Cache, $CpId, $NoComment);

    //    ,       
    if ($Cache->ADDITIONAL_TASK && !$Additional) {
        $Arr=explode("|", $Cache->ADDITIONAL_TASK);
        foreach ($Arr as $i=>$Ad) DoCache($Cache, $CpId, $NoComment, $Ad, $GetMode);
        $Query = "UPDATE ?_{$CpId}_cache SET ADDITIONAL_TASK='' WHERE ID =?";
        $Db->Query($Query, $Cache->ID);
        return true;
    }

    if ($CurrentTask=='CACHE') $LogId=CreateCronRecord($Cache->ID,$CpId,V($Cache->REPORT_ID));

    //   
    $Query = "SELECT * FROM ?_{$CpId}_cache_query_set WHERE ID = ?";
    $QuerySet=$Db->Select($Query, false, $Cache->QUERY_SET_ID);

    if (!$QuerySet) return false;
    $Params=unserialize($QuerySet->PARAMS_SET);
    $_REQUEST=$Params;
    $_REQUEST['WhereArr']=V($_REQUEST['WhereArr'],array());
    $_GP =& $_REQUEST; //  
    if (!is_array($_REQUEST['WhereArr'])) $_REQUEST['WhereArr']=unserialize($_REQUEST['WhereArr']);
    $MetaTitle=$SaveMode=$Cache->MODE;

    // 5    ,    _cache_data
    $AdditionalHash="";
    if ($Additional) {
        $Arr=explode(";", $Additional);
        foreach($Arr as $i=>$Ad) {
            $Arr2=explode("=", $Ad);
            $Var=$Arr2[0];
            $$Var=$Arr2[1];
            $_REQUEST[$Var]=$Arr2[1];
            if ($Var=="FormLimit") continue;
            $AdditionalArr[$Var]=$Arr2[1];
        }
        $AdditionalHash=md5(serialize($AdditionalArr));
    }

    //    
    include SELF."/lib/reports/const_groups.arr.php";
    include SELF."/lib/reports/prepare_vars.inc.php";

    if (!$Additional&&$Cache->CACHE_TYPE!=2) {
        if (!$NoComment) echo "no additional information.. generating by self...\n";
        $AdditionalArr['OrderBy']=$OrderBy;
        $AdditionalArr['OrderTo']=$OrderTo;
        $AdditionalHash=md5(serialize($AdditionalArr));
        if (!$NoComment) echo "new additional hash: $AdditionalHash\n";
    }

    //       
    if (!V($CpTZ[$CpId])) {
        $Query = "SELECT TIMEZONE FROM ?_config WHERE COMPANY_ID=? AND SITE_ID=0";
        $TZ=$Db->ReturnValue($Query, $CpId);
        $CpTZ[$CpId]=$TZ;
    }
    else $TZ=$CpTZ[$CpId];
    $nsUser->SQL_TZ=SqlTZ(V($TZ, 0));
    $nsUser->_SQL_TZ=SqlTZ(V($TZ, 0),$nsUser->SQL_TZ);
    if (V($SiteId)=="-1") $SiteId="";

    if (!$NoComment) echo "cache id: ".$Cache->ID.", company: $CpId, type: ".$Cache->MODE.", ".$Cache->CACHE_TYPE."\n";
    if (!$NoComment) echo "creating report class...\n";

    //  
    if ($Cache->MODE=="NATURAL") $Report= new Constructor($CpId,'NATURAL');
    if ($Cache->MODE=="PAID") $Report= new Constructor($CpId,'PAID');
    $Report->GroupBy=$GroupBy;
    $Report->MakeSum=true;
    $Report->SiteId=$SiteId;
    $Report->CacheEnable=false;
    $Report->EnableAll();
    $Report->CampId=$CampId;
    $Report->GrpId=$GrpId;
    $Report->StartDate=$StartDate;
    $Report->ViewDate=$ViewDate;
    $Report->EndDate=$EndDate;
    $Report->NewVsRet=true;
    $Report->SessVisits = array_intersect($SessionGroups,$UsedGroupsArr) ||$Report->_OnlyAction||$Report->_OnlySale?
                                        false: true;
    $Report->TrafficMode=$TrafficMode;
    $Report->QuerySetId=V($Cache->QUERY_SET_ID);

    if ($DynamicPeriod!="-1" && $DynamicPeriod!=="" ) {
        $DynamicDate=GetDateFromPeriod($DynamicPeriod,true,$TZ);
        $Report->StartDate=$DynamicDate['StartDate'];
        $Report->ViewDate="";
        $Report->EndDate=$DynamicDate['EndDate'];
    }

    //      ,    
    if (!$CampId && !$GrpId) {

    //     ReportAddJoin  ReportAddWhere
    $GLOBALS['Report'] =& $Report;
    $GLOBALS['PrevReport'] = false;
    global $PrevReport;

    //   
    if (!$NoComment) echo "including libraries...\n";
    include SELF."/lib/reports/const_where.inc.php";
    include SELF."/lib/reports/prepare_groups.inc.php";
    include SELF."/lib/reports/const_groupby.inc.php";

    //      
    if (@$PrevConvReport) {
        $PrevConvReport->TrafficMode=$TrafficMode;
        $PrevConvReport->Calculate();
        $Report->PrevLevelUni=V($PrevConvReport->StatArr[$PrevConvReport->ConversionUni], 0);
    }

    if ($FormLimit) $FormLimit++;
    //   CACHE_ROWS_CNT   ARCHIVE_ROWS
    $Limit=(($Settings['All']->CACHE_ROWS_CNT)?$Settings['All']->CACHE_ROWS_CNT+1:2001);
    $Limit=max($Limit,$FormLimit);
    $Report->PageLimit=max($Limit,$FormLimit);
    $Report->OrderBy=$OrderBy;
    //      
    if ($OrderBy == "ACTCONV"||$OrderBy == "SALECONV"||$OrderBy == "ROI") $Report->PageLimit=false;

    if (array_intersect($SessionGroups,$UsedGroupsArr)) {
        $Report->CookieJoin=false;
        $Report->SessVisits=false;
    }
    if ($Report->_OnlyAction||$Report->_OnlySale) $Report->SessVisits=false;
    if (array_intersect($DateGroups,$UsedGroupsArr) &&
        $GroupBy != $UsedGroupsArr[ count($UsedGroupsArr)-1 ] ) $Report->DisableDatesFill=true;

    if (function_exists("ini_set")) @ini_set("memory_limit","20M");

    } //   CampId, GrpId
    else {
        $Report->ShowPerClick = $Report->ShowTotalCost = true;
        $Report->EnableAll();
        $Report->PageLimit = $Limit = 2;
    }

    if ($GetMode=='VARS') {
        return get_defined_vars();
    }

    if (!$NoComment) echo "calculating report...\n";
    if ($GetMode=="QUERY") return $Report->Calculate($GetMode);
    $Report->Calculate();

    if (!$CampId && !$GrpId) { //  -      
    if (in_array($OrderBy,array( "ACTCONV","SALECONV", "ACTIONCNT", "ACTIONUNI",
                                            "SALECNT", "SALEUNI", "INCOME","ROI","COST","NEW","RETURNING"))) {
        $GLOBALS['OrderBy']=$OrderBy;
        $GLOBALS['OrderTo']=$OrderTo;
        if (!$NoComment) echo "applying alternative sorting to the report...\n";
        if (!empty($Report->StatArr)) usort($Report->StatArr, "SortRows");
        $DefaultOrderBy = $OrderBy;
    }
    if (count($Report->StatArr) > $Limit) array_splice($Report->StatArr, $Limit);
    }
    if (!$NoComment) echo "number of rows: ".count($Report->StatArr)."...\n";

    if (!$NoComment) echo "preparing data...\n";
    $RowsCnt=0;
    $LimitExceed=0;

    if (!empty($Report->StatArr) && $GetMode != 'DATAOBJ') {
        if (!$GroupBy) { $Report->Tmp[0]=$Report->StatArr; $Report->StatArr=$Report->Tmp; }

        $z=0;
        $StatArr=&$Report->StatArr;
        foreach ($StatArr as $i=>$Row) {
            if ($RowsCnt==$Limit-1) {
                $LimitExceed=1;
                break;
            }
            include SELF."/lib/reports/prepare_names.inc.php";
            $Row['Position']=$z;
            $StatArr[$i]=$Row;
            $z++;
            $RowsCnt=$z;
        }
    }

    //   
    if (@$PrevReport) {
        if (!$NoComment) echo "preparing totals...\n";
        $PrevReport->_GetActionConv = false;
        $PrevReport->_GetSaleConv = false;
        $PrevReport->_GetCost = false;
        $PrevReport->JoinArr = array_merge($PrevReport->JoinArr, $PrevReport->tlsJoinArr);
        $PrevReport->WhereArr = array_merge($PrevReport->WhereArr, $PrevReport->tlsWhereArr);
        $PrevReport->Calculate();
        if (!empty($Report->StatArr)) $Report->StatArr['__total'] = $PrevReport->StatArr;
    }

    if ($GetMode=='DATAOBJ') {
        $Vars = get_defined_vars();
        return CacheReportData($CpId, $Vars);
    }

    if (!$NoComment) echo "limit exceed: $LimitExceed\n";
    if (!$NoComment) echo "putting data to cache table...\n";

    //   
    if (!$LimitExceed) {
        $Query = "DELETE FROM ?_{$CpId}_cache_data WHERE CACHE_ID= ?";
        $Db->Query($Query, $Cache->ID);
        $Query = "UPDATE ?_{$CpId}_cache SET ADDITIONAL_TASK = '' WHERE ID = ?";
        $Db->Query($Query, $Cache->ID);
    }

    if ($GetMode == 'ARR') return V($Report->StatArr, array());

    //    
    if (V($Report->StatArr)) $Serial=serialize($Report->StatArr);
    else $Serial="";
    $Serial=gzcompress($Serial, 1);
    $Serial=base64_encode($Serial);

    if ($GetMode=='DATA') return $Serial;

    $DataId=false;
    if (!$LimitExceed) $Additional="";
    if ($AdditionalHash && $LimitExceed) {
        $Query = "SELECT ID FROM ?_{$CpId}_cache_data WHERE ADDITIONAL = ? AND CACHE_ID=?";
        $DataId=$Db->ReturnValue($Query, $AdditionalHash, $Cache->ID);
        if ($DataId) {
            $Query = "UPDATE ?_{$CpId}_cache_data SET FULL_DATA = ?, ROWS_CNT=?, LIMIT_EXCEED = ? WHERE ID = $DataId";
            $Db->Query($Query, $Serial, $RowsCnt, $LimitExceed);
        }
    }
    if (!$DataId) {
        $Query = "INSERT INTO ?_{$CpId}_cache_data (CACHE_ID, FULL_DATA, ROWS_CNT, LIMIT_EXCEED, ADDITIONAL) VALUES (?, ?, ?, ?, ?)";
        $Db->Query($Query, $Cache->ID, $Serial, $RowsCnt, $LimitExceed, $AdditionalHash);
    }
    $Cpu[]=GetCpuLoad(false, $NoComment);

    CacheDone($CpId,$Cache->ID,$TZ);
    UpdateCronLog($LogId, $Report->ProcessTime,$Cpu[1],$Cpu[0], $CpId);
    if (!$NoComment) echo "\n\n\n";
}







function DoCacheCustom($Cache=false, $CpId=false, $NoComment=NO_CRON_COMMENTS)
{
    global $Db, $Logs, $nsUser, $nsProduct, $CpTZ;
    $Cpu=array();
    $Cpu[]=GetCpuLoad(false, $NoComment);
    $LogId=CreateCronRecord($Cache->ID,$CpId,V($Cache->REPORT_ID));
    $Query = "SELECT * FROM ?_{$CpId}_cache_query_set WHERE ID = ?";
    $QuerySet=$Db->Select($Query, false, $Cache->QUERY_SET_ID);
    $QueryArr = unserialize($QuerySet->PARAMS_SET);

    //       
    if (!V($CpTZ[$CpId])) {
        $Query = "SELECT TIMEZONE FROM ?_config WHERE COMPANY_ID=? AND SITE_ID=0";
        $TZ=$Db->ReturnValue($Query,$CpId);
        $CpTZ[$CpId]=$TZ;
    }
    else $TZ=$CpTZ[$CpId];

    if (!$NoComment) echo "cache id: ".$Cache->ID.", company: $CpId\n";
    if (!$NoComment) echo "calculating report...\n";
    $Arr=array();
    $Time1=$Db->GetMicrotime();
    foreach ($QueryArr as $Key=>$Query) {
        $Sql = new Query($Query);
        $TmpArr=array();
        while ($Row=$Sql->Row()) $TmpArr[]=$Row;
        if (count($TmpArr)<2) $TmpArr=V($TmpArr[0]);
        $Arr[$Key]=$TmpArr;
    }
    $RunTime=$Db->GetMicrotime()-$Time1;
    if (!$NoComment) echo "putting data to cache table...\n";

    $Serial=serialize($Arr);
    $Serial=gzcompress($Serial, 1);
    $Serial=base64_encode($Serial);

    $DataId=false;
    $LimitExceed=false;
    $Additional="";
    $Query = "SELECT ID FROM ?_{$CpId}_cache_data WHERE CACHE_ID=?";
    $DataId=$Db->ReturnValue($Query, $Cache->ID);
    if ($DataId) {
        $Query = "UPDATE ?_{$CpId}_cache_data SET FULL_DATA = ? WHERE ID = ?";
        $Db->Query($Query, $Serial, $DataId);
    }
    else {
        $Query = "INSERT INTO ?_{$CpId}_cache_data (CACHE_ID, FULL_DATA) VALUES (?, ?)";
        $Db->Query($Query, $Cache->ID, $Serial);
    }
    $Cpu[]=GetCpuLoad(false, $NoComment);
    CacheDone($CpId,$Cache->ID,$TZ);
    UpdateCronLog($LogId, $RunTime,$Cpu[1],$Cpu[0], $CpId);
    if (!$NoComment) echo "\n\n\n";
}





function DoCacheSplit($Cache=false, $CpId=false, $NoComment=NO_CRON_COMMENTS, $GetMode)
{
    global $Db, $Logs, $nsUser,$CpTZ, $nsProduct, $CurrentTask;

    $Cpu=array();
    $Cpu[]=GetCpuLoad(false, $NoComment);
    if ($CurrentTask=='CACHE') $LogId=CreateCronRecord($Cache->ID,$CpId,V($Cache->REPORT_ID));
    $SiteId="";
    $ViewDate="";
    $StartDate="";
    $EndDate="";

    if (!$NoComment) echo "cache id: ".$Cache->ID.", company: $CpId\n";

    $Query = "SELECT * FROM ?_{$CpId}_cache_query_set WHERE ID = ?";
    $QuerySet=$Db->Select($Query, false, $Cache->QUERY_SET_ID);
    $Params=unserialize($QuerySet->PARAMS_SET);
    extract($Params);

    if (!V($CpTZ[$CpId])) {
        $Query = "SELECT TIMEZONE FROM ?_config WHERE COMPANY_ID=? AND SITE_ID=0";
        $TZ=$Db->ReturnValue($Query,$CpId);
        $CpTZ[$CpId]=$TZ;
    }
    else $TZ=$CpTZ[$CpId];
    $nsUser->SQL_TZ=SqlTZ(V($TZ, 0));
    $nsUser->_SQL_TZ=SqlTZ(V($TZ, 0),$nsUser->SQL_TZ);

    if (!$NoComment) echo "creating report class...\n";

    $Report= new SplitStat_v2($CpId);
    $Report->CacheEnable=false;
    if (V($SplitId)) $Report->SplitId=$SplitId;
    $Report->EnableAll();
    if ($StartDate) $Report->StartDate=$StartDate;
    if ($ViewDate) $Report->ViewDate=$ViewDate;
    if ($EndDate) $Report->EndDate=$EndDate;
    $DynamicPeriod= V($DynamicPeriod, "-1");
    if ($DynamicPeriod!="-1" && $DynamicPeriod!=="" ) {
        $DynamicDate=GetDateFromPeriod($DynamicPeriod,true,$TZ);
        $Report->StartDate=$DynamicDate['StartDate'];
        $Report->ViewDate="";
        $Report->EndDate=$DynamicDate['EndDate'];
    }
    $Report->ShowPages=true;
    $Report->QuerySetId=V($Cache->QUERY_SET_ID);

    if (!$NoComment) echo "calculating report...\n";
    if ($GetMode=="QUERY") return $Report->Calculate($GetMode);

    if ($GetMode=='VARS') return get_defined_vars();

    $Report->Calculate();

    if ($GetMode=='DATAOBJ') {
        $Vars = get_defined_vars();
        return SplitReportData($CpId, $Vars);
    }

    //    
    if (!$NoComment) echo "putting data to cache table...\n";

    if (V($Report->SplitStat)) $Serial=serialize($Report->SplitStat);
    else $Serial="";
    if (V($Report->PageStat)) $Serial2=serialize($Report->PageStat);
    else $Serial2="";
    $Arr[0]=$Serial;
    $Arr[1]=$Serial2;
    $Serial=serialize($Arr);
    $Serial=gzcompress($Serial, 1);
    $Serial=base64_encode($Serial);

    if ($GetMode=='DATA') return $Serial;

    $DataId=false;
    $LimitExceed=false;
    $Additional="";
    $Query = "SELECT ID FROM ?_{$CpId}_cache_data WHERE CACHE_ID=?";
    $DataId=$Db->ReturnValue($Query, $Cache->ID);
    if ($DataId) {
        $Query = "UPDATE ?_{$CpId}_cache_data SET FULL_DATA = ? WHERE ID = ?";
        $Db->Query($Query, $Serial, $DataId);
    }
    else {
        $Query = "INSERT INTO ?_{$CpId}_cache_data (CACHE_ID, FULL_DATA) VALUES (?, ?)";
        $Db->Query($Query, $Cache->ID, $Serial);
    }
    $Cpu[]=GetCpuLoad(false, $NoComment);
    CacheDone($CpId,$Cache->ID,$TZ);
    UpdateCronLog($LogId, $Report->ProcessTime,$Cpu[1],$Cpu[0], $CpId);
    if (!$NoComment) echo "\n\n\n";

}

?>