<?
if (!defined("NS_TRACKER_INDEX")) exit;

require_once SELF.'/lib/reports/export_params.func.php';

if (isset($Report->StatArr['__total'])) {
    $TotalArr = $Report->StatArr['__total'];
    unset($Report->StatArr['__total']);
}

if (in_array($OrderBy,array( "ACTCONV","SALECONV", "ACTIONCNT", "ACTIONUNI",
                                            "SALECNT", "SALEUNI", "INCOME","ROI","COST","NEW","RETURNING"))) {
	if (!$Report->TakenFromCache) usort($Report->StatArr, "SortRows");
    $DefaultOrderBy = $OrderBy;
}

if ($Report->TakenFromCache && !$Report->ExceedLimit) usort($Report->StatArr, "SortRows");

//    

if ($Report->FilterOnFly&&$Filter) {
    $Inx=0;
    $NewStat=array();
    foreach ($Report->StatArr as $i=>$Row) {
        if(strpos(strtolower($Row['Name']),strtolower($Filter))==false) {
            unset($Report->StatArr[$i]);
            continue;
        }
        $NewStat[$Inx]=$Row;
        $NewStat[$Inx]['Position']=$Inx;
        $Inx++;
    }
    $Report->StatArr=$NewStat;
}

if (!V($ExportNoLimit) && count($Report->StatArr) > $Limit) {
    $RowsLimitExceed=true;
    array_splice($Report->StatArr, $Limit);
}

require SELF."/lib/reports/prepare_table.inc.php";
$z=0;

$UseWeekDay=!preg_match("/[Dlr]/", V($Settings['All']->FORMAT_DATE));

foreach ($Report->StatArr as $i=>$Row) {
    if (!$Report->TakenFromCache&&!$ArchiveMode) include SELF."/lib/reports/prepare_names.inc.php";
    include SELF."/lib/reports/prepare_name_dates.inc.php";

	if (@$ExportCsv&&@$ExportExpanded) {
	    $Row['ActionConvOne']=$Report->OneOf($Row['UniAction'], $Row['UniClick']);
	    $Row['SaleConvOne']=$Report->OneOf($Row['UniSale'], $Row['UniClick']);
	}
	$Row['Position']=$z;
    $Row['ActionConvOneOf']=$Report->OneOf(@$Row['UniAction'],@$Row['UniClick']);
    $Row['SaleConvOneOf']=$Report->OneOf(@$Row['UniSale'],@$Row['UniClick']);
	$Report->StatArr[$i]=$Row;
	$z++;
}

$RData->Rows=&$Report->StatArr;
if (method_exists('MakeSum', $RData)) $RData->MakeSum();
$RData->ShowRealSum = true;
$RData->ShowSubSum = !$RowsLimitExceed;
$RData->ShowLimitExceed = @$ArchiveMode?false:$RowsLimitExceed;
if (@$TotalArr) $RData->ColumnsRealSum = $TotalArr;
if (!@$TotalArr && $ArchiveMode) @$RData->ShowRealSum = false;
if (!@$ArchiveMode) {
    $RData->SaveEnable = true;
    $RData->SaveLink = 'javascript:;';
    $RData->SaveJs = " $('#SaveReportForm').submit() ";
}

$ExportParams = ExportParams(array('Mode'=>$SaveMode, 'CacheId'=>$Report->GetCacheId(),
                                                                  'StartDate'=>@$Report->StartStamp, 'EndDate'=>@$Report->EndStamp,
                                                                  'Filter'=>$Filter,
                                                                  'SiteId'=>$SiteId, 'TrafficMode'=>$TrafficMode,
                                                                  'ReportValues'=>@$RData->ReportValues,
                                                                  'Name'=>@$RData->ReportCaptionLast));
$RData->ExportParams = $ExportParams;

if ((@$ExportCsv||@$ExportXls) && !@$PrepareCacheMode) {
    if ($RData->HasColumn('CntClick')) $RData->Columns['CntClick']['Name']=$Lang['TotalHits'];
    if ($RData->HasColumn('UniClick')) $RData->Columns['UniClick']['Name']=$Lang['UniVisitors'];
    if ($RData->HasColumn('CntAction')) $RData->Columns['CntAction']['Name']=$Lang['TotalActions'];
    if ($RData->HasColumn('UniAction')) $RData->Columns['UniAction']['Name']=$Lang['ByVisitors'];
    if ($RData->HasColumn('CntSale')) $RData->Columns['CntSale']['Name']=$Lang['TotalSales'];
    if ($RData->HasColumn('UniSale')) $RData->Columns['UniSale']['Name']=$Lang['ByVisitors'];
    if ($RData->HasColumn('ROI')) $RData->Columns['ROI']['Name']=$Lang['ROI'];
    if ($RData->HasColumn('CampCost')) $RData->Columns['CampCost']['Name']=$Lang['CampCost'];
    if ($RData->HasColumn('TotalIncome')) $RData->Columns['TotalIncome']['Name']=$Lang['CampIncome'];
    if ($RData->HasColumn('Income')) $RData->Columns['Income']['Name']=$Lang['RHeaderIncome'];
    if ($RData->HasColumn('ActionConv')) $RData->Columns['ActionConv']['Name']=$Lang['ActionsConv'];
    if ($RData->HasColumn('SaleConv')) $RData->Columns['SaleConv']['Name']=$Lang['SalesConv'];

    $RData->EnableSubValues=(!@$ExportExpanded)?false:true;

    if ($ExportCsv) $_REQUEST['_csv'] = $RData->Id;
    if ($ExportXls) $_REQUEST['_xls'] = $RData->Id;
    $RData->CheckExport( $ExportParams );
}

// $PrepareCacheMode -     DoCache()
if ( !@$PrepareCacheMode && $nsUser->Columns->GRAPHS) {
    $StatArrName="StatArr";
	$DateFormat=$GroupBy;
	//////////////// 
    if (in_array($GroupBy,array('Date','Month','Time','Year','WeekDay')))
        include SELF."/lib/reports/date_graph.inc.php";
    else include SELF."/lib/reports/pie_graph.inc.php";
}

if (!@$PrepareCacheMode) $RData->CheckExport( $ExportParams );
if (!@$PrepareCacheMode) include $nsTemplate->Inc('constructor/report_dump.inc');
?>