<?

require_once (@$nsSelf?$nsSelf:SELF)."/class/ua_tracker.class.php";

// RequestType: 
// 1 - default
// 2 - event
// 3 - sale
// 4 - click
// 5 - split

class NS_TRACK_DELAYED {

    function WriteTempLog($RedirectURL=false)
    {
        global $_NS_TRACK_VARS, $_COOKIE;
        $Db=&$_NS_TRACK_VARS['Db'];
        $UseBotLog=&$_NS_TRACK_VARS['UseBotLog'];        
        $Skip=&$_NS_TRACK_VARS['Skip'];
        $RequestType=&$_NS_TRACK_VARS['RequestType'];
        $CompanyId=&$_NS_TRACK_VARS['CompanyId'];
        $_GP=&$_NS_TRACK_VARS['_GP'];

        $CookieId=NS_TRACK_DELAYED::GetVisitorId();

        //  .
        $UserIp=NS_TRACK_VISITOR::GetUserIp();
        $RequestVars['_GP']=$_GP;
        $RequestVars['HTTP_USER_AGENT']=$_SERVER['HTTP_USER_AGENT'];
        $RequestVars['QUERY_STRING']=$_SERVER['QUERY_STRING'];
        $Stamp=gmdate("Y-m-d H:i:s", time());

        $Query = "INSERT INTO ?_{$CompanyId}_delayed (REQUEST_TYPE,STAMP,VISITOR_COOKIE,IP,VARS,BOT_LOG)
                            VALUES (?,?,?,?,?,?)";
        $Db->Query($Query,$RequestType,$Stamp,$CookieId,$UserIp,serialize($RequestVars),($UseBotLog?1:0));
        if ($RedirectURL) NS_TRACK_MISC::Redir($RedirectURL);
        else NS_TRACK_GENERAL::FinishTracking('Delayed record');
    }

    function GetVisitorId()
    {
        global $_NS_TRACK_VARS, $_COOKIE, $_GP;
        $Db=&$_NS_TRACK_VARS['Db'];
        $UseBotLog=&$_NS_TRACK_VARS['UseBotLog'];
        $Skip=&$_NS_TRACK_VARS['Skip'];
        $CheckCookieId=&$_NS_TRACK_VARS['CheckCookieId'];
        $CookieEnabled=false;
        $CookieId=false;
        $RequestVars=array();

        $UserAgent=NS_TRACK_MISC::V($_SERVER['HTTP_USER_AGENT']);
        if ( (defined("NS_PHP_TRACKING")&&!trim($UserAgent)&&!$PresetIP&&!$PresetID) ||     
                (!defined("NS_PHP_TRACKING")&&!trim($UserAgent)) ) {
            NS_TRACK_GENERAL::FinishTracking('No user agent');
        }

        // ,      .  ,   .
        $UAParser = new UATrackerParser();
        $UA=$UAParser->ParseUA($UserAgent);
        if (!$UA['Other']&&$UA['PotentialBot']) NS_TRACK_GENERAL::FinishTracking('Potential bot');
        if ($UA['Other']) {$UseBotLog=true; return '';}

        // ,   
        $CookieId=@$_COOKIE[NS_COOKIE_PFX.'visitor'];
        if (defined("NS_PHP_TRACKING") && !empty($_COOKIE)) $CookieEnabled=true;
        if (!defined("NS_PHP_TRACKING")) {
            if (!$CheckCookieId && !@$_COOKIE[NS_COOKIE_PFX.'visitor']) {
                $CookieId=NS_TRACK_VISITOR::TrackingVisitorCookie();
                NS_TRACK_MISC::Redir(NS_TRACK_MISC::ns_my_url()."&CheckCookieId=$CookieId");
            }
            if ($CheckCookieId && @$_COOKIE[NS_COOKIE_PFX.'visitor']) $CookieEnabled=true;
        }
        if ($CookieEnabled&&!$CookieId) $CookieId=NS_TRACK_VISITOR::TrackingVisitorCookie();
        $_NS_TRACK_VARS['CookieId']=$CookieId;
        return $CookieId;
    }

    function WriteDelayedCookie($Name=false, $Value=false, $Expire=false, $Path=false, $Domain=false, $Secure=false)
    {
        global $_NS_TRACK_VARS;
        $Db=&$_NS_TRACK_VARS['Db'];
        $CompanyId=&$_NS_TRACK_VARS['CompanyId'];
        $CookieId=&$_NS_TRACK_VARS['CookieId'];
        $QueryClass=&$_NS_TRACK_VARS['QueryClass'];    

        $NextRec=false;
        $Query = "SELECT ID, COOKIE_VAR FROM ?_{$CompanyId}_delayed WHERE VISITOR_COOKIE=? 
                            ORDER BY STAMP ASC LIMIT 2";
        $Sql = new $QueryClass($Query,false,$CookieId);
        while ($Row=$Sql->Row()) {$NextRec=$Row;}
        if (!$NextRec) return false;
        
        $CookieArr=array();
        if ($NextRec->COOKIE_VARS) $CookieArr=unserialize($NextRec->COOKIE_VARS);
        $CookieArr[$Name]=$Value;
        $CookieStr=serialize($CookieArr);
        
        $Query = "UPDATE ?_{$CompanyId}_delayed SET COOKIE_VARS = ? WHERE ID=?";
        $Db->Query($Query,$CookieStr);
        return true;
    }
    
    function DelayedNeeded()
    {
        global $_NS_TRACK_VARS;
        $Settings=&$_NS_TRACK_VARS['Settings'];
        $CompanyId=&$_NS_TRACK_VARS['CompanyId'];
        if (NS_TRACKER_DELAYED) return false;
        if ($Settings['All']->DELAYED_TRACKING || @$Settings[$CompanyId]->DELAYED_TRACKING) return true;
        return false;
    }
}

?>