<?

require_once (@$nsSelf?$nsSelf:SELF)."/class/search_engine.class.php";
require_once (@$nsSelf?$nsSelf:SELF)."/lib/track/misc.func.php";

class NS_TRACK_REFERER {


function GetRefererSet($RefArr=false, $Referer=false)
{
	if (!$RefArr||!$Referer) return 0;

	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$NaturalKey=&$_NS_TRACK_VARS['NaturalKey'];
	$HostsArr=&$_NS_TRACK_VARS['HostsArr'];
	$CookieLogSet=&$_NS_TRACK_VARS['CookieLogSet'];
	$UpdateVisPath=&$_NS_TRACK_VARS['UpdateVisPath'];
	$Frame=&$_NS_TRACK_VARS['Frame'];

	//     ,     =)
	if ($Frame) return 0;

	if (!NS_TRACK_MISC::V($RefArr['host'])) return 0;

	//      
	$HostObj=NS_TRACK_REFERER::GetRefHost($RefArr['host']);

	//   ,  
	if (!$HostObj) {$Skip=true; return 0;}

	$RefHostId=&$_NS_TRACK_VARS['RefHostId'];
	$SourceId=&$_NS_TRACK_VARS['SourceId'];

	//  id     
	$SourceId=$HostObj->ID;

	//        ,   
	if (!isset($HostsArr[NS_TRACK_MISC::ToLower($RefArr['host'])])) {
		$RefHostId=$HostObj->ID; //    ?
		$CookieLogSet=true;
		$UpdateVisPath=true;
	}
	else 	return 0;

	//  id 
	$RefId=NS_TRACK_REFERER::GetRefererId($Referer);

	// ,  referer set   
	$Query = "SELECT ID, NATURAL_KEY FROM ?_referer_set WHERE REFERER_ID=?";
	$Check=$Db->Select($Query, false, $RefId);
	//  
	if (NS_TRACK_MISC::ValidId($Check->ID)) {
		//     ,     
		$NaturalKey=($Check->NATURAL_KEY>0)?$Check->NATURAL_KEY:false;
		return $Check->ID;
	}
	//  referer set  ,  
	return NS_TRACK_REFERER::RefSetProcess($RefArr,$RefId,$HostObj,$Referer);
}

function GetRefererId($Ref=false)
{
	if (!$Ref) return 0;
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];

    $Md5Ref=urlencode($Ref);
    $Ref=urldecode(urldecode($Ref));

	$Query = "SELECT ID FROM ?_referer WHERE MD5_SEARCH=MD5(?)";
	$CheckId=$Db->ReturnValue($Query, $Md5Ref);
	if (NS_TRACK_MISC::ValidId($CheckId)) return $CheckId;
	$Query ="INSERT INTO ?_referer (REFERER, MD5_SEARCH) VALUES (?, MD5(?))";
	$Db->Query($Query, $Ref, $Md5Ref);
	return $Db->LastInsertId;
}



function RefSetProcess($RefArr, $RefId=false, $HostObj=false, $Referer=false)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$StId=&$_NS_TRACK_VARS['StId'];
	$Skip=&$_NS_TRACK_VARS['Skip'];
	$NaturalKey=&$_NS_TRACK_VARS['NaturalKey'];
	$HostsArr=&$_NS_TRACK_VARS['HostsArr'];
	$CookieLogSet=&$_NS_TRACK_VARS['CookieLogSet'];
	$UpdateVisPath=&$_NS_TRACK_VARS['UpdateVisPath'];
    $CurrentCharset=&$_NS_TRACK_VARS['CurrentCharset'];
    $SE=&$_NS_TRACK_VARS['SE'];
    if (!$SE) $SE=  new SearchEngine();
    $SE->SetReferer($Referer);
    if (!$SE->HostGrpKey) $SE->HostGrpKey=$HostObj->NAME_KEY;
    $SE->AnalyzeData($Referer);
    if (!$SE->Keyword && !$HostObj->NAME_KEY && $HostObj->KEY_VAR) {
        $SE->Keyword= urldecode(@$SE->QArr[$HostObj->KEY_VAR]);
    }
    $Key=$SE->Keyword;
    
    if ($Key) {	
        if (!$HostObj->CHARSET||@$HostObj->RENEW_CHARSET) 
            $HostObj->CHARSET=NS_TRACK_REFERER::GetHostCharset($RefArr, $HostObj->ID);
		$Key=NS_TRACK_REFERER::PrepareKeyword($Key, $HostObj->CHARSET);
        $Key=NS_TRACK_MISC::ToLower($Key,@$CurrentCharset['charset']);
		$Key=preg_replace("/\s+/", " ", $Key);
		$Key=trim($Key);
        $KeyId=NS_TRACK_REFERER::GetKeywordId($Key);
	}
	else $KeyId=0;
	$NaturalKey=$KeyId;

	$Query = "INSERT INTO ?_referer_set 
        (HOST_ID, NATURAL_KEY, PROCESSED, REFERER_ID) VALUES (?, ?, '1', ?)";
	$Db->Query($Query, $HostObj->ID, $KeyId, $RefId);
	return $Db->LastInsertId;
}

function PrepareKeyword($Key, $HostCharset=false)
{
    global $_NS_TRACK_VARS;
    $CurrentCharset=&$_NS_TRACK_VARS['CurrentCharset'];
    if (!isset($CurrentCharset['charset'])) return $Key;
    $Convert=new nsConvertCharset(false, "NS_TRACK_REFERER::ConvertError");
    $NewKey=$Convert->Convert($Key, $HostCharset, $CurrentCharset['charset']);
    return $NewKey?$NewKey:$Key;
}

function ConvertError($Number, $Value = false)
{
    if (!defined("NS_PHP_TRACKING")) {
        global $nsLang, $Logs;
        $nsLang->TplInc("inc/convert_charset");
        $Logs->Err(str_replace("{VALUE}", $Value, $Lang['ConvertCharsetMsg'][$Number]));
    }
    return false;
}


function GetHostCharset($RefArr=false, $HostId=false)
{
    if (!$RefArr) return false;
    if (!function_exists('curl_exec')) return false;
	global $_NS_TRACK_VARS;
	if (!$_NS_TRACK_VARS['Settings']['All']->CATCH_CHARSET) return false;

    $RefArr['query']=urlencode($RefArr['query']);
    $Addr=NS_TRACK_GENERAL::GlueUrl($RefArr);
    $HttpHeaders[]="User-Agent: ".NS_TRACK_MISC::ValidVar($_SERVER['HTTP_USER_AGENT']);
    $HttpHeaders[]="Accept: ".NS_TRACK_MISC::ValidVar($_SERVER['HTTP_ACCEPT']);
    $HttpHeaders[]="Accept-Language: ".NS_TRACK_MISC::ValidVar($_SERVER['HTTP_ACCEPT_LANGUAGE']);
    $HttpHeaders[]="Accept-Charset: utf-8";
    $Ch = curl_init();  
    curl_setopt($Ch, CURLOPT_URL, $Addr);
    curl_setopt($Ch, CURLOPT_VERBOSE, 0);
    curl_setopt($Ch, CURLOPT_HEADER, 1);
    curl_setopt($Ch, CURLOPT_NOBODY, 0);
    if (defined('CURLOPT_MUTE')) curl_setopt($Ch, CURLOPT_MUTE, 1);
    curl_setopt($Ch, CURLOPT_FOLLOWLOCATION, 0);
    curl_setopt($Ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($Ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($Ch, CURLOPT_HTTPHEADER, $HttpHeaders);
    $Res = curl_exec($Ch);
    curl_close($Ch);
    $Charset=false;
    $Headers=false;
    if (preg_match("/^[^<]*\n</i", $Res, $Headers)) {
        preg_match("/charset=([^\s\\\"']+)/i", $Headers[0], $Charset);
    }
    if (!isset($Charset[1])) preg_match("/<meta[^>]*charset=([^\\\"']+)/i", $Res, $Charset);
    if (isset($Charset[1])) $Charset=strtolower($Charset[1]);
    
    if (!is_array($Charset) && $HostId) {
        global $_NS_TRACK_VARS;
        $Db=&$_NS_TRACK_VARS['Db'];            
        $Query = "UPDATE ?_host SET CHARSET=? WHERE ID = ?";
        $Db->Query($Query, $Charset, $HostId);
    }
    
    return (is_array($Charset))?false:trim($Charset);
}


function GetRefHost($Host=false)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
    
    $Args[]=$Host;
    if (substr($Host,0,4)=='www.') $Host2=substr($Host,4);
    else $Host2='www.'.$Host;
    $Args[]=$Host2;

	$Query = "
		SELECT 
			TH.ID, TH.KEY_VAR, TH.BAN, TH.CHARSET, TH.HOST, TH.RENEW_CHARSET,
			THG.KEY_VAR AS GKEY, THG.BAN AS GBAN,
            THG.CHARSET AS GCHARSET, THG.NAME_KEY, THG.RENEW_CHARSET AS  G_RENEW_CHARSET
			FROM ?_host TH
				LEFT JOIN ?_host_grp THG
					ON THG.ID=TH.GRP_ID
			WHERE TH.HOST IN (?)
            LIMIT 1
	";
	$RefObj=$Db->Select($Query, false, $Args);
	if (!$RefObj) {
		NS_TRACK_REFERER::NewHost($Host);
		return NS_TRACK_REFERER::GetRefHost($Host);
	}
	if ($RefObj->BAN||$RefObj->GBAN) return 0;
	if (!$RefObj->KEY_VAR) $RefObj->KEY_VAR=$RefObj->GKEY;
    if (!$RefObj->CHARSET) $RefObj->CHARSET=$RefObj->GCHARSET;
	return $RefObj;
}


function GetKeywordId($Key=false)
{
	if (!$Key) return 0;
	global $Db, $_NS_TRACK_VARS;
	if (!$Db) $Db=&$_NS_TRACK_VARS['Db'];
    $CurrentCharset=&$_NS_TRACK_VARS['CurrentCharset'];
	
	$LowerKey=NS_TRACK_MISC::ToLower($Key,@$CurrentCharset['charset']);
	$LowerKey=md5($LowerKey);

	$Query = "SELECT ID FROM ?_keyword WHERE MD5_SEARCH=?";
	$CheckId=$Db->ReturnValue($Query,$LowerKey);
	if (NS_TRACK_MISC::ValidId($CheckId)) return $CheckId;
	$Query ="INSERT INTO ?_keyword (KEYWORD, MD5_SEARCH) VALUES (?, ?)";
	$Db->Query($Query, $Key, $LowerKey);
	return $Db->LastInsertId;
}



function NewHost($Host)
{
	global $_NS_TRACK_VARS;
	$Db=&$_NS_TRACK_VARS['Db'];
	$QueryClass=&$_NS_TRACK_VARS['QueryClass'];
    $SE=&$_NS_TRACK_VARS['SE'];
    if (!$SE) $SE=  new SearchEngine();
    $SE->Host=$Host;
    $SE->AnalyzeData();
    if (!$SE->HostGrpKey) $GrpId=0;
    else {
        $Query = "SELECT ID FROM ?_host_grp WHERE NAME_KEY=?";
        $GrpId=$Db->ReturnValue($Query,$SE->HostGrpKey);
    }

	$Query = "INSERT INTO ?_host (GRP_ID, HOST) VALUES (?, ?)";
	$Db->Query($Query, $GrpId, $Host);
	return $Db->LastInsertId;
}


function ReplacePunkt($Str)
{
	$From="~!@#$%^&*()_+|`-=\\{}[]:\";',./<>?";
	$To="                                    ";
	return strtr($Str, $From, $To);
}


function FindReqKeyword($GetVars=array(),$ParamStr=false)
{
    if (!$ParamStr) return false;
    $ParamArr=explode(",",$ParamStr);
    foreach ($ParamArr as $K) {
        if (!empty($GetVars[trim($K)])) return $GetVars[trim($K)];
    }
    return false;
}

}

?>