
var sitesEnabled = true
$(document).ready(function() {
    $('.DashSection').each(function() {
        var o = $(this)
        o.mouseover(function() { o.addClass('DashSectionHover') })
        o.mouseout(function() { o.removeClass('DashSectionHover') })
    })    
    if (sitesEnabled) loadURL('SiteStat', stTodayURL, false, function() { 
            showActivityPinned( function() { showGraphs(1); }); 
        });
});

var currentSiteId = false
function showGraphs(reload) {
    var siteId = $('#SiteIdSelector').val()
    if ($('#site' + siteId).html() && !reload) {
        $('#site' + siteId).show()
        $('#site' + currentSiteId).hide()
        currentSiteId = siteId
        setDefaultGraph(siteId)
        return false
    }

    var URL = graphURL
    URL += siteId
    loadURL('site'+siteId, URL,
        function() {
            showBlockLoading('Days')
            $('#GraphSelector').attr('disabled', true) 
            $('#SiteIdSelector').attr('disabled', true)
        }, 
        function() {
            //hideGlobalLoading()
            hideBlockLoading('Days')
            $('#GraphSelector').attr('disabled', false).get(0).selectedIndex=0
            $('#SiteIdSelector').attr('disabled', false)
            setDefaultGraph(siteId)
            $('#site' + currentSiteId).hide()
            $('#site' + siteId).show() 
            currentSiteId = siteId            
        })
}

function setDefaultGraph(siteId) {
    if (CurGraph) $(CurGraph).hide()
    $('#GR_'+siteId+'VisitorGraph').show()
    $('#GR_'+siteId+'SaleConvGraph').hide()
    $('#GR_'+siteId+'IncomeGraph').hide()
    CurGraph = $('#GR_'+siteId+'VisitorGraph').get(0)
    $('#GraphSelector').get(0).selectedIndex=0
}

function switchGraph() {
    if (CurGraph) $(CurGraph).hide()
    var siteId = $('#SiteIdSelector').val()
    var key = $('#GraphSelector').val()
    $('#GR_'+siteId+key).show()
    CurGraph = $('#GR_'+siteId+key).get(0)
}

function showBlockLoading(name) {
    $('#refresh'+name).hide()
    $('#loading'+name).show()
}
function hideBlockLoading(name) {
    $('#refresh'+name).show()
    $('#loading'+name).hide()
    $('#close'+name).show()
    $('#goto'+name).show()
}

function loadDashReport(container, URL, name) {
    loadURL(container, URL, function() { showBlockLoading(name) }, function() { hideBlockLoading(name) })
}

function showActivityPinned(callback) {
    var d = $('#activityData');
    var pinned = d.attr('activityorder');
    if (!pinned) return showActivity(false, false, callback);
    var arr = pinned.split(',');
    for (var i = 0; i < arr.length; i++) {
        var dval = arr[i].replace(/\d+/, '');
        var sval = arr[i].replace(/[^\d]+/, '');
        showActivity( (sval=='undefined' ? '' : sval), dval, (i==arr.length - 1? callback : false) , true);
    }
}

function showActivity(sval, dval, callback, dontClose) {

    if (!sval && !dval) {
        var s = $('#activitySiteId')
        var d = $('#activityData')
        var sval = s.val();
        var dval = d.val();
    }
    if (sval == -1) return false
    if (!dval || dval == -1) return false
    if (!dontClose) $('div', '#Activity').hide()
    $('#sActivity'+sval, '#Activity').show()
    var data = $('#'+dval+sval, '#Activity')    
    if (data.get(0)) return false

    var URL = activityURL + '&SiteId='+sval+'&ActData='+dval;
    requestURL(URL, 
                        function() {
                            $('#loadingActivity').show()
                            $('#activitySiteId, #activityData').attr('disabled', true)
                        }, 
                        function(data) {
                            $('#loadingActivity').hide()
                            $('#activitySiteId, #activityData').attr('disabled', false)
                            $('#sActivity'+sval).append(data)
                            if (callback) callback()
                        })
}

function showCmpPeriod() {
    var b = $('#CmpPeriod');
    var d = $('#CmpPeriodBlock');
    var ofs = b.offset();
    b.parent().find('img').hide();
    if (d.parent() != b.parent()) d.appendTo(b.parent());
    d.show();
    var preventClose = true;
    d.bind('click.cmp', function() { return preventClose = true; });
    $('body').bind('click.cmp', function(){
        if (preventClose) return preventClose = false;
        d.hide();
        b.parent().find('img').show();
        $('body').unbind('click.cmp');
        d.unbind('click.cmp');
    });
}

function updateCmpBlock(period, URL) {
    var r = $('#CmpRefresh');
    r.parent().find('img, select').hide();
    r.show();
    loadURL('AllCmp', URL+period);
}
