
ablocks = [];

function createActivityBlock(tableid, siteid) {
    ablocks.push(new activityBlock(tableid, siteid));
}

function activityBlock(tableid, siteid) {
    this.t = $('#'+tableid);
    this.pinned = this.t.attr('pinned') == 1 ? true : false;
    this.id = tableid;
    this.siteid = siteid;
    this.control = $('td.activityControl', this.t);
    this.moveControl = $('#'+this.id+'move', this.control);
    this.pinControl = $('#'+this.id+'pin', this.control);
    this.pinnedControl = $('#'+this.id+'pinned', this.control);
    extendActivityBlock(this);
}

function extendActivityBlock(o) {
    o.t.bind('mouseenter', function() {
        if (o.t.get(0).dynamic._dragable) return false;
        if (o.pinned) o.moveControl.show();
        if (o.pinned) o.pinnedControl.show();
        else o.pinControl.show();
    });
    o.t.bind('mouseleave', function() {
        if (o.t.get(0).dynamic._dragable) return false;
        o.moveControl.hide();
        o.pinnedControl.hide();
        o.pinControl.hide();
    });
    o.pinControl.bind('click', function() {
        o.pinned = true;
        o.t.attr('pinned', '1');
        o.pinControl.hide();
        o.pinnedControl.show();
        o.moveControl.show();
        saveActivityOrder();
    });
    o.pinnedControl.bind('click', function() {
        o.pinned = false;
        o.t.attr('pinned', '0');
        o.pinnedControl.hide();
        o.pinControl.show();
        o.moveControl.hide();
        saveActivityOrder();
    });
    o.t.dragable({moveHandler: '#'+o.id+'move', clone: true,
            target: 'table.activityTable[siteid='+o.siteid+']', tolerance: 'pointer', renewTarget: true, opacity: 0.9,
            animateMoveEnd: true, animateDrop: true,
            end: function() {
                o.t.trigger('mouseleave');
            },
            over: function(t, trg) {
                trg.css('background', '#e5e5e5');
            },
            out: function(t, trg) {
                trg.css('background', '');
            },
            drop: function(t, trg) {
                trg.css('background', '');
                t.elem.insertBefore(trg);
                saveActivityOrder();
                o.t.trigger('mouseleave');
            }
    });
    o.t.get(0).actBlock = o;
}

function saveActivityOrder() {
    var order = '';
    $('table.activityTable').each(function(){
        var t = $(this);
        order += t.attr('id')+':'+(t.attr('pinned')==1?1:0)+',';
    });
    requestURL(systemAjaxURL+'activity&Order='+order);
}