<?include $nsTemplate->Inc("inc/header");?>
<?include $nsTemplate->Inc("inc/submenu");?>
<?include $nsTemplate->Inc("inc/calendar.inc");?>
<link rel="stylesheet" href="<?=FileLink("css/report.css")?>" />
<script>
$(document).ready(AdjustStats)
$(window).bind('resize',AdjustStats)
function AdjustStats() {
    if (! $('#StatsDiv').get(0) ) return false;
    $('#StatsDiv').css('display','none').css('width',$('#StatsTd').width()).css('display','block');
    if ($.browser.opera) {
        $('#StatsDiv').css('overflow','scroll')
    }
}
</script>

<?GetFORM();?>
<input type=hidden name="CpId" value="<?=$CpId?>">
<input type=hidden name="FormClicked" value="1">

<table   class=FormWrapper>
<tr><td class=FormHeader>

<?if (count($SitesArr)>1) {?>
<b style="color:#000;"><?=$Lang['ChooseSite']?>&nbsp;</b>
<select name=SiteId>
<option style="color:#999;" value=0><?=$Lang['AllSites']?></option>
<?foreach ($SitesArr as $Row) {?>
    <option value=<?=$Row->ID?> <?=(($Row->ID==$SiteId)?"selected":"")?>><?=$Row->HOST?></option>
<?}?>
</select>&nbsp;
<?}?>

<b style="color:#000;"><?=$Lang['GroupBy']?>:&nbsp;</b>
<select name=GroupBy>
<option value="Date" <?=$GroupBy=='Date'?'selected':''?>><?=$Lang['Days']?></option>
<option value="Week" <?=$GroupBy=='Week'?'selected':''?>><?=$Lang['Weeks']?></option>
<option value="Month" <?=$GroupBy=='Month'?'selected':''?>><?=$Lang['Months']?></option>
<option value="Year" <?=$GroupBy=='Year'?'selected':''?>><?=$Lang['Years']?></option>
<option value="Time" <?=$GroupBy=='Time'?'selected':''?>><?=$Lang['Time']?></option>
</select>&nbsp;

<input type=submit value="<?=$Lang['Refresh']?>">
</td>
</tr>

<tr><td style='padding:6px;'>
<input type=hidden id=ViewDate value=''>
<?=$Lang['Period']?>&nbsp;
<input type=text size=10 id="StartDate" name="StartDate" value="<?=$StartDate?>" class=DateFld ondblclick="this.value=''">
<img id='StartDateIcon' src="<?=FileLink("images/icon_date.gif");?>"  width=18 height=18 border=0 alt="" align=absmiddle>&nbsp;
&nbsp;&nbsp;
<input type=text size=10 id="EndDate" name="EndDate" value="<?=$EndDate?>" class=DateFld ondblclick="this.value=''">
<img id='EndDateIcon' src="<?=FileLink("images/icon_date.gif");?>"  width=18 height=18 border=0 alt="" align=absmiddle>&nbsp;
&nbsp;<?=$Lang['Or']?>&nbsp;
<select name="DynamicPeriod">
<option value=-1></option>
<?foreach ($FormPeriodsArr as $i=>$Row) {?>
    <option value="<?=$Row->TEMPLATE?>" <?=(($Row->TEMPLATE==$DynamicPeriod||($Row->TEMPLATE=='0-a-0'&&$DynamicPeriod=='-1'))?"selected":"")?>><?=$Row->NAME?></option>
<?}?>
</select>&nbsp;
</td></tr>

</table>
</form>

<script>
createCalendar({fieldID:'StartDate',iconID:'StartDateIcon'})
createCalendar({fieldID:'EndDate',iconID:'EndDateIcon'})
</script>

<style>

</style>



<?if (V($Cache->CacheStamp)&&$Cache->TakenFromCache) {?>
<div align=right style="text-align:right;padding-right:10px;height:20px;">
<span style="font-size:10px;"><?=$Lang['CacheUpdated']?> <?=_date($Cache->CacheStamp,'datetime')?>
<?if (V($Cache->CacheTZ)){ echo " ".str_replace("{TZ}", (($Cache->CacheTZ>0)?"+":"").$Cache->CacheTZ, $Lang['CacheTimezone']); }?>
&nbsp;|&nbsp;<a href="javascript:;" onclick="preUpdateCache();"><?=$Lang['UpdateNow']?></a></span>
</div>
<?}else {?>
<div id=SpacerLarge></div>
<?}?>

<?if ($Cache->CacheEnable&&$Cache->CacheNeed) {
    include $nsTemplate->Inc("constructor/cache_check");
    CacheCheck(array('CacheId'=>$Cache->CacheId,
                                      'CacheAjax'=>$Cache->CacheUpdateMode,
                                      'AdditionalHash'=>$Cache->AdditionalHash,
                                      'EnableChecking'=>$Cache->ToCache || (empty($Cache->Data) && !$Cache->TakenFromCache),
                                      'CustomReportId'=>$Cache->CustomId
                                      ));
}?>
    

<?if (!empty($StatArr)) {?>
<table width=100% cellpadding=0 cellspacing=0 border=0>
<tr><td width=20% valign=top>


<table width=100% cellpadding=0 cellspacing=0 border=0>
<tr><td class=BotTd style="border-bottom:2px solid #f0f0f0;border-right:2px solid #f0f0f0;">&nbsp;</td></tr>
<?foreach ($StatArr as $RobotId=>$Arr) {?>
    <tr><td class=BotTd style="border-right:2px solid #f0f0f0;" nowrap>
    <b><?=$RobotArr[$RobotId]?></b> 
    <span style="font-size:10px;">[<a title="<?=$Lang['ViewPaths']?>" href="<?=getURL('bot_path',"CpId=$CpId&SiteId=$SiteId&RobotId=$RobotId")?>">^</a>]</span>
    </td></tr>
<?}?>
<tr><td class=BotTd style="border-bottom:0px solid #f0f0f0;border-right:0px solid #f0f0f0;">&nbsp;</td></tr>
</table>

</td><td id="StatsTd" width=80% valign=top>
<div id="StatsDiv" style="width:100%;height:100%;padding:0px;overflow-x:scroll;display:none; background:#fff;">
<table width=100% cellpadding=0 cellspacing=0 border=0>
<tr><?foreach ($TemplArr as $Row) {
    echo "<td nowrap class=BotTd style=\"border-bottom:2px solid #f0f0f0;\"><b>";
    if ($GroupBy=='Year' || $GroupBy=='Time') echo $Row->NAME;
    if ($GroupBy=='Month') {
        echo $Lang['MonthName'][date('n',$Row->USTAMP)];
        echo ", ".date('Y',$Row->USTAMP);
    }
    if ($GroupBy=='Date') echo _date($Row->USTAMP);
    if ($GroupBy=='Week') echo $Lang['DayOfWeek'][date('w',$Row->USTAMP)];
    echo "</b></td>";
}?></tr>
<?$i=0;?>
<?foreach ($StatArr as $RobotId=>$Arr) {?>
    <tr><?foreach ($TemplArr as $Row) echo "<td class=BotTd>".(@$Arr[$Row->NAME]?"<b>{$Arr[$Row->NAME]->CNT}</b>":0)."</td>";?></tr>
<?}?>
</table>
</div>

</td></tr>
</table>
<?} else {?>
    
    <?include $nsTemplate->Inc('inc/no_records');?>
    
<?}?>



<?include $nsTemplate->Inc("inc/footer");?>