<?
# ============================================================================
#
#                        ___
#                    ,yQ$SSS$Q,      ,yQQQL
#                  j$$"`     `?$'  ,d$P"```$$,
#           i_L   I$;            `$`       `$$,
#                                 `          I$$
#           .yQ$$$$,            ;        _,d$$'
#        ,d$$P"^```?$b,       _,'  ;  ,d$$P"`
#     ,d$P"`        `"?$$Q#QP`    $d$$P"`
#   ,$$"         ;       ``       ;$?'
#   $$;        ,dI                I$;
#   `$$,    ,d$$$`               j$I
#     ?$S#S$P'j$'                $$;         Copyright (c) Stuffed Guys
#       `"`  j$'  __....,,,.__  j$I              www.stuffedguys.com
#           j$$"``           ',$$
#           I$;               ,$$'
#           `$$,         _.u$$`
#             "?$$Q##Q$$SP"^`
#                `````
#


/////////////////////////
//
/*
      

NO_PROD -   ,    

USER:NO_USER - this user does not exist
USER:WRONG_PWD - wrong password for specific user

TPL:TPL_ALREADY_SET - the template already set!

*/
//
/////////////////////////



class nsLogs
{

    function nsLogs()
    {
        $this->LastErr = "";
        $this->USE_LOG=true;
    }

    function DbErr($Query = false, $Comment = false, $Die = false)
    {
        if (!$this->USE_LOG) return false;
        global $User, $nsConsole;
        $Error = @mysql_error();
        $Text = "";
        if ($Error) $Text .= $Error." &mdash; ";
        if ($Comment) $Text .= $Comment." &mdash; ";
        if ($Query) $Text .= $Query;
        
        if ($nsConsole && defined('DEBUG')) {
            $Trace = $nsConsole->Backtrace();
            $Str = implode('<br>', $Trace);
            $Text .= '<br><br>'.$Str;
        }        
        $this->Err(nl2br($Text));
        if ($Die) die($Comment);
    }

    function ClearError()
    {
        $_SESSION['__Errors']=array();
    }

    function ClearMsg()
    {
        $_SESSION['__Messages']=array();
    }

    function ClearAlert()
    {
        $_SESSION['__Alerts']=array();
    }

    function Clear()
    {
        $this->ClearError();
        $this->ClearMsg();
        $this->ClearAlert();
    }

    function Msg($Comment = false)
    {   
        if (!$this->USE_LOG) return false;
        if (!$Comment) return false;
        $_SESSION['__Messages'][$Comment] = $Comment;
        return true;
    }

    function Err($Comment = false, $Die = false)
    {
        if (!$this->USE_LOG) return false;
        if (!$Comment) return false;
        $Comment = "(<span style=\"font-size:10px;\">".date("H:i:s").")</span> ".$Comment;
        $_SESSION['__Errors'][$Comment]= $Comment;
        if ($Die) die($Comment);
        return false;
    }

    function Alert($Comment=false)
    {
        if (!$this->USE_LOG) return false;
        if (!$Comment) return false;
        $_SESSION['__Alerts'][$Comment] = $Comment;
        return false;
    }

    function HaveMsg()
    {
        if (!empty($_SESSION['__Messages'])) return true;
        return false;
    }

    function HaveErr()
    {
        if (!empty($_SESSION['__Errors'])) return true;
        return false;
    }

    function HaveAlert()
    {
        if (!empty($_SESSION['__Alerts'])) return true;
        return false;
    }
	
    function LogFile($File=false, $Comment=false)
    {
        if (!$File||!$Comment) return false;
        if (!file_exists($File)) return false;
        $f=fopen($File,"a+");
        $Comment=date("Y-m-d H:i")." ".$Comment;
        fwrite($f,$Comment);
        fclose($f);
    }

	function Error($ErrID=false, $Skin=false)
	{
		global $nsErrorMessage, $Lang;	
		if (!$ErrID) return false;
		switch ($ErrID){
			case "NO_PROD": $nsErrorMessage =$Lang['UnableInit']; break;
			case "NO_ACTION": $nsErrorMessage =$Lang['NoSuchAction']; break;
			case "ACTION_RESTRICT": $nsErrorMessage =$Lang['PermissionDenied']; break;
			case "NO_PERMISSION": $nsErrorMessage =$Lang['PermissionDenied']; break;
		    case "TRIAL_UPDATE": $nsErrorMessage=$Lang['TrialUpdate']; break;
        
			case 'USER:NO_USER': $nsErrorMessage =$Lang['NoUser']; break;
			case 'USER:WRONG_PWD': $nsErrorMessage =$Lang['WrongPwd']; break;
			
			default: $nsErrorMessage =$Lang['UnknownError']; break;
		}	
		
        if (!$Skin) $Skin=SELF."/skins/default/_system_error.php";
        
        if (file_exists($Skin)&&!defined("COMMAND_LINE")) include $Skin;
        if (defined("COMMAND_LINE")&&$nsErrorMessage) {
            echo $Lang['CriticalError'].": ".$nsErrorMessage;
        }
        exit;
	}

}
?>